SystemOrganization addCategory: #'Prototype-Core'!
SystemOrganization addCategory: #'Prototype-Core-Ajax'!
SystemOrganization addCategory: #'Prototype-Core-Elements'!
SystemOrganization addCategory: #'Prototype-Core-Libraries'!
SystemOrganization addCategory: #'Prototype-Core-Observers'!

WAObject subclass: #PTFactory
	instanceVariableNames: 'context block rendererClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core'!

!PTFactory commentStamp: 'lr 4/28/2008 09:46' prior: 0!
I am a factory to create Scriptaculous objects.!

!PTFactory class methodsFor: 'instance creation' stamp: 'jf 7/19/2009 15:27'!
context: aRenderContext
	^ self context: aRenderContext using: nil! !

!PTFactory class methodsFor: 'instance creation' stamp: 'jf 7/19/2009 15:26'!
context: aRenderContext using: aBlock
	^ self basicNew initializeWithContext: aRenderContext using: aBlock; yourself! !

!PTFactory methodsFor: 'private' stamp: 'jf 7/19/2009 17:28'!
create: aClass
	^ self register:
		((aClass context: context)
			rendererClass: self rendererClass;
			yourself)! !

!PTFactory methodsFor: 'creational' stamp: 'lr 6/29/2009 15:08'!
document
	^ (self create: PTObject) alias: 'document'! !

!PTFactory methodsFor: 'creational-elements' stamp: 'lr 6/29/2009 15:10'!
element
	^ self create: PTElement! !

!PTFactory methodsFor: 'creational-ajax' stamp: 'lr 6/29/2009 15:13'!
evaluator
	^ self create: PTEvaluator! !

!PTFactory methodsFor: 'creational' stamp: 'lr 6/29/2009 15:12'!
event
	^ self create: PTEvent! !

!PTFactory methodsFor: 'creational-elements' stamp: 'lr 6/29/2009 15:11'!
form
	^ self create: PTForm! !

!PTFactory methodsFor: 'creational-elements' stamp: 'lr 6/29/2009 15:11'!
formElement
	^ self create: PTFormElement! !

!PTFactory methodsFor: 'creational-observers' stamp: 'lr 6/29/2009 15:14'!
formElementObserver
	^ self create: PTFormElementObserver! !

!PTFactory methodsFor: 'creational-observers' stamp: 'lr 6/29/2009 15:15'!
formObserver
	^ self create: PTFormObserver! !

!PTFactory methodsFor: 'creational' stamp: 'lr 10/14/2008 00:40'!
function
	^ self create: JSFunction! !

!PTFactory methodsFor: 'initialization' stamp: 'jf 7/19/2009 15:25'!
initializeWithContext: aRenderContext using: aBlock
	self initialize.
	context := aRenderContext.
	block := aBlock! !

!PTFactory methodsFor: 'creational-ajax' stamp: 'lr 6/29/2009 15:14'!
insertion
	^ self create: PTInsertion! !

!PTFactory methodsFor: 'creational' stamp: 'lr 10/14/2008 00:40'!
logger
	^ self create: JSLogger! !

!PTFactory methodsFor: 'creational-ajax' stamp: 'lr 6/29/2009 15:13'!
periodical
	^ self create: PTPeriodical! !

!PTFactory methodsFor: 'creational-ajax' stamp: 'lr 6/29/2009 15:13'!
periodicalEvaluator
	^ self create: PTPeriodicalEvaluator ! !

!PTFactory methodsFor: 'private' stamp: 'lr 6/18/2007 06:50'!
register: anObject
	^ block isNil
		ifTrue: [ anObject ]
		ifFalse: [ block value: anObject ]! !

!PTFactory methodsFor: 'accessing' stamp: 'jf 7/19/2009 18:23'!
rendererClass
	^ rendererClass ifNil: [ rendererClass := WARenderer default ]! !

!PTFactory methodsFor: 'accessing' stamp: 'jf 7/19/2009 17:47'!
rendererClass: anObject
	rendererClass := anObject! !

!PTFactory methodsFor: 'creational-ajax' stamp: 'lr 6/29/2009 15:13'!
request
	^ self create: PTRequest! !

!PTFactory methodsFor: 'creational-ajax' stamp: 'lr 6/29/2009 15:14'!
responders
	^ self create: PTResponders! !

!PTFactory methodsFor: 'creational' stamp: 'lr 10/14/2008 00:40'!
script
	^ self create: JSScript! !

!PTFactory methodsFor: 'creational-elements' stamp: 'lr 6/29/2009 15:12'!
selector
	^ self create: PTSelector! !

!PTFactory methodsFor: 'creational' stamp: 'lr 10/14/2008 00:40'!
stream
	^ self register: JSStream new! !

!PTFactory methodsFor: 'creational-ajax' stamp: 'lr 6/29/2009 15:13'!
updater
	^ self create: PTUpdater! !

!PTFactory methodsFor: 'creational' stamp: 'lr 6/29/2009 15:07'!
window
	^ (self create: PTObject) alias: 'window'! !

JSObject subclass: #PTObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core'!

PTObject subclass: #PTElement
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Elements'!

!PTElement commentStamp: 'lr 2/27/2007 20:57' prior: 0!
The Element object sports a flurry of powerful DOM methods which you can access either as methods of Element (but that's rather old-fashioned now) or directly as methods of an extended element (thanks to Element.extend for that added bit of syntactic sugar).!

!PTElement methodsFor: 'geometric' stamp: 'lr 12/2/2007 18:12'!
absolutize
	"Turns element into an absolutely-positioned element without changing its position in the page layout."
	
	self call: 'absolutize'! !

!PTElement methodsFor: 'styling-classes' stamp: 'lr 6/29/2009 21:19'!
addClassName: aString 
	"Adds a CSS class to element."
	
	self call: 'addClassName' with: aString! !

!PTElement methodsFor: 'enumerating' stamp: 'lr 6/29/2009 21:21'!
adjacent
	"Finds all siblings of the current element."

	^ self call: 'adjacent'; enumerator! !

!PTElement methodsFor: 'enumerating' stamp: 'lr 6/29/2009 21:21'!
adjacent: aString
	"Finds all siblings of the current element that match the given selector(s)."

	^ self call: 'adjacent' with: aString; enumerator! !

!PTElement methodsFor: 'enumerating' stamp: 'lr 10/28/2007 14:40'!
ancestors
	"Collects all of element's ancestors and returns them as an array of extended elements."

	^ self call: 'ancestors'; enumerator! !

!PTElement methodsFor: 'elements' stamp: 'lr 10/14/2008 00:40'!
body
	self id: (JSStream on: 'document.body')! !

!PTElement methodsFor: 'enumerating' stamp: 'lr 10/28/2007 14:40'!
childElements
	"Collects all of the element's immediate descendants (i.e. children) and returns them as an array of extended elements."

	^ self call: 'childElements'; enumerator! !

!PTElement methodsFor: 'displaying' stamp: 'lr 6/11/2007 07:21'!
cleanWhitespace
	"Removes all of element's text nodes which contain only whitespace."

	self call: 'cleanWhitespace'! !

!PTElement methodsFor: 'geometric' stamp: 'lr 6/29/2009 21:22'!
clonePosition: anElement 
	"Clones the position and/or dimensions of source onto element as defined by the optional argument options."

	self call: 'clonePosition' with: anElement! !

!PTElement methodsFor: 'geometric' stamp: 'lr 12/2/2007 18:15'!
cumulativeOffset
	"Returns the offsets of element from the top left corner of the document."

	self call: 'cumulativeOffset'! !

!PTElement methodsFor: 'geometric' stamp: 'lr 12/2/2007 18:16'!
cumulativeScrollOffset
	"Calculates the cumulative scroll offset of an element in nested scrolling containers."

	self call: 'cumulativeScrollOffset'! !

!PTElement methodsFor: 'querying' stamp: 'lr 6/29/2009 21:23'!
descendantOf: anElement 
	"Checks if element is a descendant of ancestor."
	
	self call: 'descendantOf' with: anElement! !

!PTElement methodsFor: 'enumerating' stamp: 'lr 10/28/2007 14:40'!
descendants
	"Collects all of element's descendants and returns them as an array of extended elements."

	^ self call: 'descendants'; enumerator! !

!PTElement methodsFor: 'geometric' stamp: 'lr 10/28/2007 14:40'!
dimensions
	"Finds the computed width and height of element and returns them as key/value pairs of an object."

	self call: 'getDimensions'! !

!PTElement methodsFor: 'elements' stamp: 'lr 10/14/2008 00:40'!
document
	self id: (JSStream on: 'document')! !

!PTElement methodsFor: 'navigation' stamp: 'lr 11/1/2007 16:56'!
down
	self down: nil at: nil! !

!PTElement methodsFor: 'navigation' stamp: 'lr 11/1/2007 16:56'!
down: aString
	self down: aString at: nil! !

!PTElement methodsFor: 'navigation' stamp: 'lr 6/29/2009 21:25'!
down: aString at: anInteger 
	"Returns element's first descendant (or the index anInteger-th one, if anInteger is specified) that matches the css rule aString. If no aString is provided, all descendants are considered. If no descendant matches these criteria, undefined is returned."
	
	self call: 'down' withArguments: (self rule: aString at: anInteger)! !

!PTElement methodsFor: 'deprecated' stamp: 'lr 6/30/2009 07:51'!
elementsByClassName: aString 
	"Fetches all of element's descendants which have a CSS class of className and returns them as an array of extended elements."

	self 
		seasideDeprecatedApi: 'PTElement>>#elementsByClassName:'
		details: 'As of Prototype 1.6, #elementsByClassName: has been deprecated in favor of the more concise #select:.'.
	^ self
		call: 'getElementsByClassName' with: aString;
		enumerator! !

!PTElement methodsFor: 'deprecated' stamp: 'lr 6/30/2009 07:51'!
elementsBySelector: aString 
	"Takes an arbitrary number of CSS selectors (strings) and returns a document-order array of extended children of element that match any of them."
	
	self 
		seasideDeprecatedApi: 'PTElement>>#elementsBySelector:'
		details: 'As of Prototype 1.6, #elementsBySelector: has been deprecated in favor of the more concise #select:.'.
	^ self call: 'getElementsBySelector' with: aString; enumerator! !

!PTElement methodsFor: 'querying' stamp: 'lr 10/28/2007 14:40'!
empty
	"Tests whether element is empty (i.e. contains only whitespace)."

	self call: 'empty'! !

!PTElement methodsFor: 'events' stamp: 'lr 6/29/2009 21:26'!
fire: aString 
	"Fires a custom event with the current element as its target."
	
	self call: 'fire' with: aString! !

!PTElement methodsFor: 'events' stamp: 'lr 6/29/2009 21:27'!
fire: aString with: anObject 
	"Fires a custom event with the current element as its target."
	
	self call: 'fire' with: aString with: anObject! !

!PTElement methodsFor: 'querying' stamp: 'lr 10/28/2007 14:40'!
firstDescendant
	"Returns the first child that is an element. This is opposed to firstChild DOM property which will return any node (whitespace in most usual cases)."

	self call: 'firstDescendant'! !

!PTElement methodsFor: 'styling-classes' stamp: 'lr 6/29/2009 21:28'!
hasClassName: aString 
	"Checks whether element has the given CSS className."
	
	self call: 'hasClassName' with: aString! !

!PTElement methodsFor: 'elements' stamp: 'lr 10/14/2008 00:40'!
head
	self id: (JSStream on: 'document.head')! !

!PTElement methodsFor: 'geometric' stamp: 'lr 10/28/2007 14:40'!
height
	"Finds and returns the computed height of element."

	self call: 'getHeight'! !

!PTElement methodsFor: 'displaying' stamp: 'lr 6/11/2007 07:20'!
hide
	"Hides and returns element."

	self call: 'hide'! !

!PTElement methodsFor: 'accessing' stamp: 'lr 10/14/2008 00:40'!
id
	^ id ifNil: [ JSStream on: 'this' ]! !

!PTElement methodsFor: 'accessing' stamp: 'lr 6/11/2007 07:02'!
id: aString
	id := aString! !

!PTElement methodsFor: 'querying' stamp: 'lr 12/2/2007 18:29'!
identify
	"Returns element's id attribute if it exists, or sets and returns a unique, auto-generated id."

	self call: 'identify'! !

!PTElement methodsFor: 'deprecated' stamp: 'lr 6/30/2009 07:51'!
immediateDescendants
	"Collects all of the element's immediate descendants (i.e. children) and returns them as an array of extended elements."

	self
		seasideDeprecatedApi: 'PTElement>>#immediateDescendants'
		details: 'As of Prototype 1.6, #immediateDescendants has been deprecated in favor of the more concise #childElements.'.
	^ self call: 'immediateDescendants'; enumerator! !

!PTElement methodsFor: 'modifying' stamp: 'lr 6/29/2009 21:27'!
insert: anObject 
	"Inserts content before, after, at the top of, or at the bottom of element, as specified by the position property of the argument. If the argument is the content itself, insert will append it to element."
	
	self call: 'insert' with: (self render: anObject)! !

!PTElement methodsFor: 'modifying' stamp: 'lr 6/29/2009 21:27'!
insert: anObject position: aString 
	"Inserts anObject before, after, at the top of, or at the bottom of element."
	
	self call: 'insert' with: (Dictionary new 
		at: aString put: (self render: anObject); 
		yourself)! !

!PTElement methodsFor: 'modifying' stamp: 'lr 12/2/2007 18:10'!
insertAfter: anObject
	self insert: anObject position: 'after'! !

!PTElement methodsFor: 'modifying' stamp: 'lr 12/2/2007 18:10'!
insertBefore: anObject
	self insert: anObject position: 'before'! !

!PTElement methodsFor: 'modifying' stamp: 'lr 12/2/2007 18:10'!
insertBottom: anObject
	self insert: anObject position: 'bottom'! !

!PTElement methodsFor: 'modifying' stamp: 'lr 12/2/2007 18:10'!
insertTop: anObject
	self insert: anObject position: 'top'! !

!PTElement methodsFor: 'geometric' stamp: 'lr 6/11/2007 07:21'!
makeClipping
	"Simulates the poorly supported CSS clip property by setting element's overflow value to 'hidden'. Returns element."

	self call: 'makeClipping'! !

!PTElement methodsFor: 'geometric' stamp: 'lr 6/11/2007 07:21'!
makePositioned
	"Allows for the easy creation of CSS containing block by setting element's CSS position to 'relative' if its initial position is either 'static' or undefined. Returns element."

	self call: 'makePositioned'! !

!PTElement methodsFor: 'querying' stamp: 'lr 6/29/2009 21:24'!
match: aString 
	"Checks if element matches the given CSS selector."
	
	self call: 'match' with: aString! !

!PTElement methodsFor: 'navigation' stamp: 'lr 11/1/2007 16:53'!
next
	self next: nil at: nil! !

!PTElement methodsFor: 'navigation' stamp: 'lr 11/1/2007 16:53'!
next: aString
	self next: aString at: nil! !

!PTElement methodsFor: 'navigation' stamp: 'lr 6/29/2009 21:24'!
next: aString at: anInteger 
	"Returns element's following sibling (or the index anInteger-th one, if anInteger is specified) that matches the css rule aString. If no aString is provided, all following siblings are considered. If no following sibling matches these criteria, undefined is returned."
	
	self call: 'next' withArguments: (self rule: aString at: anInteger)! !

!PTElement methodsFor: 'enumerating' stamp: 'lr 10/28/2007 14:40'!
nextSiblings
	"Collects all of element's next siblings and returns them as an array of extended elements."

	^ self call: 'nextSiblings'; enumerator! !

!PTElement methodsFor: 'geometric' stamp: 'lr 12/2/2007 19:22'!
offsetParent
	"Returns element's closest positioned ancestor. If none is found, the body element is returned."

	self call: 'getOffsetParent'! !

!PTElement methodsFor: 'events' stamp: 'lr 6/29/2009 21:27'!
on: aString do: aHandlerObject 
	"Register the handler aBlock for the event aString on the receiving DOM element. Please refer to SUEvent>>#observe:on:do: for further information."
	
	self call: 'observe' with: aString with: (aHandlerObject asFunction: #('event'))! !

!PTElement methodsFor: 'displaying' stamp: 'lr 6/29/2009 21:29'!
opacity: aFloat
	"Sets the visual opacity of an element while working around inconsistencies in various browsers. The opacity argument should be a floating point number, where the value of 0 is fully transparent and 1 is fully opaque."
	
	self call: 'setOpacity' with: aFloat! !

!PTElement methodsFor: 'geometric' stamp: 'lr 12/2/2007 18:34'!
positionedOffset
	"Returns element's offset relative to its closest positioned ancestor (the element that would be returned by #offsetParent)."

	self call: 'positionedOffset'! !

!PTElement methodsFor: 'navigation' stamp: 'lr 11/1/2007 16:54'!
previous
	self previous: nil at: nil! !

!PTElement methodsFor: 'navigation' stamp: 'lr 11/1/2007 16:54'!
previous: aString
	self previous: aString at: nil! !

!PTElement methodsFor: 'navigation' stamp: 'lr 6/29/2009 21:24'!
previous: aString at: anInteger 
	"Returns element's previous sibling (or the index anInteger-th one, if anInteger is specified) that matches the css rule aString. If no aString is provided, all previous siblings are considered. If no previous sibling matches these criteria, undefined is returned."
	
	self call: 'previous' withArguments: (self rule: aString at: anInteger)! !

!PTElement methodsFor: 'enumerating' stamp: 'lr 10/28/2007 14:40'!
previousSiblings
	"Collects all of element's previous siblings and returns them as an array of extended elements."

	^ self call: 'previousSiblings'; enumerator! !

!PTElement methodsFor: 'printing' stamp: 'lr 2/12/2009 09:51'!
printContentOn: aStream
	aStream nextPut: $$.
	JSStream encodeArguments: (Array with: self id) on: aStream! !

!PTElement methodsFor: 'attributes' stamp: 'lr 3/30/2009 20:06'!
readAttribute: aString 
	"Answer the value of element's attribute or null if attribute has not been specified."
	
	self call: 'readAttribute' with: aString! !

!PTElement methodsFor: 'enumerating' stamp: 'lr 6/29/2009 21:26'!
recursivelyCollect: aString 
	"Recursively collects elements whose relationship is specified by aString. aString has to be a property of element that points to a single DOM node. Returns an array of extended elements."
	
	^ self call: 'recursivelyCollect' with: aString; enumerator! !

!PTElement methodsFor: 'geometric' stamp: 'lr 12/2/2007 18:42'!
relativize
	"Turns element into an relatively-positioned element without changing its position in the page layout."
	
	self call: 'relativize'! !

!PTElement methodsFor: 'modifying' stamp: 'lr 6/11/2007 07:21'!
remove
	"Completely removes element from the document and returns it."

	self call: 'remove'! !

!PTElement methodsFor: 'attributes' stamp: 'lr 3/19/2008 19:19'!
removeAttribute: aString
	"Remove attribute aString."
	
	self writeAttribute: aString value: nil! !

!PTElement methodsFor: 'styling-classes' stamp: 'lr 6/29/2009 21:28'!
removeClassName: aString 
	"Removes element's CSS className and returns element."
	
	self call: 'removeClassName' with: aString! !

!PTElement methodsFor: 'modifying' stamp: 'lr 6/29/2009 21:28'!
replace: anObject 
	"Replaces element by the content of the html argument and returns the removed element."
	
	self call: 'replace' with: (self render: anObject)! !

!PTElement methodsFor: 'private' stamp: 'lr 11/1/2007 16:52'!
rule: aString at: anInteger
	^ Array streamContents: [ :stream |
		(aString isNil or: [ aString isEmpty ])
			ifFalse: [ stream nextPut: aString ].
		(anInteger isNil or: [ anInteger isZero ])
			ifFalse: [ stream nextPut: anInteger ] ]! !

!PTElement methodsFor: 'displaying' stamp: 'lr 6/11/2007 07:20'!
scroll
	"Scrolls the window so that element appears at the top of the viewport."

	self call: 'scrollTo'! !

!PTElement methodsFor: 'enumerating' stamp: 'lr 6/29/2009 21:26'!
select: aString 
	"Takes a CSS selector and returns an enumerable of extended descendants of element that match aString."
	
	^ self call: 'select' with: aString; enumerator! !

!PTElement methodsFor: 'displaying' stamp: 'lr 6/11/2007 07:20'!
show
	"Displays and returns element."

	self call: 'show'! !

!PTElement methodsFor: 'enumerating' stamp: 'lr 10/28/2007 14:40'!
siblings
	"Collects all of element's siblings and returns them as an array of extended elements."

	^ self call: 'siblings'; enumerator! !

!PTElement methodsFor: 'styling-styles' stamp: 'lr 6/29/2009 21:28'!
style: aDictionary 
	"Modifies element's CSS style properties. Styles are passed as a hash of property-value pairs in which the properties are specified in their camelized form."
	
	self call: 'setStyle' with: aDictionary! !

!PTElement methodsFor: 'styling-styles' stamp: 'lr 6/29/2009 21:28'!
styleAt: aString 
	"Returns the given CSS property value of element. property can be specified in either of its CSS or camelized form."
	
	self call: 'getStyle' with: aString! !

!PTElement methodsFor: 'styling-styles' stamp: 'lr 2/27/2007 21:06'!
styleAt: aPropertyString put: anObject
	"Modifies element's CSS style properties. Styles are passed as a hash of property-value pairs in which the properties are specified in their camelized form."

	self style: (Dictionary new
		at: aPropertyString put: anObject;
		yourself)! !

!PTElement methodsFor: 'displaying' stamp: 'lr 6/11/2007 07:20'!
toggle
	"Toggles the visibility of element."

	self call: 'toggle'! !

!PTElement methodsFor: 'styling-classes' stamp: 'lr 6/29/2009 21:28'!
toggleClassName: aString 
	"Toggles element's CSS className and returns element."
	
	self call: 'toggleClassName' with: aString! !

!PTElement methodsFor: 'geometric' stamp: 'lr 6/11/2007 07:22'!
undoClipping
	"Sets element's CSS overflow property back to the value it had before Element.makeClipping() was applied. Returns element."

	self call: 'undoClipping'! !

!PTElement methodsFor: 'geometric' stamp: 'lr 6/11/2007 07:22'!
undoPositioned
	"Sets element back to the state it was before Element.makePositioned was applied to it. Returns element."

	self call: 'undoPositioned'! !

!PTElement methodsFor: 'navigation' stamp: 'lr 11/1/2007 16:58'!
up
	self up: nil at: nil! !

!PTElement methodsFor: 'navigation' stamp: 'lr 11/1/2007 16:58'!
up: aString
	self up: aString at: nil! !

!PTElement methodsFor: 'navigation' stamp: 'lr 6/29/2009 21:25'!
up: aString at: anInteger 
	"Returns element's first ancestor (or the index anInteger-th one, if anInteger is specified) that matches the css rule aString. If no aString is provided, all ancestors are considered. If no ancestor matches these criteria, undefined is returned."

	self call: 'up' withArguments: (self rule: aString at: anInteger)! !

!PTElement methodsFor: 'modifying' stamp: 'lr 6/29/2009 21:28'!
update: anObject 
	"Replaces the content of element with the provided newContent argument and returns element."
	
	self call: 'update' with: (self render: anObject)! !

!PTElement methodsFor: 'geometric' stamp: 'lr 12/2/2007 18:44'!
viewportOffset
	"Returns the X/Y coordinates of element relative to the viewport."

	self call: 'viewportOffset'! !

!PTElement methodsFor: 'displaying' stamp: 'lr 10/28/2007 14:40'!
visible
	"Returns a Boolean indicating whether or not element is visible (i.e. whether its inline style property is set to display: none;)"

	self call: 'visible'! !

!PTElement methodsFor: 'geometric' stamp: 'lr 10/28/2007 14:40'!
width
	"Finds and returns the computed width of element."

	self call: 'getWidth'! !

!PTElement methodsFor: 'modifying' stamp: 'lr 12/2/2007 19:26'!
wrap: aString
	"Wraps an element inside another, then returns the wrapper."

	self wrap: aString attributes: Dictionary new! !

!PTElement methodsFor: 'modifying' stamp: 'lr 6/29/2009 21:28'!
wrap: aString attributes: aDictionary 
	"Wraps an element inside another, then returns the wrapper."
	
	self call: 'wrap' with: aString with: aDictionary! !

!PTElement methodsFor: 'attributes' stamp: 'lr 3/30/2009 20:06'!
writeAttribute: aString value: anObject 
	"Add or replace attribute aString with anObject."
	
	self call: 'writeAttribute' with: aString with: anObject! !

PTElement subclass: #PTForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Elements'!

!PTForm commentStamp: 'lr 2/27/2007 21:14' prior: 0!
Form is a namespace and a module for all things form-related, packed with form manipulation and serialization goodness. While it holds methods dealing with forms as whole, its submodule Form.Element deals with specific form controls.!

!PTForm methodsFor: 'actions' stamp: 'lr 6/11/2007 07:59'!
disable
	"Disables the form as whole. Form controls will be visible but uneditable."

	self call: 'disable'! !

!PTForm methodsFor: 'enumerating' stamp: 'lr 9/12/2007 07:31'!
elements
	"Returns a collection of all form controls within a form."

	^ self call: 'getElements'; enumerator! !

!PTForm methodsFor: 'actions' stamp: 'lr 6/11/2007 08:00'!
enable
	"Enables a fully or partially disabled form."

	self call: 'enable'! !

!PTForm methodsFor: 'querying' stamp: 'lr 6/11/2007 08:00'!
findFirstElement
	"Finds first non-hidden, non-disabled form control."

	self call: 'findFirstElement'! !

!PTForm methodsFor: 'actions' stamp: 'lr 6/11/2007 08:00'!
focusFirstElement
	"Gives keyboard focus to the first element of the form."

	self call: 'focusFirstElement'! !

!PTForm methodsFor: 'enumerating' stamp: 'lr 9/12/2007 07:31'!
inputs
	"Returns a collection of all INPUT elements in a form. Use optional type and name arguments to restrict the search on these attributes."

	^ self call: 'getInputs'; enumerator! !

!PTForm methodsFor: 'actions' stamp: 'lr 6/11/2007 08:00'!
request
	"A convenience method for serializing and submitting the form via an SURequest to the URL of the form's action attribute."

	self call: 'request'! !

!PTForm methodsFor: 'actions' stamp: 'lr 6/11/2007 07:59'!
reset
	"Resets a form to its default values."

	self call: 'reset'! !

!PTForm methodsFor: 'querying' stamp: 'lr 6/11/2007 08:00'!
serialize
	"Serialize form data to a string suitable for Ajax requests (default behavior) or, if optional getHash evaluates to true, an object hash where keys are form control names and values are data."

	self call: 'serialize'! !

!PTForm methodsFor: 'actions' stamp: 'lr 6/12/2007 16:55'!
submit
	self call: 'submit'! !

PTElement subclass: #PTFormElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Elements'!

!PTFormElement commentStamp: 'lr 2/27/2007 21:16' prior: 0!
This is a collection of methods that assist in dealing with form controls. They provide ways to focus, serialize, disable/enable or extract current value from a specific control.!

!PTFormElement methodsFor: 'actions' stamp: 'lr 10/28/2007 14:40'!
activate
	"Gives focus to a form control and selects its contents if it is a text input."

	self call: 'activate'! !

!PTFormElement methodsFor: 'actions' stamp: 'lr 10/28/2007 14:40'!
clear
	"Clears the contents of a text input."

	self call: 'clear'! !

!PTFormElement methodsFor: 'actions' stamp: 'lr 10/28/2007 14:40'!
disable
	"Disables a form control, effectively preventing its value to be changed until it is enabled again."

	self call: 'disable'! !

!PTFormElement methodsFor: 'actions' stamp: 'lr 10/28/2007 14:40'!
enable
	"Enables a previously disabled form control."

	self call: 'enable'! !

!PTFormElement methodsFor: 'actions' stamp: 'lr 10/28/2007 14:40'!
focus
	"Gives keyboard focus to an element."

	self call: 'focus'! !

!PTFormElement methodsFor: 'querying' stamp: 'lr 10/28/2007 14:40'!
present
	"Returns true if a text input has contents, false otherwise."

	self call: 'present'! !

!PTFormElement methodsFor: 'actions' stamp: 'lr 10/28/2007 14:40'!
select
	"Selects the current text in a text input."

	self call: 'select'! !

!PTFormElement methodsFor: 'querying' stamp: 'lr 10/28/2007 14:40'!
serialize
	"Creates an URL-encoded string representation of a form control in the name=value format."

	self call: 'serialize'! !

!PTFormElement methodsFor: 'querying' stamp: 'lr 10/28/2007 14:40'!
value
	"Returns the current value of a form control. A string is returned for most controls; only multiple select boxes return an array of values. The global shortcut for this method is $F()."

	self call: 'getValue'! !

PTObject subclass: #PTEnumerable
	instanceVariableNames: 'receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core'!

!PTEnumerable commentStamp: 'lr 6/16/2007 18:28' prior: 0!
Enumerable provides a large set of useful methods for enumerations, that is, objects that act as collections of values. It is a cornerstone of Prototype.!

!PTEnumerable class methodsFor: 'instance creation' stamp: 'jf 7/19/2009 15:21'!
context: aRenderContext receiver: anObject
	^ (self context: aRenderContext) receiver: anObject! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 10/14/2008 09:10'!
all: anObject 
	"Determines whether all the elements are boolean-equivalent to true, either directly or through computation by the provided iterator."
	self 
		call: 'all'
		with: (self iteratorFor: anObject)! !

!PTEnumerable methodsFor: 'enumerating' stamp: 'lr 6/16/2007 18:46'!
allSatisfy: anObject
	^ self all: anObject! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 10/14/2008 09:10'!
any: anObject 
	"Determines whether at least one element is boolean-equivalent to true, either directly or through computation by the provided iterator."
	self 
		call: 'any'
		with: (self iteratorFor: anObject)! !

!PTEnumerable methodsFor: 'enumerating' stamp: 'lr 6/16/2007 18:46'!
anySatisfy: anObject
	^ self any: anObject! !

!PTEnumerable methodsFor: 'enumerating' stamp: 'lr 6/16/2007 18:42'!
collect: anObject
	^ self map: anObject! !

!PTEnumerable methodsFor: 'enumerating' stamp: 'lr 6/16/2007 18:42'!
detect: anObject
	^ self find: anObject! !

!PTEnumerable methodsFor: 'enumerating' stamp: 'lr 6/16/2007 18:43'!
detectMax: anObject
	^ self max: anObject! !

!PTEnumerable methodsFor: 'enumerating' stamp: 'lr 6/16/2007 18:43'!
detectMin: anObject
	^ self min: anObject! !

!PTEnumerable methodsFor: 'enumerating' stamp: 'lr 6/16/2007 18:42'!
do: anObject
	^ self each: anObject! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 10/14/2008 09:10'!
each: anObject 
	"The cornerstone of Enumerable. It lets you iterate over all the elements in a generic fashion, then returns the Enumerable, thereby allowing chain-calling."
	self 
		call: 'each'
		with: (self 
				iteratorFor: anObject
				return: false)! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 10/14/2008 09:10'!
find: anObject 
	"Finds the first element for which the iterator returns true."
	self 
		call: 'find'
		with: (self iteratorFor: anObject)! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 10/14/2008 09:10'!
findAll: anObject 
	"Returns all the elements for which the iterator returned true."
	self 
		call: 'findAll'
		with: (self iteratorFor: anObject)! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 10/14/2008 09:10'!
grep: aString 
	"Returns all the elements whose string representations match the regular expression."
	self 
		call: 'grep'
		with: aString! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 10/14/2008 09:10'!
include: anObject 
	"Determines whether a given object is in the Enumerable or not, based on the == comparison operator."
	self 
		call: 'include'
		with: anObject! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 6/18/2007 06:16'!
invoke: aString
	self invoke: aString withAll: #()! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 10/28/2007 14:40'!
invoke: aString with: anObject
	self invoke: aString withAll: (Array with: anObject)! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 10/14/2008 09:10'!
invoke: aString withAll: anArray 
	self 
		call: 'invoke'
		withArguments: (Array with: aString) , anArray! !

!PTEnumerable methodsFor: 'private' stamp: 'lr 6/18/2007 09:04'!
iteratorFor: anObject
	^ self iteratorFor: anObject return: true! !

!PTEnumerable methodsFor: 'private' stamp: 'jf 7/19/2009 17:37'!
iteratorFor: anObject return: aBoolean
	^ anObject isBlock
		ifFalse: [ anObject asFunction ]
		ifTrue: [ (JSFunction context: self renderContext iterator: anObject)
					rendererClass: self rendererClass;
					return: aBoolean ]! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 10/14/2008 09:10'!
map: anObject 
	"Returns the results of applying the iterator to each element."
	self 
		call: 'map'
		with: (self iteratorFor: anObject)! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 10/14/2008 09:10'!
max: anObject 
	"Returns the maximum element (or element-based computation), or undefined if the enumeration is empty. Elements are either compared directly, or by first applying the iterator and comparing returned values."
	self 
		call: 'max'
		with: (self iteratorFor: anObject)! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 10/14/2008 09:10'!
min: anObject 
	"Returns the minimum element (or element-based computation), or undefined if the enumeration is empty. Elements are either compared directly, or by first applying the iterator and comparing returned values."
	self 
		call: 'min'
		with: (self iteratorFor: anObject)! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 10/14/2008 09:10'!
pluck: aString 
	"Optimization for a common use-case of collect: fetching the same property for all the elements. Returns the property values."
	self 
		call: 'pluck'
		with: aString! !

!PTEnumerable methodsFor: 'printing' stamp: 'lr 6/16/2007 18:30'!
printContentOn: aStream
	self receiver printOn: aStream! !

!PTEnumerable methodsFor: 'accessing' stamp: 'lr 6/18/2007 06:23'!
receiver
	^ receiver! !

!PTEnumerable methodsFor: 'accessing' stamp: 'lr 6/18/2007 06:26'!
receiver: anObject
	receiver := anObject! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 10/14/2008 09:10'!
reject: anObject 
	"Returns all the elements for which the iterator returned false."
	self 
		call: 'reject'
		with: (self iteratorFor: anObject)! !

!PTEnumerable methodsFor: 'enumerating' stamp: 'lr 6/16/2007 18:42'!
select: anObject
	^ self findAll: anObject! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 10/28/2007 14:40'!
size
	"Return the size of the enumeration."

	self call: 'size'! !

!PTEnumerable methodsFor: 'querying' stamp: 'lr 10/14/2008 09:10'!
sortBy: anObject 
	"Provides a custom-sorted view of the elements based on the criteria computed, for each element, by the iterator."
	self 
		call: 'sortBy'
		with: (self iteratorFor: anObject)! !

PTEnumerable subclass: #PTSelector
	instanceVariableNames: 'selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Elements'!

!PTSelector commentStamp: 'lr 4/25/2007 10:20' prior: 0!
Takes an arbitrary number of CSS selectors (strings) and returns a document-order array of extended DOM elements that match any of them.!

!PTSelector methodsFor: 'adding' stamp: 'lr 10/28/2007 14:40'!
add: aString
	"Add the selector aString to the receiver."

	selectors add: aString! !

!PTSelector methodsFor: 'initialization' stamp: 'lr 5/15/2006 13:48'!
initialize
	super initialize.
	selectors := OrderedCollection new! !

!PTSelector methodsFor: 'printing' stamp: 'lr 2/12/2009 09:52'!
printContentOn: aStream
	aStream nextPutAll: '$$'.
	JSStream encodeArguments: self selectors on: aStream! !

!PTSelector methodsFor: 'accessing' stamp: 'lr 5/15/2006 13:49'!
selectors
	^ selectors! !

!PTSelector methodsFor: 'accessing' stamp: 'lr 5/15/2006 13:49'!
selectors: aCollection
	selectors := aCollection! !

!PTObject methodsFor: 'querying' stamp: 'jf 7/19/2009 17:29'!
enumerator
	"Answer an enumerator on the receiver."

	^ (PTEnumerable context: self renderContext receiver: self)
		rendererClass: self rendererClass;
		yourself! !

!PTObject methodsFor: 'accessing' stamp: 'jf 7/19/2009 17:27'!
factory
	"Answer a factory object for Prototype objects."

	^ (PTFactory context: self renderContext)
		rendererClass: self rendererClass;
		yourself! !

!PTObject methodsFor: 'querying' stamp: 'lr 10/28/2007 14:40'!
toJson
	"Return a JSON string."

	self call: 'toJSON'! !

PTObject subclass: #PTPrototype
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core'!

PTPrototype subclass: #PTAjax
	instanceVariableNames: 'url callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Ajax'!

!PTAjax methodsFor: 'parameters' stamp: 'lr 10/28/2007 14:40'!
addParameter: anObject
	"Add the request parameter anObject, a single value or an association."

	self parameters add: anObject! !

!PTAjax methodsFor: 'parameters' stamp: 'lr 10/28/2007 14:40'!
addParameters: aCollection
	"Add multiple request parameters from aCollection."

	self parameters addAll: aCollection associations! !

!PTAjax methodsFor: 'options' stamp: 'lr 10/28/2007 14:40'!
asynchronous: aBoolean
	"Determines whether XMLHttpRequest is used asynchronously or not. Since synchronous usage is rather unsettling, and usually bad taste, you should avoid changing this. Seriously."

	self optionAt: 'asynchronous' put: aBoolean! !

!PTAjax methodsFor: 'callbacks' stamp: 'lr 10/14/2008 00:51'!
callback: aBlock
	"Register aBlock as a primary callback of the receiver. It only makes sense to have a single primary callback registered per instance. Depending on the actual instance, aBlock is evaluated differently. See #processOn: for details.
	
	- SURequest: aBlock does not expect any arguments.
	- SUEvaluator: aBlock expects one argument, which will be an instance of JSScript.
	- SUUpdater: aBlock expects one argument, which will be a renderer."
	
	callback := aBlock fixCallbackTemps! !

!PTAjax methodsFor: 'callbacks' stamp: 'jf 7/19/2009 16:40'!
callback: aBlock value: anObject
	"Register aBlock as a secondary callback. anObject is interpreted as JavaScript on the client-side, the result will be sent back to the server and passed into aBlock. Multiple secondary callbacks can be defined with one receiver."

	aBlock numArgs = 1
		ifFalse: [ self error: 'aBlock expects one argument' ].
	self addParameter: (self renderContext callbacks
		store: (WAValueCallback on: aBlock)) 
			-> anObject! !

!PTAjax methodsFor: 'options' stamp: 'lr 10/28/2007 14:40'!
contentType: aString
	"The Content-Type header for your request. You might want to send XML instead of the regular URL-encoded format, in which case you would have to change this."

	self optionAt: 'contentType' put: aString! !

!PTAjax methodsFor: 'private' stamp: 'lr 5/10/2006 21:33'!
defaultArguments
	^ (Array with: self url) , super defaultArguments! !

!PTAjax methodsFor: 'private' stamp: 'pmm 12/6/2008 09:48'!
defaultContentType
	^ self application contentType! !

!PTAjax methodsFor: 'options' stamp: 'lr 10/28/2007 14:40'!
encoding: aString
	"The encoding for your request contents. It is best left as is, but should weird encoding issues arise, you may have to tweak it in accordance with other encoding-related parts of your page code and server side."

	self optionAt: 'encoding' put: aString! !

!PTAjax methodsFor: 'options' stamp: 'lr 6/30/2009 23:24'!
evalJs: aBoolean
	"Automatically evals the content of Ajax.Response#responseText if the content-type returned by the server is one of the following: application/ecmascript, application/javascript, application/x-ecmascript, application/x-javascript, text/ecmascript, text/javascript, text/x-ecmascript, or text/x-javascript and the request obeys SOP. If you need to force evalutation, pass 'force'. To prevent it altogether, pass false."

	self options at: 'evalJS' put: aBoolean! !

!PTAjax methodsFor: 'options' stamp: 'lr 6/30/2009 23:23'!
evalJson: aBoolean
	"Automatically evals the content of Ajax.Response#responseText and populates Ajax.Response#responseJSON with it if the content-type returned by the server is set to application/json. If the request doesn't obey SOP, the content is sanitized before evaluation. If you need to force evalutation, pass 'force'. To prevent it altogether, pass false."

	self options at: 'evalJSON' put: aBoolean! !

!PTAjax methodsFor: 'initialization' stamp: 'lr 5/10/2006 22:06'!
initialize
	super initialize.
	self create! !

!PTAjax methodsFor: 'options' stamp: 'lr 10/28/2007 14:40'!
method: aString
	"The HTTP method to use for the request. The other widespread possibility is 'get'."

	self optionAt: 'method' put: aString! !

!PTAjax methodsFor: 'callbacks' stamp: 'pmm 1/10/2009 23:56'!
on: aSelector of: anObject
	self callback: (WADelayedSend receiver: anObject selector: aSelector)! !

!PTAjax methodsFor: 'callbacks' stamp: 'pmm 1/10/2009 23:56'!
on: aSelector of: anObject value: anotherObject
	self
		callback: (WADelayedSend receiver: anObject selector: aSelector)
		value: anotherObject! !

!PTAjax methodsFor: 'events' stamp: 'lr 2/27/2007 20:33'!
onComplete: anObject
	"Triggered at the very end of a request's life-cycle, once the request completed, status-specific callbacks were called, and possible automatic behaviors were processed."

	self optionAt: 'onComplete' put: anObject asFunction! !

!PTAjax methodsFor: 'events' stamp: 'lr 6/30/2009 23:27'!
onCreate: anObject
	"Triggered when the Ajax.Request object is initialized. This is after the parameters and the URL have been processed, but before first using the methods of the XHR object."

	self optionAt: 'onCreate' put: anObject asFunction! !

!PTAjax methodsFor: 'events' stamp: 'lr 2/27/2007 20:33'!
onException: anObject
	"Triggered whenever an XHR error arises. Has a custom signature: the first argument is the requester, the second is the exception object."

	self optionAt: 'onException' put: anObject asFunction! !

!PTAjax methodsFor: 'events' stamp: 'lr 2/27/2007 20:33'!
onFailure: anObject
	"Invoked when a request completes and its status code exists but is not in the 2xy family. This is skipped if a code-specific callback is defined, and happens before onComplete."

	self optionAt: 'onFailure' put: anObject asFunction! !

!PTAjax methodsFor: 'events' stamp: 'lr 2/27/2007 20:33'!
onInteractive: anObject
	"(Not guaranteed) Triggered whenever the requester receives a part of the response (but not the final part), should it be sent in several packets."

	self optionAt: 'onInteractive' put: anObject asFunction! !

!PTAjax methodsFor: 'events' stamp: 'lr 2/27/2007 20:33'!
onLoaded: anObject
	"(Not guaranteed) Triggered once the underlying XHR object is setup, the connection open, and ready to send its actual request."

	self optionAt: 'onLoaded' put: anObject asFunction! !

!PTAjax methodsFor: 'events' stamp: 'lr 2/27/2007 20:34'!
onLoading: anObject
	"(Not guaranteed) Triggered when the underlying XHR object is being setup, and its connection opened."

	self optionAt: 'onLoading' put: anObject asFunction! !

!PTAjax methodsFor: 'events' stamp: 'lr 8/30/2008 16:22'!
onStatus: anInteger do: anObject 
	"With anInteger being an HTTP status code for the response. Invoked when the response just completed, and the status code is exactly the one we used in the callback name. Prevents execution of onSuccess / onFailure. Happens before onComplete."
	self 
		optionAt: 'on' , anInteger seasideString
		put: anObject asFunction! !

!PTAjax methodsFor: 'events' stamp: 'lr 2/27/2007 20:34'!
onSuccess: anObject
	"Invoked when a request completes and its status code is undefined or belongs in the 2xy family. This is skipped if a code-specific callback is defined, and happens before onComplete."

	self optionAt: 'onSuccess' put: anObject asFunction! !

!PTAjax methodsFor: 'events' stamp: 'lr 2/27/2007 20:34'!
onUninitialized: anObject
	"(Not guaranteed) Invoked when the XHR object was just created."

	self optionAt: 'onUninitialized' put: anObject asFunction! !

!PTAjax methodsFor: 'parameters' stamp: 'lr 10/16/2008 19:23'!
parameters
	"Answer the request parameters of the reciever."

	^ (self options at: 'parameters' ifAbsentPut: [ JSJoin new ]) collection! !

!PTAjax methodsFor: 'processing' stamp: 'jf 7/11/2008 16:51'!
process
	self processWith: nil! !

!PTAjax methodsFor: 'processing' stamp: 'jf 7/14/2008 01:31'!
processOn: aStream with: argumentString
	self subclassResponsibility! !

!PTAjax methodsFor: 'processing' stamp: 'lr 5/20/2009 20:10'!
processWith: argumentString
	self requestContext respond: [ :response |
		response 
			doNotCache; 
			contentType: self defaultContentType.
		self processOn: response stream with: argumentString ]! !

!PTAjax methodsFor: 'initialization' stamp: 'jf 7/19/2009 13:52'!
registerCallbackIn: aCallbackStore
	self addParameter: (aCallbackStore store: (JSAjaxCallback on: [ self process ]))! !

!PTAjax methodsFor: 'options' stamp: 'lr 10/28/2007 14:40'!
requestHeaders: aDictionary
	"Prototype automatically provides a set of default headers, that this option can override and augment: X-Requested-With, X-Prototype-Version, Accept, and Content-type."

	self optionAt: 'requestHeaders' put: aDictionary! !

!PTAjax methodsFor: 'options' stamp: 'lr 6/30/2009 23:25'!
sanitizeJson: aBoolean
	"Sanitizes the content of Ajax.Response#responseText before evaluating it."

	self options at: 'sanitizeJSON' put: aBoolean! !

!PTAjax methodsFor: 'initialization' stamp: 'jf 7/19/2009 14:07'!
setContext: aRenderContext
	super setContext: aRenderContext.
	self url: aRenderContext actionUrl withoutParameters.
	self addParameters: aRenderContext actionUrl parameters.
	self registerCallbackIn: aRenderContext callbacks! !

!PTAjax methodsFor: 'triggers' stamp: 'lr 10/16/2008 21:50'!
triggerArgument: anInteger callback: aBlock
	"Triggers a JavaScript function argument and passes its value into aBlock."

	self callback: aBlock value: (JSStream argument: anInteger)! !

!PTAjax methodsFor: 'triggers' stamp: 'lr 9/8/2009 09:05'!
triggerForm: aString
	"Serialize a complete from and trigger all its associated callbacks. Note that the callbacks of submit buttons are ignored to preserve consistency, use the normal callback to trigger specific code evaluation."

	self addParameter: (PTForm new
		id: aString;
		serialize)! !

!PTAjax methodsFor: 'triggers' stamp: 'lr 6/29/2009 15:11'!
triggerFormElement: aString
	"Serializing a form element and trigger its associated callback. Note that this might not work for all form elements as one would expect: (1) check-boxes and multi-select lists do not work as Seaside internally depends on other hidden form elements. (2) submit-button callbacks are ignored, instead use the normal callback to trigger specific code evaluation."

	self addParameter: (PTFormElement new
		id: aString;
		serialize)! !

!PTAjax methodsFor: 'triggers' stamp: 'jf 7/19/2009 14:16'!
triggerPassenger: aBlock
	aBlock fixCallbackTemps.
	self
		callback: [ :value | aBlock value: (self renderContext callbacks passengerAt: value) ]
		value: (JSStream on: 'arguments[0].id')! !

!PTAjax methodsFor: 'accessing' stamp: 'lr 4/20/2006 15:03'!
url
	^ url! !

!PTAjax methodsFor: 'accessing' stamp: 'lr 4/20/2006 15:06'!
url: aString
	url := aString! !

PTAjax subclass: #PTRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Ajax'!

!PTRequest commentStamp: 'lr 2/27/2007 20:39' prior: 0!
Initiates and processes an AJAX request.!

PTRequest subclass: #PTEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Ajax'!

!PTEvaluator commentStamp: 'lr 2/27/2007 20:40' prior: 0!
Initiates and processes an AJAX request. It automatically injects the JavaScript generated during the callback into the page.!

!PTEvaluator methodsFor: 'private' stamp: 'yann.monclair 9/4/2009 17:33'!
defaultContentType
	^ WAMimeType textJavascript charset: self requestContext entryPoint charSet! !

!PTEvaluator methodsFor: 'processing' stamp: 'lr 10/14/2008 21:51'!
processOn: aStream with: unused
	self script: callback on: aStream! !

PTEvaluator subclass: #PTPeriodicalEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Ajax'!

!PTPeriodicalEvaluator commentStamp: 'rjl 3/5/2009 17:20' prior: 0!
Periodically performs an AJAX request and gives you the ability to update multiple elements on the page with a single callaback. Offers a mechanism for decay, which lets it trigger at widening intervals while the response is unchanged.!

!PTPeriodicalEvaluator methodsFor: 'options' stamp: 'rjl 3/5/2009 14:49'!
decay: aNumber
	"This controls the rate at which the request interval grows when the response is unchanged. It is used as a multiplier on the current period (which starts at the original value of the frequency parameter). Every time a request returns an unchanged response text, the current period is multiplied by the decay. Therefore, the default value means regular requests (no change of interval). Values higher than one will yield growing intervals. Values below one are dangerous: the longer the response text stays the same, the more often you'll check, until the interval is so short your browser is left with no other choice than suicide. Note that, as soon as the response text does change, the current period resets to the original one."

	self options at: 'decay' put: aNumber! !

!PTPeriodicalEvaluator methodsFor: 'private' stamp: 'rjl 3/5/2009 17:18'!
defaultArguments
	"first arg seems required even though not being used"
	^ (Array with: '') , super defaultArguments! !

!PTPeriodicalEvaluator methodsFor: 'private' stamp: 'rjl 3/5/2009 14:57'!
defaultPrototype
	^ 'Ajax.PeriodicalUpdater'! !

!PTPeriodicalEvaluator methodsFor: 'options' stamp: 'rjl 3/5/2009 14:58'!
frequency: aDuration
	"Okay, this is not a frequency (e.g 0.5Hz), but a period (i.e. a number of seconds). Don't kill me, I didn't write this one!! This is the minimum interval at which AJAX requests are made. You don't want to make it too short (otherwise you may very well end up with multiple requests in parallel, if they take longer to process and return), but you technically can provide a number below one, e.g. 0.75 second."

	self options at: 'frequency' put: aDuration! !

!PTPeriodicalEvaluator methodsFor: 'actions' stamp: 'rjl 3/5/2009 14:58'!
start
	"If you wish to re-enable it later, just call its start method."

	self call: 'start'! !

!PTPeriodicalEvaluator methodsFor: 'actions' stamp: 'rjl 3/5/2009 14:58'!
stop
	"You can pull the brake on a running PeriodicalUpdater by simply calling its stop method."

	self call: 'stop'! !

!PTRequest methodsFor: 'private' stamp: 'lr 5/10/2006 21:25'!
defaultPrototype
	^ 'Ajax.Request'! !

!PTRequest methodsFor: 'processing' stamp: 'lr 6/7/2006 09:17'!
process
	[ super process ] on: Error do: [ :err | err defaultAction ]! !

!PTRequest methodsFor: 'processing' stamp: 'lr 2/28/2009 22:47'!
processOn: aStream with: unused
	callback isNil
		ifFalse: [ callback value ]! !

PTAjax subclass: #PTUpdater
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Ajax'!

!PTUpdater commentStamp: 'lr 2/27/2007 20:38' prior: 0!
Performs an AJAX request and updates a container's contents based on the response text.!

PTUpdater subclass: #PTPeriodical
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Ajax'!

!PTPeriodical commentStamp: 'lr 2/27/2007 20:37' prior: 0!
Periodically performs an AJAX request and updates a container's contents based on the response text. Offers a mechanism for decay, which lets it trigger at widening intervals while the response is unchanged.!

!PTPeriodical methodsFor: 'options' stamp: 'lr 4/25/2007 10:18'!
decay: aNumber
	"This controls the rate at which the request interval grows when the response is unchanged. It is used as a multiplier on the current period (which starts at the original value of the frequency parameter). Every time a request returns an unchanged response text, the current period is multiplied by the decay. Therefore, the default value means regular requests (no change of interval). Values higher than one will yield growing intervals. Values below one are dangerous: the longer the response text stays the same, the more often you'll check, until the interval is so short your browser is left with no other choice than suicide. Note that, as soon as the response text does change, the current period resets to the original one."

	self options at: 'decay' put: aNumber! !

!PTPeriodical methodsFor: 'private' stamp: 'lr 5/10/2006 21:26'!
defaultPrototype
	^ 'Ajax.PeriodicalUpdater'! !

!PTPeriodical methodsFor: 'options' stamp: 'lr 2/27/2007 20:36'!
frequency: aDuration
	"Okay, this is not a frequency (e.g 0.5Hz), but a period (i.e. a number of seconds). Don't kill me, I didn't write this one!! This is the minimum interval at which AJAX requests are made. You don't want to make it too short (otherwise you may very well end up with multiple requests in parallel, if they take longer to process and return), but you technically can provide a number below one, e.g. 0.75 second."

	self options at: 'frequency' put: aDuration! !

!PTPeriodical methodsFor: 'actions' stamp: 'lr 10/28/2007 14:40'!
start
	"If you wish to re-enable it later, just call its start method."

	self call: 'start'! !

!PTPeriodical methodsFor: 'actions' stamp: 'lr 10/28/2007 14:40'!
stop
	"You can pull the brake on a running PeriodicalUpdater by simply calling its stop method."

	self call: 'stop'! !

!PTUpdater methodsFor: 'private' stamp: 'lr 5/10/2006 21:33'!
defaultArguments
	^ (Array with: self id) , super defaultArguments! !

!PTUpdater methodsFor: 'private' stamp: 'lr 10/14/2008 00:39'!
defaultId
	^ JSStream on: 'this'! !

!PTUpdater methodsFor: 'private' stamp: 'lr 5/10/2006 21:26'!
defaultPrototype
	^ 'Ajax.Updater'! !

!PTUpdater methodsFor: 'options' stamp: 'lr 6/30/2009 23:23'!
evalScripts: aBoolean
	"This determines whether <script> elements in the response text are evaluated or not. The default implementation of Prototypes does not evaluate script, however this implementation changes this odd behavior."

	self options at: 'evalScripts' put: aBoolean! !

!PTUpdater methodsFor: 'accessing' stamp: 'lr 5/10/2006 21:33'!
id
	^ id ifNil: [ self defaultId ]! !

!PTUpdater methodsFor: 'accessing' stamp: 'lr 4/20/2006 15:09'!
id: aString
	id := aString! !

!PTUpdater methodsFor: 'initialization' stamp: 'lr 4/30/2007 20:27'!
initialize
	super initialize.
	self evalScripts: true! !

!PTUpdater methodsFor: 'options' stamp: 'lr 2/27/2007 20:38'!
insertion: anInsertion
	"By default, Element.update is used, which replaces the whole contents of the container with the response text. You may want to instead insert the response text around existing contents. You just need to pass a valid Insertion object for this, such as Insertion.Bottom."

	self options at: 'insertion' put: anInsertion! !

!PTUpdater methodsFor: 'processing' stamp: 'lr 2/28/2009 22:47'!
processOn: aStream with: argumentString
	callback isNil
		ifTrue: [ ^ self ].
	self 
		render: [ :html |
			callback argumentCount = 2
				ifTrue: [ callback valueWithArguments: (Array with: html with: argumentString) ]
				ifFalse: [ callback value: html ] ]
		on: aStream! !

PTPrototype subclass: #PTEvent
	instanceVariableNames: 'event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Elements'!

!PTEvent commentStamp: 'lr 2/27/2007 21:13' prior: 0!
Event management is one of the really sore spots of cross-browser scripting.
True, the prominent issue is: everybody does it the W3C way, and MSIE does it another way altogether. But there are quite a few subtler, sneakier issues here and there waiting to bite your ankle, such as the keypress/keydown issue with KHTML-based browsers (Konqueror and Safari). Also, MSIE has a tendency to leak memory when it comes to discarding event handlers.!

!PTEvent methodsFor: 'private' stamp: 'lr 5/17/2006 11:29'!
defaultArguments
	^ nil! !

!PTEvent methodsFor: 'private' stamp: 'lr 10/14/2008 00:40'!
defaultEvent
	^ JSStream on: 'event'! !

!PTEvent methodsFor: 'private' stamp: 'lr 5/10/2006 21:20'!
defaultPrototype
	^ 'Event'! !

!PTEvent methodsFor: 'querying' stamp: 'lr 10/14/2008 09:10'!
element
	"Returns the DOM element on which the event occurred."
	self 
		call: 'element'
		with: self event! !

!PTEvent methodsFor: 'accessing' stamp: 'lr 5/10/2006 21:13'!
event
	^ event ifNil: [ self defaultEvent ]! !

!PTEvent methodsFor: 'accessing' stamp: 'lr 5/10/2006 21:14'!
event: anObject
	event := anObject! !

!PTEvent methodsFor: 'querying' stamp: 'lr 10/14/2008 09:13'!
findElement: aString 
	"Returns the first DOM element with a given tag name, upwards from the one on which the event occurred."
	self 
		call: 'findElement'
		with: self event
		with: aString! !

!PTEvent methodsFor: 'querying' stamp: 'lr 10/14/2008 09:10'!
isLeftClick
	"Determines whether a button-related mouse event was about the left (primary, actually) button."
	self 
		call: 'isLeftClick'
		with: self event! !

!PTEvent methodsFor: 'actions' stamp: 'lr 10/14/2008 09:10'!
observe: anObservedObject on: anEventString do: aHandlerObject 
	"Define event handler aHandlerObject for anEventString."
	self 
		call: 'observe'
		withArguments: (Array 
				with: anObservedObject
				with: anEventString
				with: (aHandlerObject asFunction: #('event' )))! !

!PTEvent methodsFor: 'actions' stamp: 'lr 10/14/2008 09:00'!
stop
	"Stops the event's propagation and prevents its default action from being triggered eventually."

	self call: 'stop' with: self event! !

!PTEvent methodsFor: 'querying' stamp: 'lr 10/14/2008 09:00'!
x
	"Returns the absolute horizontal position for a mouse event."

	self call: 'pointerX' with: self event! !

!PTEvent methodsFor: 'querying' stamp: 'lr 10/14/2008 09:00'!
y
	"Returns the absolute vertical position for a mouse event."

	self call: 'pointerY' with: self event! !

PTPrototype subclass: #PTNamed
	instanceVariableNames: 'id method arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core'!

PTNamed subclass: #PTInsertion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Ajax'!

!PTInsertion commentStamp: 'lr 2/27/2007 21:19' prior: 0!
Insertion provides a cross-browser solution to the dynamic insertion of HTML snippets (or plain text, obviously). Comes in four flavors: After, Before, Bottom and Top, which behave just as expected.!

!PTInsertion methodsFor: 'accessing' stamp: 'lr 2/27/2007 21:19'!
after
	"Inserts the html into the page as the next sibling of element."

	self access: 'After'! !

!PTInsertion methodsFor: 'actions' stamp: 'lr 11/23/2006 00:14'!
after: aBlock
	self after; with: aBlock! !

!PTInsertion methodsFor: 'accessing' stamp: 'lr 2/27/2007 21:19'!
before
	"Inserts the html into the page as the previous sibling of element."

	self access: 'Before'! !

!PTInsertion methodsFor: 'actions' stamp: 'lr 11/23/2006 00:14'!
before: aBlock
	self before; with: aBlock! !

!PTInsertion methodsFor: 'accessing' stamp: 'lr 2/27/2007 21:19'!
bottom
	"Inserts the html into the page as the last child of element."

	self access: 'Bottom'! !

!PTInsertion methodsFor: 'actions' stamp: 'lr 11/23/2006 00:14'!
bottom: aBlock
	self bottom; with: aBlock! !

!PTInsertion methodsFor: 'private' stamp: 'lr 5/17/2006 11:31'!
defaultArguments
	^ nil! !

!PTInsertion methodsFor: 'private' stamp: 'lr 5/10/2006 21:45'!
defaultPrototype
	^ 'Insertion'! !

!PTInsertion methodsFor: 'accessing' stamp: 'lr 2/27/2007 21:19'!
top
	"Inserts the html into the page as the first child of element."

	self access: 'Top'! !

!PTInsertion methodsFor: 'actions' stamp: 'lr 11/23/2006 00:14'!
top: aBlock
	self top; with: aBlock! !

!PTInsertion methodsFor: 'public' stamp: 'lr 10/13/2008 23:58'!
with: aBlock
	self create; apply: (Array
		with: self id
		with: (self render: aBlock))! !

!PTNamed methodsFor: 'accessing' stamp: 'lr 5/12/2006 14:58'!
arguments
	^ arguments ifNil: [ Array with: self id ]! !

!PTNamed methodsFor: 'accessing' stamp: 'lr 5/12/2006 14:11'!
arguments: aCollection
	arguments := aCollection! !

!PTNamed methodsFor: 'private' stamp: 'lr 5/12/2006 14:58'!
defaultArguments
	^ self arguments , super defaultArguments! !

!PTNamed methodsFor: 'private' stamp: 'lr 10/14/2008 00:40'!
defaultId
	^ JSStream on: 'this'! !

!PTNamed methodsFor: 'private' stamp: 'lr 5/12/2006 14:12'!
defaultMethod
	^ nil! !

!PTNamed methodsFor: 'accessing' stamp: 'lr 5/10/2006 20:38'!
id
	^ id ifNil: [ self defaultId ]! !

!PTNamed methodsFor: 'accessing' stamp: 'lr 5/12/2006 14:58'!
id: aString
	id := aString! !

!PTNamed methodsFor: 'accessing' stamp: 'lr 5/12/2006 14:11'!
method
	^ method ifNil: [ self defaultMethod ]! !

!PTNamed methodsFor: 'accessing' stamp: 'lr 5/12/2006 14:12'!
method: aString
	method := aString! !

!PTNamed methodsFor: 'printing' stamp: 'lr 2/28/2009 22:45'!
printContentOn: aStream
	self printPrototypeOn: aStream.
	self method isNil
		ifFalse: [ self printMethodOn: aStream ].
	self printArgumentsOn: aStream! !

!PTNamed methodsFor: 'printing' stamp: 'lr 5/15/2006 13:45'!
printMethodOn: aStream
	aStream nextPut: $.; nextPutAll: self method! !

PTNamed subclass: #PTResponders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Ajax'!

!PTResponders commentStamp: 'lr 2/27/2007 20:41' prior: 0!
A repository of global listeners notified about every step of Prototype-based AJAX requests.!

!PTResponders methodsFor: 'private' stamp: 'lr 2/27/2007 20:53'!
defaultArguments
	^ Array with: self options! !

!PTResponders methodsFor: 'private' stamp: 'lr 2/27/2007 20:49'!
defaultMethod
	^ 'register'! !

!PTResponders methodsFor: 'private' stamp: 'lr 2/27/2007 20:42'!
defaultPrototype
	^ 'Ajax.Responders'! !

!PTResponders methodsFor: 'events' stamp: 'lr 2/27/2007 20:45'!
onComplete: anObject
	"Triggered at the very end of a request's life-cycle, once the request completed, status-specific callbacks were called, and possible automatic behaviors were processed."

	self optionAt: 'onComplete' put: anObject asFunction! !

!PTResponders methodsFor: 'events' stamp: 'lr 2/27/2007 20:45'!
onCreate: anObject
	"onCreate is only available to responders, as it wouldn't make a lot of sense to individual requests: you do know when your code creates them, don't you?"

	self optionAt: 'onCreate' put: anObject asFunction! !

!PTResponders methodsFor: 'events' stamp: 'lr 2/27/2007 20:45'!
onException: anObject
	"Triggered whenever an XHR error arises. Has a custom signature: the first argument is the requester, the second is the exception object."

	self optionAt: 'onException' put: anObject asFunction! !

!PTResponders methodsFor: 'events' stamp: 'lr 2/27/2007 20:45'!
onFailure: anObject
	"Invoked when a request completes and its status code exists but is not in the 2xy family. This is skipped if a code-specific callback is defined, and happens before onComplete."

	self optionAt: 'onFailure' put: anObject asFunction! !

!PTResponders methodsFor: 'events' stamp: 'lr 2/27/2007 20:45'!
onInteractive: anObject
	"(Not guaranteed) Triggered whenever the requester receives a part of the response (but not the final part), should it be sent in several packets."

	self optionAt: 'onInteractive' put: anObject asFunction! !

!PTResponders methodsFor: 'events' stamp: 'lr 2/27/2007 20:45'!
onLoaded: anObject
	"(Not guaranteed) Triggered once the underlying XHR object is setup, the connection open, and ready to send its actual request."

	self optionAt: 'onLoaded' put: anObject asFunction! !

!PTResponders methodsFor: 'events' stamp: 'lr 2/27/2007 20:45'!
onLoading: anObject
	"(Not guaranteed) Triggered when the underlying XHR object is being setup, and its connection opened."

	self optionAt: 'onLoading' put: anObject asFunction! !

!PTResponders methodsFor: 'events' stamp: 'lr 8/30/2008 16:22'!
onStatus: anInteger do: anObject 
	"With anInteger being an HTTP status code for the response. Invoked when the response just completed, and the status code is exactly the one we used in the callback name. Prevents execution of onSuccess / onFailure. Happens before onComplete."
	self 
		optionAt: 'on' , anInteger seasideString
		put: anObject asFunction! !

!PTResponders methodsFor: 'events' stamp: 'lr 2/27/2007 20:45'!
onSuccess: anObject
	"Invoked when a request completes and its status code is undefined or belongs in the 2xy family. This is skipped if a code-specific callback is defined, and happens before onComplete."

	self optionAt: 'onSuccess' put: anObject asFunction! !

!PTResponders methodsFor: 'events' stamp: 'lr 2/27/2007 20:45'!
onUninitialized: anObject
	"(Not guaranteed) Invoked when the XHR object was just created."

	self optionAt: 'onUninitialized' put: anObject asFunction! !

!PTResponders methodsFor: 'actions' stamp: 'lr 2/27/2007 20:50'!
register
	method := 'register'! !

!PTResponders methodsFor: 'actions' stamp: 'lr 2/27/2007 20:50'!
unregister
	method := 'unregister'! !

PTNamed subclass: #PTTimedObserver
	instanceVariableNames: 'frequency function'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Observers'!

!PTTimedObserver commentStamp: 'kdt 1/19/2009 10:58' prior: 0!
This is an abstract class which corresponds to the class Abstract.TimedObserver in the prototype.js library.

All of the prototype.js observers watch an element (specified by #id) at a particular #frequency and evaluate a javascript #function if the element has changed. The function takes two arguments, element (the element that changed) and value (the new value).

So the simplest use of an observer looks something like this:

html textInput id: 'watchMe'.
html script: (html formElementObserver
	id: 'watchMe';
	frequency: 2 seconds;
	function: 'alert(value)')

or you can put something more interesting in the function, e.g.:

	function: (html updater ... )
!

PTTimedObserver subclass: #PTFormElementObserver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Observers'!

!PTFormElementObserver commentStamp: 'lr 5/19/2009 09:09' prior: 0!
This class corresponds to the Form.Observer class in the prototype.js library. It is typically instantiated via a canvas, e.g. (html scriptaculous formElementObserver).

See the comment on SUTimedObserver for more details.!

!PTFormElementObserver methodsFor: 'defaults' stamp: 'lr 5/19/2009 09:09'!
defaultPrototype
	^ 'Form.Element.Observer'! !

PTTimedObserver subclass: #PTFormObserver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Observers'!

!PTFormObserver commentStamp: 'lr 5/19/2009 09:09' prior: 0!
This class corresponds to the Form.Observer class in the prototype.js library. It is typically instantiated via a canvas, e.g. (html scriptaculous formObserver).

See the comment on SUTimedObserver for more details.!

!PTFormObserver methodsFor: 'defaults' stamp: 'kdt 1/16/2009 23:17'!
defaultPrototype
	^ 'Form.Observer'! !

!PTTimedObserver methodsFor: 'defaults' stamp: 'lr 5/19/2009 09:12'!
defaultArguments
	^ super defaultArguments , (Array with: self frequency with: self function)! !

!PTTimedObserver methodsFor: 'defaults' stamp: 'lr 5/19/2009 09:41'!
defaultFrequency
	^ 1! !

!PTTimedObserver methodsFor: 'defaults' stamp: 'lr 5/19/2009 09:39'!
defaultFunction
	^ JSFunction new! !

!PTTimedObserver methodsFor: 'accessing' stamp: 'lr 5/19/2009 09:13'!
frequency
	^ frequency ifNil: [ self defaultFrequency ]! !

!PTTimedObserver methodsFor: 'accessing' stamp: 'lr 5/19/2009 09:41'!
frequency: anInteger
	frequency := anInteger! !

!PTTimedObserver methodsFor: 'accessing' stamp: 'lr 5/19/2009 09:13'!
function
	^ function ifNil: [ self defaultFunction ]! !

!PTTimedObserver methodsFor: 'accessing' stamp: 'lr 5/19/2009 09:08'!
function: anObject 
	function := anObject asFunction: #('element' 'value')! !

!PTTimedObserver methodsFor: 'initialization' stamp: 'kdt 1/17/2009 22:32'!
initialize
	super initialize.
	self create! !

!PTPrototype methodsFor: 'private' stamp: 'lr 2/28/2009 22:44'!
defaultArguments
	^ options isNil
		ifTrue: [ Array new ] 
		ifFalse: [ Array with: options ]! !

!PTPrototype methodsFor: 'private' stamp: 'lr 9/30/2008 18:28'!
defaultOptions
	^ WASmallDictionary new! !

!PTPrototype methodsFor: 'private' stamp: 'lr 5/10/2006 21:18'!
defaultPrototype
	self subclassResponsibility! !

!PTPrototype methodsFor: 'accessing' stamp: 'lr 5/9/2006 21:07'!
optionAt: aKey put: anObject
	self options at: aKey put: anObject! !

!PTPrototype methodsFor: 'accessing' stamp: 'lr 5/9/2006 21:07'!
options
	^ options ifNil: [ options := self defaultOptions ]! !

!PTPrototype methodsFor: 'printing' stamp: 'lr 2/12/2009 09:52'!
printArgumentsOn: aStream
	| arguments |
	arguments := self defaultArguments
		ifNil: [ ^ self ].
	JSStream encodeArguments: arguments on: aStream! !

!PTPrototype methodsFor: 'printing' stamp: 'lr 5/15/2006 13:44'!
printContentOn: aStream
	self printPrototypeOn: aStream.
	self printArgumentsOn: aStream! !

!PTPrototype methodsFor: 'printing' stamp: 'mb 5/29/2006 13:02'!
printPrototypeOn: aStream
	aStream nextPutAll: self defaultPrototype! !

!JSScript methodsFor: '*prototype-core-deprecated' stamp: 'lr 6/29/2009 15:06'!
element
	self 
		seasideDeprecatedApi: 'JSScript>>#element'
		details: 'Use "aScript prototype element".'.
	^ self prototype element! !

!JSScript methodsFor: '*prototype-core-deprecated' stamp: 'lr 6/29/2009 15:06'!
factory
	self
		seasideDeprecatedApi: 'JSScript>>#factory'
		details: 'Use "aScript prototype scriptaculous".'.
	^ self prototype! !

!JSScript methodsFor: '*prototype-core-deprecated' stamp: 'lr 6/29/2009 15:06'!
formElement
	self 
		seasideDeprecatedApi: 'JSScript>>#formElement'
		details: 'Use "aScript prototype formElement".'.
	^ self prototype formElement! !

!JSScript methodsFor: '*prototype-core-deprecated' stamp: 'lr 6/29/2009 15:06'!
insertion
	self 
		seasideDeprecatedApi: 'JSScript>>#insertion'
		details: 'Use "aScript prototype insertion".'.
	^ self prototype insertion! !

!JSScript methodsFor: '*prototype-core' stamp: 'jf 7/19/2009 17:49'!
prototype
	"Answer a Prototype factory that automatically adds to the receiving script."

	^ (PTFactory context: self renderContext using: (WADelayedSend receiver: self selector: #add:))
		rendererClass: self rendererClass;
		yourself! !

!JSScript methodsFor: '*prototype-core-deprecated' stamp: 'lr 6/29/2009 15:06'!
selector
	self 
		seasideDeprecatedApi: 'JSScript>>#selector'
		details: 'Use "aScript prototype selector".'.
	^ self prototype selector! !

!WAPackage class methodsFor: '*prototype-core' stamp: 'lr 6/29/2009 14:52'!
prototypeCore
	^ self new
		name: 'Prototype-Core';
		description: 'Prototype integration for Seaside. Prototype is a JavaScript Framework that aims to ease development of dynamic web applications.';
		addDependency: 'Javascript-Core';
		yourself! !

WAFileLibrary subclass: #PTDeploymentLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Libraries'!

!PTDeploymentLibrary methodsFor: 'uploaded' stamp: 'lr 6/29/2009 15:22'!
prototypeJs
	^ '/*  Prototype JavaScript framework, version 1.6.0.3
 *  (c) 2005-2008 Sam Stephenson
 *  Prototype is freely distributable under the terms of an MIT-style license.
 *  For details, see the Prototype web site: http://www.prototypejs.org/
 *--------------------------------------------------------------------------*/
var Prototype={Version:"1.6.0.3",Browser:{IE:!!!!(window.attachEvent&&navigator.userAgent.indexOf("Opera")===-1),Opera:navigator.userAgent.indexOf("Opera")>-1,WebKit:navigator.userAgent.indexOf("AppleWebKit/")>-1,Gecko:navigator.userAgent.indexOf("Gecko")>-1&&navigator.userAgent.indexOf("KHTML")===-1,MobileSafari:!!!!navigator.userAgent.match(/Apple.*Mobile.*Safari/)},BrowserFeatures:{XPath:!!!!document.evaluate,SelectorsAPI:!!!!document.querySelector,ElementExtensions:!!!!window.HTMLElement,SpecificElementExtensions:document.createElement("div")["__proto__"]&&document.createElement("div")["__proto__"]!!==document.createElement("form")["__proto__"]},ScriptFragment:"<script[^>]*>([\\S\\s]*?)<\/script>",JSONFilter:/^\/\*-secure-([\s\S]*)\*\/\s*$/,emptyFunction:function(){},K:function(A){return A}};if(Prototype.Browser.MobileSafari){Prototype.BrowserFeatures.SpecificElementExtensions=false}var Class={create:function(){var E=null,D=$A(arguments);if(Object.isFunction(D[0])){E=D.shift()}function A(){this.initialize.apply(this,arguments)}Object.extend(A,Class.Methods);A.superclass=E;A.subclasses=[];if(E){var B=function(){};B.prototype=E.prototype;A.prototype=new B;E.subclasses.push(A)}for(var C=0;C<D.length;C++){A.addMethods(D[C])}if(!!A.prototype.initialize){A.prototype.initialize=Prototype.emptyFunction}A.prototype.constructor=A;return A}};Class.Methods={addMethods:function(G){var C=this.superclass&&this.superclass.prototype;var B=Object.keys(G);if(!!Object.keys({toString:true}).length){B.push("toString","valueOf")}for(var A=0,D=B.length;A<D;A++){var F=B[A],E=G[F];if(C&&Object.isFunction(E)&&E.argumentNames().first()=="$super"){var H=E;E=(function(I){return function(){return C[I].apply(this,arguments)}})(F).wrap(H);E.valueOf=H.valueOf.bind(H);E.toString=H.toString.bind(H)}this.prototype[F]=E}return this}};var Abstract={};Object.extend=function(A,C){for(var B in C){A[B]=C[B]}return A};Object.extend(Object,{inspect:function(A){try{if(Object.isUndefined(A)){return"undefined"}if(A===null){return"null"}return A.inspect?A.inspect():String(A)}catch(B){if(B instanceof RangeError){return"..."}throw B}},toJSON:function(A){var C=typeof A;switch(C){case"undefined":case"function":case"unknown":return ;case"boolean":return A.toString()}if(A===null){return"null"}if(A.toJSON){return A.toJSON()}if(Object.isElement(A)){return }var B=[];for(var E in A){var D=Object.toJSON(A[E]);if(!!Object.isUndefined(D)){B.push(E.toJSON()+": "+D)}}return"{"+B.join(", ")+"}"},toQueryString:function(A){return $H(A).toQueryString()},toHTML:function(A){return A&&A.toHTML?A.toHTML():String.interpret(A)},keys:function(A){var B=[];for(var C in A){B.push(C)}return B},values:function(B){var A=[];for(var C in B){A.push(B[C])}return A},clone:function(A){return Object.extend({},A)},isElement:function(A){return !!!!(A&&A.nodeType==1)},isArray:function(A){return A!!=null&&typeof A=="object"&&"splice" in A&&"join" in A},isHash:function(A){return A instanceof Hash},isFunction:function(A){return typeof A=="function"},isString:function(A){return typeof A=="string"},isNumber:function(A){return typeof A=="number"},isUndefined:function(A){return typeof A=="undefined"}});Object.extend(Function.prototype,{argumentNames:function(){var A=this.toString().match(/^[\s\(]*function[^(]*\(([^\)]*)\)/)[1].replace(/\s+/g,"").split(",");return A.length==1&&!!A[0]?[]:A},bind:function(){if(arguments.length<2&&Object.isUndefined(arguments[0])){return this}var A=this,C=$A(arguments),B=C.shift();return function(){return A.apply(B,C.concat($A(arguments)))}},bindAsEventListener:function(){var A=this,C=$A(arguments),B=C.shift();return function(D){return A.apply(B,[D||window.event].concat(C))}},curry:function(){if(!!arguments.length){return this}var A=this,B=$A(arguments);return function(){return A.apply(this,B.concat($A(arguments)))}},delay:function(){var A=this,B=$A(arguments),C=B.shift()*1000;return window.setTimeout(function(){return A.apply(A,B)},C)},defer:function(){var A=[0.01].concat($A(arguments));return this.delay.apply(this,A)},wrap:function(B){var A=this;return function(){return B.apply(this,[A.bind(this)].concat($A(arguments)))}},methodize:function(){if(this._methodized){return this._methodized}var A=this;return this._methodized=function(){return A.apply(null,[this].concat($A(arguments)))}}});Date.prototype.toJSON=function(){return''"''+this.getUTCFullYear()+"-"+(this.getUTCMonth()+1).toPaddedString(2)+"-"+this.getUTCDate().toPaddedString(2)+"T"+this.getUTCHours().toPaddedString(2)+":"+this.getUTCMinutes().toPaddedString(2)+":"+this.getUTCSeconds().toPaddedString(2)+''Z"''};var Try={these:function(){var C;for(var B=0,D=arguments.length;B<D;B++){var A=arguments[B];try{C=A();break}catch(E){}}return C}};RegExp.prototype.match=RegExp.prototype.test;RegExp.escape=function(A){return String(A).replace(/([.*+?^=!!:${}()|[\]\/\\])/g,"\\$1")};var PeriodicalExecuter=Class.create({initialize:function(B,A){this.callback=B;this.frequency=A;this.currentlyExecuting=false;this.registerCallback()},registerCallback:function(){this.timer=setInterval(this.onTimerEvent.bind(this),this.frequency*1000)},execute:function(){this.callback(this)},stop:function(){if(!!this.timer){return }clearInterval(this.timer);this.timer=null},onTimerEvent:function(){if(!!this.currentlyExecuting){try{this.currentlyExecuting=true;this.execute()}finally{this.currentlyExecuting=false}}}});Object.extend(String,{interpret:function(A){return A==null?"":String(A)},specialChar:{"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r","\\":"\\\\"}});Object.extend(String.prototype,{gsub:function(E,C){var A="",D=this,B;C=arguments.callee.prepareReplacement(C);while(D.length>0){if(B=D.match(E)){A+=D.slice(0,B.index);A+=String.interpret(C(B));D=D.slice(B.index+B[0].length)}else{A+=D,D=""}}return A},sub:function(C,A,B){A=this.gsub.prepareReplacement(A);B=Object.isUndefined(B)?1:B;return this.gsub(C,function(D){if(--B<0){return D[0]}return A(D)})},scan:function(B,A){this.gsub(B,A);return String(this)},truncate:function(B,A){B=B||30;A=Object.isUndefined(A)?"...":A;return this.length>B?this.slice(0,B-A.length)+A:String(this)},strip:function(){return this.replace(/^\s+/,"").replace(/\s+$/,"")},stripTags:function(){return this.replace(/<\/?[^>]+>/gi,"")},stripScripts:function(){return this.replace(new RegExp(Prototype.ScriptFragment,"img"),"")},extractScripts:function(){var B=new RegExp(Prototype.ScriptFragment,"img");var A=new RegExp(Prototype.ScriptFragment,"im");return(this.match(B)||[]).map(function(C){return(C.match(A)||["",""])[1]})},evalScripts:function(){return this.extractScripts().map(function(script){return eval(script)})},escapeHTML:function(){var A=arguments.callee;A.text.data=this;return A.div.innerHTML},unescapeHTML:function(){var A=new Element("div");A.innerHTML=this.stripTags();return A.childNodes[0]?(A.childNodes.length>1?$A(A.childNodes).inject("",function(B,C){return B+C.nodeValue}):A.childNodes[0].nodeValue):""},toQueryParams:function(B){var A=this.strip().match(/([^?#]*)(#.*)?$/);if(!!A){return{}}return A[1].split(B||"&").inject({},function(E,F){if((F=F.split("="))[0]){var C=decodeURIComponent(F.shift());var D=F.length>1?F.join("="):F[0];if(D!!=undefined){D=decodeURIComponent(D)}if(C in E){if(!!Object.isArray(E[C])){E[C]=[E[C]]}E[C].push(D)}else{E[C]=D}}return E})},toArray:function(){return this.split("")},succ:function(){return this.slice(0,this.length-1)+String.fromCharCode(this.charCodeAt(this.length-1)+1)},times:function(A){return A<1?"":new Array(A+1).join(this)},camelize:function(){var D=this.split("-"),A=D.length;if(A==1){return D[0]}var C=this.charAt(0)=="-"?D[0].charAt(0).toUpperCase()+D[0].substring(1):D[0];for(var B=1;B<A;B++){C+=D[B].charAt(0).toUpperCase()+D[B].substring(1)}return C},capitalize:function(){return this.charAt(0).toUpperCase()+this.substring(1).toLowerCase()},underscore:function(){return this.gsub(/::/,"/").gsub(/([A-Z]+)([A-Z][a-z])/,"#{1}_#{2}").gsub(/([a-z\d])([A-Z])/,"#{1}_#{2}").gsub(/-/,"_").toLowerCase()},dasherize:function(){return this.gsub(/_/,"-")},inspect:function(B){var A=this.gsub(/[\x00-\x1f\\]/,function(C){var D=String.specialChar[C[0]];return D?D:"\\u00"+C[0].charCodeAt().toPaddedString(2,16)});if(B){return''"''+A.replace(/"/g,''\\"'')+''"''}return"''"+A.replace(/''/g,"\\''")+"''"},toJSON:function(){return this.inspect(true)},unfilterJSON:function(A){return this.sub(A||Prototype.JSONFilter,"#{1}")},isJSON:function(){var A=this;if(A.blank()){return false}A=this.replace(/\\./g,"@").replace(/"[^"\\\n\r]*"/g,"");return(/^[,:{}\[\]0-9.\-+Eaeflnr-u \n\r\t]*$/).test(A)},evalJSON:function(sanitize){var json=this.unfilterJSON();try{if(!!sanitize||json.isJSON()){return eval("("+json+")")}}catch(e){}throw new SyntaxError("Badly formed JSON string: "+this.inspect())},include:function(A){return this.indexOf(A)>-1},startsWith:function(A){return this.indexOf(A)===0},endsWith:function(A){var B=this.length-A.length;return B>=0&&this.lastIndexOf(A)===B},empty:function(){return this==""},blank:function(){return/^\s*$/.test(this)},interpolate:function(A,B){return new Template(this,B).evaluate(A)}});if(Prototype.Browser.WebKit||Prototype.Browser.IE){Object.extend(String.prototype,{escapeHTML:function(){return this.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;")},unescapeHTML:function(){return this.stripTags().replace(/&amp;/g,"&").replace(/&lt;/g,"<").replace(/&gt;/g,">")}})}String.prototype.gsub.prepareReplacement=function(B){if(Object.isFunction(B)){return B}var A=new Template(B);return function(C){return A.evaluate(C)}};String.prototype.parseQuery=String.prototype.toQueryParams;Object.extend(String.prototype.escapeHTML,{div:document.createElement("div"),text:document.createTextNode("")});String.prototype.escapeHTML.div.appendChild(String.prototype.escapeHTML.text);var Template=Class.create({initialize:function(A,B){this.template=A.toString();this.pattern=B||Template.Pattern},evaluate:function(A){if(Object.isFunction(A.toTemplateReplacements)){A=A.toTemplateReplacements()}return this.template.gsub(this.pattern,function(D){if(A==null){return""}var F=D[1]||"";if(F=="\\"){return D[2]}var B=A,G=D[3];var E=/^([^.[]+|\[((?:.*?[^\\])?)\])(\.|\[|$)/;D=E.exec(G);if(D==null){return F}while(D!!=null){var C=D[1].startsWith("[")?D[2].gsub("\\\\]","]"):D[1];B=B[C];if(null==B||""==D[3]){break}G=G.substring("["==D[3]?D[1].length:D[0].length);D=E.exec(G)}return F+String.interpret(B)})}});Template.Pattern=/(^|.|\r|\n)(#\{(.*?)\})/;var $break={};var Enumerable={each:function(C,B){var A=0;try{this._each(function(E){C.call(B,E,A++)})}catch(D){if(D!!=$break){throw D}}return this},eachSlice:function(D,C,B){var A=-D,E=[],F=this.toArray();if(D<1){return F}while((A+=D)<F.length){E.push(F.slice(A,A+D))}return E.collect(C,B)},all:function(C,B){C=C||Prototype.K;var A=true;this.each(function(E,D){A=A&&!!!!C.call(B,E,D);if(!!A){throw $break}});return A},any:function(C,B){C=C||Prototype.K;var A=false;this.each(function(E,D){if(A=!!!!C.call(B,E,D)){throw $break}});return A},collect:function(C,B){C=C||Prototype.K;var A=[];this.each(function(E,D){A.push(C.call(B,E,D))});return A},detect:function(C,B){var A;this.each(function(E,D){if(C.call(B,E,D)){A=E;throw $break}});return A},findAll:function(C,B){var A=[];this.each(function(E,D){if(C.call(B,E,D)){A.push(E)}});return A},grep:function(D,C,B){C=C||Prototype.K;var A=[];if(Object.isString(D)){D=new RegExp(D)}this.each(function(F,E){if(D.match(F)){A.push(C.call(B,F,E))}});return A},include:function(A){if(Object.isFunction(this.indexOf)){if(this.indexOf(A)!!=-1){return true}}var B=false;this.each(function(C){if(C==A){B=true;throw $break}});return B},inGroupsOf:function(B,A){A=Object.isUndefined(A)?null:A;return this.eachSlice(B,function(C){while(C.length<B){C.push(A)}return C})},inject:function(A,C,B){this.each(function(E,D){A=C.call(B,A,E,D)});return A},invoke:function(B){var A=$A(arguments).slice(1);return this.map(function(C){return C[B].apply(C,A)})},max:function(C,B){C=C||Prototype.K;var A;this.each(function(E,D){E=C.call(B,E,D);if(A==null||E>=A){A=E}});return A},min:function(C,B){C=C||Prototype.K;var A;this.each(function(E,D){E=C.call(B,E,D);if(A==null||E<A){A=E}});return A},partition:function(D,B){D=D||Prototype.K;var C=[],A=[];this.each(function(F,E){(D.call(B,F,E)?C:A).push(F)});return[C,A]},pluck:function(B){var A=[];this.each(function(C){A.push(C[B])});return A},reject:function(C,B){var A=[];this.each(function(E,D){if(!!C.call(B,E,D)){A.push(E)}});return A},sortBy:function(B,A){return this.map(function(D,C){return{value:D,criteria:B.call(A,D,C)}}).sort(function(F,E){var D=F.criteria,C=E.criteria;return D<C?-1:D>C?1:0}).pluck("value")},toArray:function(){return this.map()},zip:function(){var B=Prototype.K,A=$A(arguments);if(Object.isFunction(A.last())){B=A.pop()}var C=[this].concat(A).map($A);return this.map(function(E,D){return B(C.pluck(D))})},size:function(){return this.toArray().length},inspect:function(){return"#<Enumerable:"+this.toArray().inspect()+">"}};Object.extend(Enumerable,{map:Enumerable.collect,find:Enumerable.detect,select:Enumerable.findAll,filter:Enumerable.findAll,member:Enumerable.include,entries:Enumerable.toArray,every:Enumerable.all,some:Enumerable.any});function $A(C){if(!!C){return[]}if(C.toArray){return C.toArray()}var B=C.length||0,A=new Array(B);while(B--){A[B]=C[B]}return A}if(Prototype.Browser.WebKit){$A=function(C){if(!!C){return[]}if(!!(typeof C==="function"&&typeof C.length==="number"&&typeof C.item==="function")&&C.toArray){return C.toArray()}var B=C.length||0,A=new Array(B);while(B--){A[B]=C[B]}return A}}Array.from=$A;Object.extend(Array.prototype,Enumerable);if(!!Array.prototype._reverse){Array.prototype._reverse=Array.prototype.reverse}Object.extend(Array.prototype,{_each:function(B){for(var A=0,C=this.length;A<C;A++){B(this[A])}},clear:function(){this.length=0;return this},first:function(){return this[0]},last:function(){return this[this.length-1]},compact:function(){return this.select(function(A){return A!!=null})},flatten:function(){return this.inject([],function(B,A){return B.concat(Object.isArray(A)?A.flatten():[A])})},without:function(){var A=$A(arguments);return this.select(function(B){return !!A.include(B)})},reverse:function(A){return(A!!==false?this:this.toArray())._reverse()},reduce:function(){return this.length>1?this:this[0]},uniq:function(A){return this.inject([],function(D,C,B){if(0==B||(A?D.last()!!=C:!!D.include(C))){D.push(C)}return D})},intersect:function(A){return this.uniq().findAll(function(B){return A.detect(function(C){return B===C})})},clone:function(){return[].concat(this)},size:function(){return this.length},inspect:function(){return"["+this.map(Object.inspect).join(", ")+"]"},toJSON:function(){var A=[];this.each(function(B){var C=Object.toJSON(B);if(!!Object.isUndefined(C)){A.push(C)}});return"["+A.join(", ")+"]"}});if(Object.isFunction(Array.prototype.forEach)){Array.prototype._each=Array.prototype.forEach}if(!!Array.prototype.indexOf){Array.prototype.indexOf=function(C,A){A||(A=0);var B=this.length;if(A<0){A=B+A}for(;A<B;A++){if(this[A]===C){return A}}return -1}}if(!!Array.prototype.lastIndexOf){Array.prototype.lastIndexOf=function(B,A){A=isNaN(A)?this.length:(A<0?this.length+A:A)+1;var C=this.slice(0,A).reverse().indexOf(B);return(C<0)?C:A-C-1}}Array.prototype.toArray=Array.prototype.clone;function $w(A){if(!!Object.isString(A)){return[]}A=A.strip();return A?A.split(/\s+/):[]}if(Prototype.Browser.Opera){Array.prototype.concat=function(){var E=[];for(var B=0,C=this.length;B<C;B++){E.push(this[B])}for(var B=0,C=arguments.length;B<C;B++){if(Object.isArray(arguments[B])){for(var A=0,D=arguments[B].length;A<D;A++){E.push(arguments[B][A])}}else{E.push(arguments[B])}}return E}}Object.extend(Number.prototype,{toColorPart:function(){return this.toPaddedString(2,16)},succ:function(){return this+1},times:function(B,A){$R(0,this,true).each(B,A);return this},toPaddedString:function(C,B){var A=this.toString(B||10);return"0".times(C-A.length)+A},toJSON:function(){return isFinite(this)?this.toString():"null"}});$w("abs round ceil floor").each(function(A){Number.prototype[A]=Math[A].methodize()});function $H(A){return new Hash(A)}var Hash=Class.create(Enumerable,(function(){function A(B,C){if(Object.isUndefined(C)){return B}return B+"="+encodeURIComponent(String.interpret(C))}return{initialize:function(B){this._object=Object.isHash(B)?B.toObject():Object.clone(B)},_each:function(C){for(var B in this._object){var D=this._object[B],E=[B,D];E.key=B;E.value=D;C(E)}},set:function(B,C){return this._object[B]=C},get:function(B){if(this._object[B]!!==Object.prototype[B]){return this._object[B]}},unset:function(B){var C=this._object[B];delete this._object[B];return C},toObject:function(){return Object.clone(this._object)},keys:function(){return this.pluck("key")},values:function(){return this.pluck("value")},index:function(C){var B=this.detect(function(D){return D.value===C});return B&&B.key},merge:function(B){return this.clone().update(B)},update:function(B){return new Hash(B).inject(this,function(C,D){C.set(D.key,D.value);return C})},toQueryString:function(){return this.inject([],function(D,E){var C=encodeURIComponent(E.key),B=E.value;if(B&&typeof B=="object"){if(Object.isArray(B)){return D.concat(B.map(A.curry(C)))}}else{D.push(A(C,B))}return D}).join("&")},inspect:function(){return"#<Hash:{"+this.map(function(B){return B.map(Object.inspect).join(": ")}).join(", ")+"}>"},toJSON:function(){return Object.toJSON(this.toObject())},clone:function(){return new Hash(this)}}})());Hash.prototype.toTemplateReplacements=Hash.prototype.toObject;Hash.from=$H;var ObjectRange=Class.create(Enumerable,{initialize:function(C,A,B){this.start=C;this.end=A;this.exclusive=B},_each:function(A){var B=this.start;while(this.include(B)){A(B);B=B.succ()}},include:function(A){if(A<this.start){return false}if(this.exclusive){return A<this.end}return A<=this.end}});var $R=function(C,A,B){return new ObjectRange(C,A,B)};var Ajax={getTransport:function(){return Try.these(function(){return new XMLHttpRequest()},function(){return new ActiveXObject("Msxml2.XMLHTTP")},function(){return new ActiveXObject("Microsoft.XMLHTTP")})||false},activeRequestCount:0};Ajax.Responders={responders:[],_each:function(A){this.responders._each(A)},register:function(A){if(!!this.include(A)){this.responders.push(A)}},unregister:function(A){this.responders=this.responders.without(A)},dispatch:function(D,B,C,A){this.each(function(E){if(Object.isFunction(E[D])){try{E[D].apply(E,[B,C,A])}catch(F){}}})}};Object.extend(Ajax.Responders,Enumerable);Ajax.Responders.register({onCreate:function(){Ajax.activeRequestCount++},onComplete:function(){Ajax.activeRequestCount--}});Ajax.Base=Class.create({initialize:function(A){this.options={method:"post",asynchronous:true,contentType:"application/x-www-form-urlencoded",encoding:"UTF-8",parameters:"",evalJSON:true,evalJS:true};Object.extend(this.options,A||{});this.options.method=this.options.method.toLowerCase();if(Object.isString(this.options.parameters)){this.options.parameters=this.options.parameters.toQueryParams()}else{if(Object.isHash(this.options.parameters)){this.options.parameters=this.options.parameters.toObject()}}}});Ajax.Request=Class.create(Ajax.Base,{_complete:false,initialize:function($super,B,A){$super(A);this.transport=Ajax.getTransport();this.request(B)},request:function(B){this.url=B;this.method=this.options.method;var D=Object.clone(this.options.parameters);if(!!["get","post"].include(this.method)){D._method=this.method;this.method="post"}this.parameters=D;if(D=Object.toQueryString(D)){if(this.method=="get"){this.url+=(this.url.include("?")?"&":"?")+D}else{if(/Konqueror|Safari|KHTML/.test(navigator.userAgent)){D+="&_="}}}try{var A=new Ajax.Response(this);if(this.options.onCreate){this.options.onCreate(A)}Ajax.Responders.dispatch("onCreate",this,A);this.transport.open(this.method.toUpperCase(),this.url,this.options.asynchronous);if(this.options.asynchronous){this.respondToReadyState.bind(this).defer(1)}this.transport.onreadystatechange=this.onStateChange.bind(this);this.setRequestHeaders();this.body=this.method=="post"?(this.options.postBody||D):null;this.transport.send(this.body);if(!!this.options.asynchronous&&this.transport.overrideMimeType){this.onStateChange()}}catch(C){this.dispatchException(C)}},onStateChange:function(){var A=this.transport.readyState;if(A>1&&!!((A==4)&&this._complete)){this.respondToReadyState(this.transport.readyState)}},setRequestHeaders:function(){var E={"X-Requested-With":"XMLHttpRequest","X-Prototype-Version":Prototype.Version,Accept:"text/javascript, text/html, application/xml, text/xml, */*"};if(this.method=="post"){E["Content-type"]=this.options.contentType+(this.options.encoding?"; charset="+this.options.encoding:"");if(this.transport.overrideMimeType&&(navigator.userAgent.match(/Gecko\/(\d{4})/)||[0,2005])[1]<2005){E.Connection="close"}}if(typeof this.options.requestHeaders=="object"){var C=this.options.requestHeaders;if(Object.isFunction(C.push)){for(var B=0,D=C.length;B<D;B+=2){E[C[B]]=C[B+1]}}else{$H(C).each(function(F){E[F.key]=F.value})}}for(var A in E){this.transport.setRequestHeader(A,E[A])}},success:function(){var A=this.getStatus();return !!A||(A>=200&&A<300)},getStatus:function(){try{return this.transport.status||0}catch(A){return 0}},respondToReadyState:function(A){var C=Ajax.Request.Events[A],B=new Ajax.Response(this);if(C=="Complete"){try{this._complete=true;(this.options["on"+B.status]||this.options["on"+(this.success()?"Success":"Failure")]||Prototype.emptyFunction)(B,B.headerJSON)}catch(D){this.dispatchException(D)}var E=B.getHeader("Content-type");if(this.options.evalJS=="force"||(this.options.evalJS&&this.isSameOrigin()&&E&&E.match(/^\s*(text|application)\/(x-)?(java|ecma)script(;.*)?\s*$/i))){this.evalResponse()}}try{(this.options["on"+C]||Prototype.emptyFunction)(B,B.headerJSON);Ajax.Responders.dispatch("on"+C,this,B,B.headerJSON)}catch(D){this.dispatchException(D)}if(C=="Complete"){this.transport.onreadystatechange=Prototype.emptyFunction}},isSameOrigin:function(){var A=this.url.match(/^\s*https?:\/\/[^\/]*/);return !!A||(A[0]=="#{protocol}//#{domain}#{port}".interpolate({protocol:location.protocol,domain:document.domain,port:location.port?":"+location.port:""}))},getHeader:function(A){try{return this.transport.getResponseHeader(A)||null}catch(B){return null}},evalResponse:function(){try{return eval((this.transport.responseText||"").unfilterJSON())}catch(e){this.dispatchException(e)}},dispatchException:function(A){(this.options.onException||Prototype.emptyFunction)(this,A);Ajax.Responders.dispatch("onException",this,A)}});Ajax.Request.Events=["Uninitialized","Loading","Loaded","Interactive","Complete"];Ajax.Response=Class.create({initialize:function(C){this.request=C;var D=this.transport=C.transport,A=this.readyState=D.readyState;if((A>2&&!!Prototype.Browser.IE)||A==4){this.status=this.getStatus();this.statusText=this.getStatusText();this.responseText=String.interpret(D.responseText);this.headerJSON=this._getHeaderJSON()}if(A==4){var B=D.responseXML;this.responseXML=Object.isUndefined(B)?null:B;this.responseJSON=this._getResponseJSON()}},status:0,statusText:"",getStatus:Ajax.Request.prototype.getStatus,getStatusText:function(){try{return this.transport.statusText||""}catch(A){return""}},getHeader:Ajax.Request.prototype.getHeader,getAllHeaders:function(){try{return this.getAllResponseHeaders()}catch(A){return null}},getResponseHeader:function(A){return this.transport.getResponseHeader(A)},getAllResponseHeaders:function(){return this.transport.getAllResponseHeaders()},_getHeaderJSON:function(){var A=this.getHeader("X-JSON");if(!!A){return null}A=decodeURIComponent(escape(A));try{return A.evalJSON(this.request.options.sanitizeJSON||!!this.request.isSameOrigin())}catch(B){this.request.dispatchException(B)}},_getResponseJSON:function(){var A=this.request.options;if(!!A.evalJSON||(A.evalJSON!!="force"&&!!(this.getHeader("Content-type")||"").include("application/json"))||this.responseText.blank()){return null}try{return this.responseText.evalJSON(A.sanitizeJSON||!!this.request.isSameOrigin())}catch(B){this.request.dispatchException(B)}}});Ajax.Updater=Class.create(Ajax.Request,{initialize:function($super,A,C,B){this.container={success:(A.success||A),failure:(A.failure||(A.success?null:A))};B=Object.clone(B);var D=B.onComplete;B.onComplete=(function(E,F){this.updateContent(E.responseText);if(Object.isFunction(D)){D(E,F)}}).bind(this);$super(C,B)},updateContent:function(D){var C=this.container[this.success()?"success":"failure"],A=this.options;if(!!A.evalScripts){D=D.stripScripts()}if(C=$(C)){if(A.insertion){if(Object.isString(A.insertion)){var B={};B[A.insertion]=D;C.insert(B)}else{A.insertion(C,D)}}else{C.update(D)}}}});Ajax.PeriodicalUpdater=Class.create(Ajax.Base,{initialize:function($super,A,C,B){$super(B);this.onComplete=this.options.onComplete;this.frequency=(this.options.frequency||2);this.decay=(this.options.decay||1);this.updater={};this.container=A;this.url=C;this.start()},start:function(){this.options.onComplete=this.updateComplete.bind(this);this.onTimerEvent()},stop:function(){this.updater.options.onComplete=undefined;clearTimeout(this.timer);(this.onComplete||Prototype.emptyFunction).apply(this,arguments)},updateComplete:function(A){if(this.options.decay){this.decay=(A.responseText==this.lastText?this.decay*this.options.decay:1);this.lastText=A.responseText}this.timer=this.onTimerEvent.bind(this).delay(this.decay*this.frequency)},onTimerEvent:function(){this.updater=new Ajax.Updater(this.container,this.url,this.options)}});function $(B){if(arguments.length>1){for(var A=0,D=[],C=arguments.length;A<C;A++){D.push($(arguments[A]))}return D}if(Object.isString(B)){B=document.getElementById(B)}return Element.extend(B)}if(Prototype.BrowserFeatures.XPath){document._getElementsByXPath=function(F,A){var C=[];var E=document.evaluate(F,$(A)||document,null,XPathResult.ORDERED_NODE_SNAPSHOT_TYPE,null);for(var B=0,D=E.snapshotLength;B<D;B++){C.push(Element.extend(E.snapshotItem(B)))}return C}}if(!!window.Node){var Node={}}if(!!Node.ELEMENT_NODE){Object.extend(Node,{ELEMENT_NODE:1,ATTRIBUTE_NODE:2,TEXT_NODE:3,CDATA_SECTION_NODE:4,ENTITY_REFERENCE_NODE:5,ENTITY_NODE:6,PROCESSING_INSTRUCTION_NODE:7,COMMENT_NODE:8,DOCUMENT_NODE:9,DOCUMENT_TYPE_NODE:10,DOCUMENT_FRAGMENT_NODE:11,NOTATION_NODE:12})}(function(){var A=this.Element;this.Element=function(D,C){C=C||{};D=D.toLowerCase();var B=Element.cache;if(Prototype.Browser.IE&&C.name){D="<"+D+'' name="''+C.name+''">'';delete C.name;return Element.writeAttribute(document.createElement(D),C)}if(!!B[D]){B[D]=Element.extend(document.createElement(D))}return Element.writeAttribute(B[D].cloneNode(false),C)};Object.extend(this.Element,A||{});if(A){this.Element.prototype=A.prototype}}).call(window);Element.cache={};Element.Methods={visible:function(A){return $(A).style.display!!="none"},toggle:function(A){A=$(A);Element[Element.visible(A)?"hide":"show"](A);return A},hide:function(A){A=$(A);A.style.display="none";return A},show:function(A){A=$(A);A.style.display="";return A},remove:function(A){A=$(A);A.parentNode.removeChild(A);return A},update:function(A,B){A=$(A);if(B&&B.toElement){B=B.toElement()}if(Object.isElement(B)){return A.update().insert(B)}B=Object.toHTML(B);A.innerHTML=B.stripScripts();B.evalScripts.bind(B).defer();return A},replace:function(B,C){B=$(B);if(C&&C.toElement){C=C.toElement()}else{if(!!Object.isElement(C)){C=Object.toHTML(C);var A=B.ownerDocument.createRange();A.selectNode(B);C.evalScripts.bind(C).defer();C=A.createContextualFragment(C.stripScripts())}}B.parentNode.replaceChild(C,B);return B},insert:function(C,E){C=$(C);if(Object.isString(E)||Object.isNumber(E)||Object.isElement(E)||(E&&(E.toElement||E.toHTML))){E={bottom:E}}var D,F,B,G;for(var A in E){D=E[A];A=A.toLowerCase();F=Element._insertionTranslations[A];if(D&&D.toElement){D=D.toElement()}if(Object.isElement(D)){F(C,D);continue}D=Object.toHTML(D);B=((A=="before"||A=="after")?C.parentNode:C).tagName.toUpperCase();G=Element._getContentFromAnonymousElement(B,D.stripScripts());if(A=="top"||A=="after"){G.reverse()}G.each(F.curry(C));D.evalScripts.bind(D).defer()}return C},wrap:function(B,C,A){B=$(B);if(Object.isElement(C)){$(C).writeAttribute(A||{})}else{if(Object.isString(C)){C=new Element(C,A)}else{C=new Element("div",C)}}if(B.parentNode){B.parentNode.replaceChild(C,B)}C.appendChild(B);return C},inspect:function(B){B=$(B);var A="<"+B.tagName.toLowerCase();$H({id:"id",className:"class"}).each(function(F){var E=F.first(),C=F.last();var D=(B[E]||"").toString();if(D){A+=" "+C+"="+D.inspect(true)}});return A+">"},recursivelyCollect:function(A,C){A=$(A);var B=[];while(A=A[C]){if(A.nodeType==1){B.push(Element.extend(A))}}return B},ancestors:function(A){return $(A).recursivelyCollect("parentNode")},descendants:function(A){return $(A).select("*")},firstDescendant:function(A){A=$(A).firstChild;while(A&&A.nodeType!!=1){A=A.nextSibling}return $(A)},immediateDescendants:function(A){if(!!(A=$(A).firstChild)){return[]}while(A&&A.nodeType!!=1){A=A.nextSibling}if(A){return[A].concat($(A).nextSiblings())}return[]},previousSiblings:function(A){return $(A).recursivelyCollect("previousSibling")},nextSiblings:function(A){return $(A).recursivelyCollect("nextSibling")},siblings:function(A){A=$(A);return A.previousSiblings().reverse().concat(A.nextSiblings())},match:function(B,A){if(Object.isString(A)){A=new Selector(A)}return A.match($(B))},up:function(B,D,A){B=$(B);if(arguments.length==1){return $(B.parentNode)}var C=B.ancestors();return Object.isNumber(D)?C[D]:Selector.findElement(C,D,A)},down:function(B,C,A){B=$(B);if(arguments.length==1){return B.firstDescendant()}return Object.isNumber(C)?B.descendants()[C]:Element.select(B,C)[A||0]},previous:function(B,D,A){B=$(B);if(arguments.length==1){return $(Selector.handlers.previousElementSibling(B))}var C=B.previousSiblings();return Object.isNumber(D)?C[D]:Selector.findElement(C,D,A)},next:function(C,D,B){C=$(C);if(arguments.length==1){return $(Selector.handlers.nextElementSibling(C))}var A=C.nextSiblings();return Object.isNumber(D)?A[D]:Selector.findElement(A,D,B)},select:function(){var A=$A(arguments),B=$(A.shift());return Selector.findChildElements(B,A)},adjacent:function(){var A=$A(arguments),B=$(A.shift());return Selector.findChildElements(B.parentNode,A).without(B)},identify:function(B){B=$(B);var C=B.readAttribute("id"),A=arguments.callee;if(C){return C}do{C="anonymous_element_"+A.counter++}while($(C));B.writeAttribute("id",C);return C},readAttribute:function(C,A){C=$(C);if(Prototype.Browser.IE){var B=Element._attributeTranslations.read;if(B.values[A]){return B.values[A](C,A)}if(B.names[A]){A=B.names[A]}if(A.include(":")){return(!!C.attributes||!!C.attributes[A])?null:C.attributes[A].value}}return C.getAttribute(A)},writeAttribute:function(E,C,F){E=$(E);var B={},D=Element._attributeTranslations.write;if(typeof C=="object"){B=C}else{B[C]=Object.isUndefined(F)?true:F}for(var A in B){C=D.names[A]||A;F=B[A];if(D.values[A]){C=D.values[A](E,F)}if(F===false||F===null){E.removeAttribute(C)}else{if(F===true){E.setAttribute(C,C)}else{E.setAttribute(C,F)}}}return E},getHeight:function(A){return $(A).getDimensions().height},getWidth:function(A){return $(A).getDimensions().width},classNames:function(A){return new Element.ClassNames(A)},hasClassName:function(A,B){if(!!(A=$(A))){return }var C=A.className;return(C.length>0&&(C==B||new RegExp("(^|\\s)"+B+"(\\s|$)").test(C)))},addClassName:function(A,B){if(!!(A=$(A))){return }if(!!A.hasClassName(B)){A.className+=(A.className?" ":"")+B}return A},removeClassName:function(A,B){if(!!(A=$(A))){return }A.className=A.className.replace(new RegExp("(^|\\s+)"+B+"(\\s+|$)")," ").strip();return A},toggleClassName:function(A,B){if(!!(A=$(A))){return }return A[A.hasClassName(B)?"removeClassName":"addClassName"](B)},cleanWhitespace:function(B){B=$(B);var C=B.firstChild;while(C){var A=C.nextSibling;if(C.nodeType==3&&!!/\S/.test(C.nodeValue)){B.removeChild(C)}C=A}return B},empty:function(A){return $(A).innerHTML.blank()},descendantOf:function(B,A){B=$(B),A=$(A);if(B.compareDocumentPosition){return(B.compareDocumentPosition(A)&8)===8}if(A.contains){return A.contains(B)&&A!!==B}while(B=B.parentNode){if(B==A){return true}}return false},scrollTo:function(A){A=$(A);var B=A.cumulativeOffset();window.scrollTo(B[0],B[1]);return A},getStyle:function(B,C){B=$(B);C=C=="float"?"cssFloat":C.camelize();var D=B.style[C];if(!!D||D=="auto"){var A=document.defaultView.getComputedStyle(B,null);D=A?A[C]:null}if(C=="opacity"){return D?parseFloat(D):1}return D=="auto"?null:D},getOpacity:function(A){return $(A).getStyle("opacity")},setStyle:function(B,C){B=$(B);var E=B.style,A;if(Object.isString(C)){B.style.cssText+=";"+C;return C.include("opacity")?B.setOpacity(C.match(/opacity:\s*(\d?\.?\d*)/)[1]):B}for(var D in C){if(D=="opacity"){B.setOpacity(C[D])}else{E[(D=="float"||D=="cssFloat")?(Object.isUndefined(E.styleFloat)?"cssFloat":"styleFloat"):D]=C[D]}}return B},setOpacity:function(A,B){A=$(A);A.style.opacity=(B==1||B==="")?"":(B<0.00001)?0:B;return A},getDimensions:function(C){C=$(C);var G=C.getStyle("display");if(G!!="none"&&G!!=null){return{width:C.offsetWidth,height:C.offsetHeight}}var B=C.style;var F=B.visibility;var D=B.position;var A=B.display;B.visibility="hidden";B.position="absolute";B.display="block";var H=C.clientWidth;var E=C.clientHeight;B.display=A;B.position=D;B.visibility=F;return{width:H,height:E}},makePositioned:function(A){A=$(A);var B=Element.getStyle(A,"position");if(B=="static"||!!B){A._madePositioned=true;A.style.position="relative";if(Prototype.Browser.Opera){A.style.top=0;A.style.left=0}}return A},undoPositioned:function(A){A=$(A);if(A._madePositioned){A._madePositioned=undefined;A.style.position=A.style.top=A.style.left=A.style.bottom=A.style.right=""}return A},makeClipping:function(A){A=$(A);if(A._overflow){return A}A._overflow=Element.getStyle(A,"overflow")||"auto";if(A._overflow!!=="hidden"){A.style.overflow="hidden"}return A},undoClipping:function(A){A=$(A);if(!!A._overflow){return A}A.style.overflow=A._overflow=="auto"?"":A._overflow;A._overflow=null;return A},cumulativeOffset:function(B){var A=0,C=0;do{A+=B.offsetTop||0;C+=B.offsetLeft||0;B=B.offsetParent}while(B);return Element._returnOffset(C,A)},positionedOffset:function(B){var A=0,D=0;do{A+=B.offsetTop||0;D+=B.offsetLeft||0;B=B.offsetParent;if(B){if(B.tagName.toUpperCase()=="BODY"){break}var C=Element.getStyle(B,"position");if(C!!=="static"){break}}}while(B);return Element._returnOffset(D,A)},absolutize:function(B){B=$(B);if(B.getStyle("position")=="absolute"){return B}var D=B.positionedOffset();var F=D[1];var E=D[0];var C=B.clientWidth;var A=B.clientHeight;B._originalLeft=E-parseFloat(B.style.left||0);B._originalTop=F-parseFloat(B.style.top||0);B._originalWidth=B.style.width;B._originalHeight=B.style.height;B.style.position="absolute";B.style.top=F+"px";B.style.left=E+"px";B.style.width=C+"px";B.style.height=A+"px";return B},relativize:function(A){A=$(A);if(A.getStyle("position")=="relative"){return A}A.style.position="relative";var C=parseFloat(A.style.top||0)-(A._originalTop||0);var B=parseFloat(A.style.left||0)-(A._originalLeft||0);A.style.top=C+"px";A.style.left=B+"px";A.style.height=A._originalHeight;A.style.width=A._originalWidth;return A},cumulativeScrollOffset:function(B){var A=0,C=0;do{A+=B.scrollTop||0;C+=B.scrollLeft||0;B=B.parentNode}while(B);return Element._returnOffset(C,A)},getOffsetParent:function(A){if(A.offsetParent){return $(A.offsetParent)}if(A==document.body){return $(A)}while((A=A.parentNode)&&A!!=document.body){if(Element.getStyle(A,"position")!!="static"){return $(A)}}return $(document.body)},viewportOffset:function(D){var A=0,C=0;var B=D;do{A+=B.offsetTop||0;C+=B.offsetLeft||0;if(B.offsetParent==document.body&&Element.getStyle(B,"position")=="absolute"){break}}while(B=B.offsetParent);B=D;do{if(!!Prototype.Browser.Opera||(B.tagName&&(B.tagName.toUpperCase()=="BODY"))){A-=B.scrollTop||0;C-=B.scrollLeft||0}}while(B=B.parentNode);return Element._returnOffset(C,A)},clonePosition:function(B,D){var A=Object.extend({setLeft:true,setTop:true,setWidth:true,setHeight:true,offsetTop:0,offsetLeft:0},arguments[2]||{});D=$(D);var E=D.viewportOffset();B=$(B);var F=[0,0];var C=null;if(Element.getStyle(B,"position")=="absolute"){C=B.getOffsetParent();F=C.viewportOffset()}if(C==document.body){F[0]-=document.body.offsetLeft;F[1]-=document.body.offsetTop}if(A.setLeft){B.style.left=(E[0]-F[0]+A.offsetLeft)+"px"}if(A.setTop){B.style.top=(E[1]-F[1]+A.offsetTop)+"px"}if(A.setWidth){B.style.width=D.offsetWidth+"px"}if(A.setHeight){B.style.height=D.offsetHeight+"px"}return B}};Element.Methods.identify.counter=1;Object.extend(Element.Methods,{getElementsBySelector:Element.Methods.select,childElements:Element.Methods.immediateDescendants});Element._attributeTranslations={write:{names:{className:"class",htmlFor:"for"},values:{}}};if(Prototype.Browser.Opera){Element.Methods.getStyle=Element.Methods.getStyle.wrap(function(D,B,C){switch(C){case"left":case"top":case"right":case"bottom":if(D(B,"position")==="static"){return null}case"height":case"width":if(!!Element.visible(B)){return null}var E=parseInt(D(B,C),10);if(E!!==B["offset"+C.capitalize()]){return E+"px"}var A;if(C==="height"){A=["border-top-width","padding-top","padding-bottom","border-bottom-width"]}else{A=["border-left-width","padding-left","padding-right","border-right-width"]}return A.inject(E,function(F,G){var H=D(B,G);return H===null?F:F-parseInt(H,10)})+"px";default:return D(B,C)}});Element.Methods.readAttribute=Element.Methods.readAttribute.wrap(function(C,A,B){if(B==="title"){return A.title}return C(A,B)})}else{if(Prototype.Browser.IE){Element.Methods.getOffsetParent=Element.Methods.getOffsetParent.wrap(function(C,B){B=$(B);try{B.offsetParent}catch(E){return $(document.body)}var A=B.getStyle("position");if(A!!=="static"){return C(B)}B.setStyle({position:"relative"});var D=C(B);B.setStyle({position:A});return D});$w("positionedOffset viewportOffset").each(function(A){Element.Methods[A]=Element.Methods[A].wrap(function(E,C){C=$(C);try{C.offsetParent}catch(G){return Element._returnOffset(0,0)}var B=C.getStyle("position");if(B!!=="static"){return E(C)}var D=C.getOffsetParent();if(D&&D.getStyle("position")==="fixed"){D.setStyle({zoom:1})}C.setStyle({position:"relative"});var F=E(C);C.setStyle({position:B});return F})});Element.Methods.cumulativeOffset=Element.Methods.cumulativeOffset.wrap(function(B,A){try{A.offsetParent}catch(C){return Element._returnOffset(0,0)}return B(A)});Element.Methods.getStyle=function(A,B){A=$(A);B=(B=="float"||B=="cssFloat")?"styleFloat":B.camelize();var C=A.style[B];if(!!C&&A.currentStyle){C=A.currentStyle[B]}if(B=="opacity"){if(C=(A.getStyle("filter")||"").match(/alpha\(opacity=(.*)\)/)){if(C[1]){return parseFloat(C[1])/100}}return 1}if(C=="auto"){if((B=="width"||B=="height")&&(A.getStyle("display")!!="none")){return A["offset"+B.capitalize()]+"px"}return null}return C};Element.Methods.setOpacity=function(B,E){function F(G){return G.replace(/alpha\([^\)]*\)/gi,"")}B=$(B);var A=B.currentStyle;if((A&&!!A.hasLayout)||(!!A&&B.style.zoom=="normal")){B.style.zoom=1}var D=B.getStyle("filter"),C=B.style;if(E==1||E===""){(D=F(D))?C.filter=D:C.removeAttribute("filter");return B}else{if(E<0.00001){E=0}}C.filter=F(D)+"alpha(opacity="+(E*100)+")";return B};Element._attributeTranslations={read:{names:{"class":"className","for":"htmlFor"},values:{_getAttr:function(A,B){return A.getAttribute(B,2)},_getAttrNode:function(A,C){var B=A.getAttributeNode(C);return B?B.value:""},_getEv:function(A,B){B=A.getAttribute(B);return B?B.toString().slice(23,-2):null},_flag:function(A,B){return $(A).hasAttribute(B)?B:null},style:function(A){return A.style.cssText.toLowerCase()},title:function(A){return A.title}}}};Element._attributeTranslations.write={names:Object.extend({cellpadding:"cellPadding",cellspacing:"cellSpacing"},Element._attributeTranslations.read.names),values:{checked:function(A,B){A.checked=!!!!B},style:function(A,B){A.style.cssText=B?B:""}}};Element._attributeTranslations.has={};$w("colSpan rowSpan vAlign dateTime accessKey tabIndex encType maxLength readOnly longDesc frameBorder").each(function(A){Element._attributeTranslations.write.names[A.toLowerCase()]=A;Element._attributeTranslations.has[A.toLowerCase()]=A});(function(A){Object.extend(A,{href:A._getAttr,src:A._getAttr,type:A._getAttr,action:A._getAttrNode,disabled:A._flag,checked:A._flag,readonly:A._flag,multiple:A._flag,onload:A._getEv,onunload:A._getEv,onclick:A._getEv,ondblclick:A._getEv,onmousedown:A._getEv,onmouseup:A._getEv,onmouseover:A._getEv,onmousemove:A._getEv,onmouseout:A._getEv,onfocus:A._getEv,onblur:A._getEv,onkeypress:A._getEv,onkeydown:A._getEv,onkeyup:A._getEv,onsubmit:A._getEv,onreset:A._getEv,onselect:A._getEv,onchange:A._getEv})})(Element._attributeTranslations.read.values)}else{if(Prototype.Browser.Gecko&&/rv:1\.8\.0/.test(navigator.userAgent)){Element.Methods.setOpacity=function(A,B){A=$(A);A.style.opacity=(B==1)?0.999999:(B==="")?"":(B<0.00001)?0:B;return A}}else{if(Prototype.Browser.WebKit){Element.Methods.setOpacity=function(A,B){A=$(A);A.style.opacity=(B==1||B==="")?"":(B<0.00001)?0:B;if(B==1){if(A.tagName.toUpperCase()=="IMG"&&A.width){A.width++;A.width--}else{try{var D=document.createTextNode(" ");A.appendChild(D);A.removeChild(D)}catch(C){}}}return A};Element.Methods.cumulativeOffset=function(B){var A=0,C=0;do{A+=B.offsetTop||0;C+=B.offsetLeft||0;if(B.offsetParent==document.body){if(Element.getStyle(B,"position")=="absolute"){break}}B=B.offsetParent}while(B);return Element._returnOffset(C,A)}}}}}if(Prototype.Browser.IE||Prototype.Browser.Opera){Element.Methods.update=function(B,C){B=$(B);if(C&&C.toElement){C=C.toElement()}if(Object.isElement(C)){return B.update().insert(C)}C=Object.toHTML(C);var A=B.tagName.toUpperCase();if(A in Element._insertionTranslations.tags){$A(B.childNodes).each(function(D){B.removeChild(D)});Element._getContentFromAnonymousElement(A,C.stripScripts()).each(function(D){B.appendChild(D)})}else{B.innerHTML=C.stripScripts()}C.evalScripts.bind(C).defer();return B}}if("outerHTML" in document.createElement("div")){Element.Methods.replace=function(C,E){C=$(C);if(E&&E.toElement){E=E.toElement()}if(Object.isElement(E)){C.parentNode.replaceChild(E,C);return C}E=Object.toHTML(E);var D=C.parentNode,B=D.tagName.toUpperCase();if(Element._insertionTranslations.tags[B]){var F=C.next();var A=Element._getContentFromAnonymousElement(B,E.stripScripts());D.removeChild(C);if(F){A.each(function(G){D.insertBefore(G,F)})}else{A.each(function(G){D.appendChild(G)})}}else{C.outerHTML=E.stripScripts()}E.evalScripts.bind(E).defer();return C}}Element._returnOffset=function(B,C){var A=[B,C];A.left=B;A.top=C;return A};Element._getContentFromAnonymousElement=function(C,B){var D=new Element("div"),A=Element._insertionTranslations.tags[C];if(A){D.innerHTML=A[0]+B+A[1];A[2].times(function(){D=D.firstChild})}else{D.innerHTML=B}return $A(D.childNodes)};Element._insertionTranslations={before:function(A,B){A.parentNode.insertBefore(B,A)},top:function(A,B){A.insertBefore(B,A.firstChild)},bottom:function(A,B){A.appendChild(B)},after:function(A,B){A.parentNode.insertBefore(B,A.nextSibling)},tags:{TABLE:["<table>","</table>",1],TBODY:["<table><tbody>","</tbody></table>",2],TR:["<table><tbody><tr>","</tr></tbody></table>",3],TD:["<table><tbody><tr><td>","</td></tr></tbody></table>",4],SELECT:["<select>","</select>",1]}};(function(){Object.extend(this.tags,{THEAD:this.tags.TBODY,TFOOT:this.tags.TBODY,TH:this.tags.TD})}).call(Element._insertionTranslations);Element.Methods.Simulated={hasAttribute:function(A,C){C=Element._attributeTranslations.has[C]||C;var B=$(A).getAttributeNode(C);return !!!!(B&&B.specified)}};Element.Methods.ByTag={};Object.extend(Element,Element.Methods);if(!!Prototype.BrowserFeatures.ElementExtensions&&document.createElement("div")["__proto__"]){window.HTMLElement={};window.HTMLElement.prototype=document.createElement("div")["__proto__"];Prototype.BrowserFeatures.ElementExtensions=true}Element.extend=(function(){if(Prototype.BrowserFeatures.SpecificElementExtensions){return Prototype.K}var A={},B=Element.Methods.ByTag;var C=Object.extend(function(F){if(!!F||F._extendedByPrototype||F.nodeType!!=1||F==window){return F}var D=Object.clone(A),E=F.tagName.toUpperCase(),H,G;if(B[E]){Object.extend(D,B[E])}for(H in D){G=D[H];if(Object.isFunction(G)&&!!(H in F)){F[H]=G.methodize()}}F._extendedByPrototype=Prototype.emptyFunction;return F},{refresh:function(){if(!!Prototype.BrowserFeatures.ElementExtensions){Object.extend(A,Element.Methods);Object.extend(A,Element.Methods.Simulated)}}});C.refresh();return C})();Element.hasAttribute=function(A,B){if(A.hasAttribute){return A.hasAttribute(B)}return Element.Methods.Simulated.hasAttribute(A,B)};Element.addMethods=function(C){var I=Prototype.BrowserFeatures,D=Element.Methods.ByTag;if(!!C){Object.extend(Form,Form.Methods);Object.extend(Form.Element,Form.Element.Methods);Object.extend(Element.Methods.ByTag,{FORM:Object.clone(Form.Methods),INPUT:Object.clone(Form.Element.Methods),SELECT:Object.clone(Form.Element.Methods),TEXTAREA:Object.clone(Form.Element.Methods)})}if(arguments.length==2){var B=C;C=arguments[1]}if(!!B){Object.extend(Element.Methods,C||{})}else{if(Object.isArray(B)){B.each(H)}else{H(B)}}function H(F){F=F.toUpperCase();if(!!Element.Methods.ByTag[F]){Element.Methods.ByTag[F]={}}Object.extend(Element.Methods.ByTag[F],C)}function A(L,K,F){F=F||false;for(var N in L){var M=L[N];if(!!Object.isFunction(M)){continue}if(!!F||!!(N in K)){K[N]=M.methodize()}}}function E(L){var F;var K={OPTGROUP:"OptGroup",TEXTAREA:"TextArea",P:"Paragraph",FIELDSET:"FieldSet",UL:"UList",OL:"OList",DL:"DList",DIR:"Directory",H1:"Heading",H2:"Heading",H3:"Heading",H4:"Heading",H5:"Heading",H6:"Heading",Q:"Quote",INS:"Mod",DEL:"Mod",A:"Anchor",IMG:"Image",CAPTION:"TableCaption",COL:"TableCol",COLGROUP:"TableCol",THEAD:"TableSection",TFOOT:"TableSection",TBODY:"TableSection",TR:"TableRow",TH:"TableCell",TD:"TableCell",FRAMESET:"FrameSet",IFRAME:"IFrame"};if(K[L]){F="HTML"+K[L]+"Element"}if(window[F]){return window[F]}F="HTML"+L+"Element";if(window[F]){return window[F]}F="HTML"+L.capitalize()+"Element";if(window[F]){return window[F]}window[F]={};window[F].prototype=document.createElement(L)["__proto__"];return window[F]}if(I.ElementExtensions){A(Element.Methods,HTMLElement.prototype);A(Element.Methods.Simulated,HTMLElement.prototype,true)}if(I.SpecificElementExtensions){for(var J in Element.Methods.ByTag){var G=E(J);if(Object.isUndefined(G)){continue}A(D[J],G.prototype)}}Object.extend(Element,Element.Methods);delete Element.ByTag;if(Element.extend.refresh){Element.extend.refresh()}Element.cache={}};document.viewport={getDimensions:function(){var A={},C=Prototype.Browser;$w("width height").each(function(E){var B=E.capitalize();if(C.WebKit&&!!document.evaluate){A[E]=self["inner"+B]}else{if(C.Opera&&parseFloat(window.opera.version())<9.5){A[E]=document.body["client"+B]}else{A[E]=document.documentElement["client"+B]}}});return A},getWidth:function(){return this.getDimensions().width},getHeight:function(){return this.getDimensions().height},getScrollOffsets:function(){return Element._returnOffset(window.pageXOffset||document.documentElement.scrollLeft||document.body.scrollLeft,window.pageYOffset||document.documentElement.scrollTop||document.body.scrollTop)}};var Selector=Class.create({initialize:function(A){this.expression=A.strip();if(this.shouldUseSelectorsAPI()){this.mode="selectorsAPI"}else{if(this.shouldUseXPath()){this.mode="xpath";this.compileXPathMatcher()}else{this.mode="normal";this.compileMatcher()}}},shouldUseXPath:function(){if(!!Prototype.BrowserFeatures.XPath){return false}var A=this.expression;if(Prototype.Browser.WebKit&&(A.include("-of-type")||A.include(":empty"))){return false}if((/(\[[\w-]*?:|:checked)/).test(A)){return false}return true},shouldUseSelectorsAPI:function(){if(!!Prototype.BrowserFeatures.SelectorsAPI){return false}if(!!Selector._div){Selector._div=new Element("div")}try{Selector._div.querySelector(this.expression)}catch(A){return false}return true},compileMatcher:function(){var e=this.expression,ps=Selector.patterns,h=Selector.handlers,c=Selector.criteria,le,p,m;if(Selector._cache[e]){this.matcher=Selector._cache[e];return }this.matcher=["this.matcher = function(root) {","var r = root, h = Selector.handlers, c = false, n;"];while(e&&le!!=e&&(/\S/).test(e)){le=e;for(var i in ps){p=ps[i];if(m=e.match(p)){this.matcher.push(Object.isFunction(c[i])?c[i](m):new Template(c[i]).evaluate(m));e=e.replace(m[0],"");break}}}this.matcher.push("return h.unique(n);\n}");eval(this.matcher.join("\n"));Selector._cache[this.expression]=this.matcher},compileXPathMatcher:function(){var E=this.expression,F=Selector.patterns,B=Selector.xpath,D,A;if(Selector._cache[E]){this.xpath=Selector._cache[E];return }this.matcher=[".//*"];while(E&&D!!=E&&(/\S/).test(E)){D=E;for(var C in F){if(A=E.match(F[C])){this.matcher.push(Object.isFunction(B[C])?B[C](A):new Template(B[C]).evaluate(A));E=E.replace(A[0],"");break}}}this.xpath=this.matcher.join("");Selector._cache[this.expression]=this.xpath},findElements:function(A){A=A||document;var C=this.expression,B;switch(this.mode){case"selectorsAPI":if(A!!==document){var D=A.id,E=$(A).identify();C="#"+E+" "+C}B=$A(A.querySelectorAll(C)).map(Element.extend);A.id=D;return B;case"xpath":return document._getElementsByXPath(this.xpath,A);default:return this.matcher(A)}},match:function(H){this.tokens=[];var L=this.expression,A=Selector.patterns,E=Selector.assertions;var B,D,F;while(L&&B!!==L&&(/\S/).test(L)){B=L;for(var I in A){D=A[I];if(F=L.match(D)){if(E[I]){this.tokens.push([I,Object.clone(F)]);L=L.replace(F[0],"")}else{return this.findElements(document).include(H)}}}}var K=true,C,J;for(var I=0,G;G=this.tokens[I];I++){C=G[0],J=G[1];if(!!Selector.assertions[C](H,J)){K=false;break}}return K},toString:function(){return this.expression},inspect:function(){return"#<Selector:"+this.expression.inspect()+">"}});Object.extend(Selector,{_cache:{},xpath:{descendant:"//*",child:"/*",adjacent:"/following-sibling::*[1]",laterSibling:"/following-sibling::*",tagName:function(A){if(A[1]=="*"){return""}return"[local-name()=''"+A[1].toLowerCase()+"'' or local-name()=''"+A[1].toUpperCase()+"'']"},className:"[contains(concat('' '', @class, '' ''), '' #{1} '')]",id:"[@id=''#{1}'']",attrPresence:function(A){A[1]=A[1].toLowerCase();return new Template("[@#{1}]").evaluate(A)},attr:function(A){A[1]=A[1].toLowerCase();A[3]=A[5]||A[6];return new Template(Selector.xpath.operators[A[2]]).evaluate(A)},pseudo:function(A){var B=Selector.xpath.pseudos[A[1]];if(!!B){return""}if(Object.isFunction(B)){return B(A)}return new Template(Selector.xpath.pseudos[A[1]]).evaluate(A)},operators:{"=":"[@#{1}=''#{3}'']","!!=":"[@#{1}!!=''#{3}'']","^=":"[starts-with(@#{1}, ''#{3}'')]","$=":"[substring(@#{1}, (string-length(@#{1}) - string-length(''#{3}'') + 1))=''#{3}'']","*=":"[contains(@#{1}, ''#{3}'')]","~=":"[contains(concat('' '', @#{1}, '' ''), '' #{3} '')]","|=":"[contains(concat(''-'', @#{1}, ''-''), ''-#{3}-'')]"},pseudos:{"first-child":"[not(preceding-sibling::*)]","last-child":"[not(following-sibling::*)]","only-child":"[not(preceding-sibling::* or following-sibling::*)]",empty:"[count(*) = 0 and (count(text()) = 0)]",checked:"[@checked]",disabled:"[(@disabled) and (@type!!=''hidden'')]",enabled:"[not(@disabled) and (@type!!=''hidden'')]",not:function(B){var H=B[6],G=Selector.patterns,A=Selector.xpath,E,C;var F=[];while(H&&E!!=H&&(/\S/).test(H)){E=H;for(var D in G){if(B=H.match(G[D])){C=Object.isFunction(A[D])?A[D](B):new Template(A[D]).evaluate(B);F.push("("+C.substring(1,C.length-1)+")");H=H.replace(B[0],"");break}}}return"[not("+F.join(" and ")+")]"},"nth-child":function(A){return Selector.xpath.pseudos.nth("(count(./preceding-sibling::*) + 1) ",A)},"nth-last-child":function(A){return Selector.xpath.pseudos.nth("(count(./following-sibling::*) + 1) ",A)},"nth-of-type":function(A){return Selector.xpath.pseudos.nth("position() ",A)},"nth-last-of-type":function(A){return Selector.xpath.pseudos.nth("(last() + 1 - position()) ",A)},"first-of-type":function(A){A[6]="1";return Selector.xpath.pseudos["nth-of-type"](A)},"last-of-type":function(A){A[6]="1";return Selector.xpath.pseudos["nth-last-of-type"](A)},"only-of-type":function(A){var B=Selector.xpath.pseudos;return B["first-of-type"](A)+B["last-of-type"](A)},nth:function(E,C){var F,G=C[6],B;if(G=="even"){G="2n+0"}if(G=="odd"){G="2n+1"}if(F=G.match(/^(\d+)$/)){return"["+E+"= "+F[1]+"]"}if(F=G.match(/^(-?\d*)?n(([+-])(\d+))?/)){if(F[1]=="-"){F[1]=-1}var D=F[1]?Number(F[1]):1;var A=F[2]?Number(F[2]):0;B="[((#{fragment} - #{b}) mod #{a} = 0) and ((#{fragment} - #{b}) div #{a} >= 0)]";return new Template(B).evaluate({fragment:E,a:D,b:A})}}}},criteria:{tagName:''n = h.tagName(n, r, "#{1}", c);      c = false;'',className:''n = h.className(n, r, "#{1}", c);    c = false;'',id:''n = h.id(n, r, "#{1}", c);           c = false;'',attrPresence:''n = h.attrPresence(n, r, "#{1}", c); c = false;'',attr:function(A){A[3]=(A[5]||A[6]);return new Template(''n = h.attr(n, r, "#{1}", "#{3}", "#{2}", c); c = false;'').evaluate(A)},pseudo:function(A){if(A[6]){A[6]=A[6].replace(/"/g,''\\"'')}return new Template(''n = h.pseudo(n, "#{1}", "#{6}", r, c); c = false;'').evaluate(A)},descendant:''c = "descendant";'',child:''c = "child";'',adjacent:''c = "adjacent";'',laterSibling:''c = "laterSibling";''},patterns:{laterSibling:/^\s*~\s*/,child:/^\s*>\s*/,adjacent:/^\s*\+\s*/,descendant:/^\s/,tagName:/^\s*(\*|[\w\-]+)(\b|$)?/,id:/^#([\w\-\*]+)(\b|$)/,className:/^\.([\w\-\*]+)(\b|$)/,pseudo:/^:((first|last|nth|nth-last|only)(-child|-of-type)|empty|checked|(en|dis)abled|not)(\((.*?)\))?(\b|$|(?=\s|[:+~>]))/,attrPresence:/^\[((?:[\w]+:)?[\w]+)\]/,attr:/\[((?:[\w-]*:)?[\w-]+)\s*(?:([!!^$*~|]?=)\s*(([''"])([^\4]*?)\4|([^''"][^\]]*?)))?\]/},assertions:{tagName:function(A,B){return B[1].toUpperCase()==A.tagName.toUpperCase()},className:function(A,B){return Element.hasClassName(A,B[1])},id:function(A,B){return A.id===B[1]},attrPresence:function(A,B){return Element.hasAttribute(A,B[1])},attr:function(B,C){var A=Element.readAttribute(B,C[1]);return A&&Selector.operators[C[2]](A,C[5]||C[6])}},handlers:{concat:function(B,A){for(var C=0,D;D=A[C];C++){B.push(D)}return B},mark:function(A){var D=Prototype.emptyFunction;for(var B=0,C;C=A[B];B++){C._countedByPrototype=D}return A},unmark:function(A){for(var B=0,C;C=A[B];B++){C._countedByPrototype=undefined}return A},index:function(A,D,G){A._countedByPrototype=Prototype.emptyFunction;if(D){for(var B=A.childNodes,E=B.length-1,C=1;E>=0;E--){var F=B[E];if(F.nodeType==1&&(!!G||F._countedByPrototype)){F.nodeIndex=C++}}}else{for(var E=0,C=1,B=A.childNodes;F=B[E];E++){if(F.nodeType==1&&(!!G||F._countedByPrototype)){F.nodeIndex=C++}}}},unique:function(B){if(B.length==0){return B}var D=[],E;for(var C=0,A=B.length;C<A;C++){if(!!(E=B[C])._countedByPrototype){E._countedByPrototype=Prototype.emptyFunction;D.push(Element.extend(E))}}return Selector.handlers.unmark(D)},descendant:function(A){var D=Selector.handlers;for(var C=0,B=[],E;E=A[C];C++){D.concat(B,E.getElementsByTagName("*"))}return B},child:function(A){var E=Selector.handlers;for(var D=0,C=[],F;F=A[D];D++){for(var B=0,G;G=F.childNodes[B];B++){if(G.nodeType==1&&G.tagName!!="!!"){C.push(G)}}}return C},adjacent:function(A){for(var C=0,B=[],E;E=A[C];C++){var D=this.nextElementSibling(E);if(D){B.push(D)}}return B},laterSibling:function(A){var D=Selector.handlers;for(var C=0,B=[],E;E=A[C];C++){D.concat(B,Element.nextSiblings(E))}return B},nextElementSibling:function(A){while(A=A.nextSibling){if(A.nodeType==1){return A}}return null},previousElementSibling:function(A){while(A=A.previousSibling){if(A.nodeType==1){return A}}return null},tagName:function(A,H,C,B){var I=C.toUpperCase();var E=[],G=Selector.handlers;if(A){if(B){if(B=="descendant"){for(var F=0,D;D=A[F];F++){G.concat(E,D.getElementsByTagName(C))}return E}else{A=this[B](A)}if(C=="*"){return A}}for(var F=0,D;D=A[F];F++){if(D.tagName.toUpperCase()===I){E.push(D)}}return E}else{return H.getElementsByTagName(C)}},id:function(B,A,H,F){var G=$(H),D=Selector.handlers;if(!!G){return[]}if(!!B&&A==document){return[G]}if(B){if(F){if(F=="child"){for(var C=0,E;E=B[C];C++){if(G.parentNode==E){return[G]}}}else{if(F=="descendant"){for(var C=0,E;E=B[C];C++){if(Element.descendantOf(G,E)){return[G]}}}else{if(F=="adjacent"){for(var C=0,E;E=B[C];C++){if(Selector.handlers.previousElementSibling(G)==E){return[G]}}}else{B=D[F](B)}}}}for(var C=0,E;E=B[C];C++){if(E==G){return[G]}}return[]}return(G&&Element.descendantOf(G,A))?[G]:[]},className:function(B,A,C,D){if(B&&D){B=this[D](B)}return Selector.handlers.byClassName(B,A,C)},byClassName:function(C,B,F){if(!!C){C=Selector.handlers.descendant([B])}var H=" "+F+" ";for(var E=0,D=[],G,A;G=C[E];E++){A=G.className;if(A.length==0){continue}if(A==F||(" "+A+" ").include(H)){D.push(G)}}return D},attrPresence:function(C,B,A,G){if(!!C){C=B.getElementsByTagName("*")}if(C&&G){C=this[G](C)}var E=[];for(var D=0,F;F=C[D];D++){if(Element.hasAttribute(F,A)){E.push(F)}}return E},attr:function(A,I,H,J,C,B){if(!!A){A=I.getElementsByTagName("*")}if(A&&B){A=this[B](A)}var K=Selector.operators[C],F=[];for(var E=0,D;D=A[E];E++){var G=Element.readAttribute(D,H);if(G===null){continue}if(K(G,J)){F.push(D)}}return F},pseudo:function(B,C,E,A,D){if(B&&D){B=this[D](B)}if(!!B){B=A.getElementsByTagName("*")}return Selector.pseudos[C](B,E,A)}},pseudos:{"first-child":function(B,F,A){for(var D=0,C=[],E;E=B[D];D++){if(Selector.handlers.previousElementSibling(E)){continue}C.push(E)}return C},"last-child":function(B,F,A){for(var D=0,C=[],E;E=B[D];D++){if(Selector.handlers.nextElementSibling(E)){continue}C.push(E)}return C},"only-child":function(B,G,A){var E=Selector.handlers;for(var D=0,C=[],F;F=B[D];D++){if(!!E.previousElementSibling(F)&&!!E.nextElementSibling(F)){C.push(F)}}return C},"nth-child":function(B,C,A){return Selector.pseudos.nth(B,C,A)},"nth-last-child":function(B,C,A){return Selector.pseudos.nth(B,C,A,true)},"nth-of-type":function(B,C,A){return Selector.pseudos.nth(B,C,A,false,true)},"nth-last-of-type":function(B,C,A){return Selector.pseudos.nth(B,C,A,true,true)},"first-of-type":function(B,C,A){return Selector.pseudos.nth(B,"1",A,false,true)},"last-of-type":function(B,C,A){return Selector.pseudos.nth(B,"1",A,true,true)},"only-of-type":function(B,D,A){var C=Selector.pseudos;return C["last-of-type"](C["first-of-type"](B,D,A),D,A)},getIndices:function(B,A,C){if(B==0){return A>0?[A]:[]}return $R(1,C).inject([],function(D,E){if(0==(E-A)%B&&(E-A)/B>=0){D.push(E)}return D})},nth:function(A,L,N,K,C){if(A.length==0){return[]}if(L=="even"){L="2n+0"}if(L=="odd"){L="2n+1"}var J=Selector.handlers,I=[],B=[],E;J.mark(A);for(var H=0,D;D=A[H];H++){if(!!D.parentNode._countedByPrototype){J.index(D.parentNode,K,C);B.push(D.parentNode)}}if(L.match(/^\d+$/)){L=Number(L);for(var H=0,D;D=A[H];H++){if(D.nodeIndex==L){I.push(D)}}}else{if(E=L.match(/^(-?\d*)?n(([+-])(\d+))?/)){if(E[1]=="-"){E[1]=-1}var O=E[1]?Number(E[1]):1;var M=E[2]?Number(E[2]):0;var P=Selector.pseudos.getIndices(O,M,A.length);for(var H=0,D,F=P.length;D=A[H];H++){for(var G=0;G<F;G++){if(D.nodeIndex==P[G]){I.push(D)}}}}}J.unmark(A);J.unmark(B);return I},empty:function(B,F,A){for(var D=0,C=[],E;E=B[D];D++){if(E.tagName=="!!"||E.firstChild){continue}C.push(E)}return C},not:function(A,D,I){var G=Selector.handlers,J,C;var H=new Selector(D).findElements(I);G.mark(H);for(var F=0,E=[],B;B=A[F];F++){if(!!B._countedByPrototype){E.push(B)}}G.unmark(H);return E},enabled:function(B,F,A){for(var D=0,C=[],E;E=B[D];D++){if(!!E.disabled&&(!!E.type||E.type!!=="hidden")){C.push(E)}}return C},disabled:function(B,F,A){for(var D=0,C=[],E;E=B[D];D++){if(E.disabled){C.push(E)}}return C},checked:function(B,F,A){for(var D=0,C=[],E;E=B[D];D++){if(E.checked){C.push(E)}}return C}},operators:{"=":function(B,A){return B==A},"!!=":function(B,A){return B!!=A},"^=":function(B,A){return B==A||B&&B.startsWith(A)},"$=":function(B,A){return B==A||B&&B.endsWith(A)},"*=":function(B,A){return B==A||B&&B.include(A)},"$=":function(B,A){return B.endsWith(A)},"*=":function(B,A){return B.include(A)},"~=":function(B,A){return(" "+B+" ").include(" "+A+" ")},"|=":function(B,A){return("-"+(B||"").toUpperCase()+"-").include("-"+(A||"").toUpperCase()+"-")}},split:function(B){var A=[];B.scan(/(([\w#:.~>+()\s-]+|\*|\[.*?\])+)\s*(,|$)/,function(C){A.push(C[1].strip())});return A},matchElements:function(F,G){var E=$$(G),D=Selector.handlers;D.mark(E);for(var C=0,B=[],A;A=F[C];C++){if(A._countedByPrototype){B.push(A)}}D.unmark(E);return B},findElement:function(B,C,A){if(Object.isNumber(C)){A=C;C=false}return Selector.matchElements(B,C||"*")[A||0]},findChildElements:function(E,G){G=Selector.split(G.join(","));var D=[],F=Selector.handlers;for(var C=0,B=G.length,A;C<B;C++){A=new Selector(G[C].strip());F.concat(D,A.findElements(E))}return(B>1)?F.unique(D):D}});if(Prototype.Browser.IE){Object.extend(Selector.handlers,{concat:function(B,A){for(var C=0,D;D=A[C];C++){if(D.tagName!!=="!!"){B.push(D)}}return B},unmark:function(A){for(var B=0,C;C=A[B];B++){C.removeAttribute("_countedByPrototype")}return A}})}function $$(){return Selector.findChildElements(document,$A(arguments))}var Form={reset:function(A){$(A).reset();return A},serializeElements:function(G,B){if(typeof B!!="object"){B={hash:!!!!B}}else{if(Object.isUndefined(B.hash)){B.hash=true}}var C,F,A=false,E=B.submit;var D=G.inject({},function(H,I){if(!!I.disabled&&I.name){C=I.name;F=$(I).getValue();if(F!!=null&&I.type!!="file"&&(I.type!!="submit"||(!!A&&E!!==false&&(!!E||C==E)&&(A=true)))){if(C in H){if(!!Object.isArray(H[C])){H[C]=[H[C]]}H[C].push(F)}else{H[C]=F}}}return H});return B.hash?D:Object.toQueryString(D)}};Form.Methods={serialize:function(B,A){return Form.serializeElements(Form.getElements(B),A)},getElements:function(A){return $A($(A).getElementsByTagName("*")).inject([],function(B,C){if(Form.Element.Serializers[C.tagName.toLowerCase()]){B.push(Element.extend(C))}return B})},getInputs:function(G,C,D){G=$(G);var A=G.getElementsByTagName("input");if(!!C&&!!D){return $A(A).map(Element.extend)}for(var E=0,H=[],F=A.length;E<F;E++){var B=A[E];if((C&&B.type!!=C)||(D&&B.name!!=D)){continue}H.push(Element.extend(B))}return H},disable:function(A){A=$(A);Form.getElements(A).invoke("disable");return A},enable:function(A){A=$(A);Form.getElements(A).invoke("enable");return A},findFirstElement:function(B){var C=$(B).getElements().findAll(function(D){return"hidden"!!=D.type&&!!D.disabled});var A=C.findAll(function(D){return D.hasAttribute("tabIndex")&&D.tabIndex>=0}).sortBy(function(D){return D.tabIndex}).first();return A?A:C.find(function(D){return["input","select","textarea"].include(D.tagName.toLowerCase())})},focusFirstElement:function(A){A=$(A);A.findFirstElement().activate();return A},request:function(B,A){B=$(B),A=Object.clone(A||{});var D=A.parameters,C=B.readAttribute("action")||"";if(C.blank()){C=window.location.href}A.parameters=B.serialize(true);if(D){if(Object.isString(D)){D=D.toQueryParams()}Object.extend(A.parameters,D)}if(B.hasAttribute("method")&&!!A.method){A.method=B.method}return new Ajax.Request(C,A)}};Form.Element={focus:function(A){$(A).focus();return A},select:function(A){$(A).select();return A}};Form.Element.Methods={serialize:function(A){A=$(A);if(!!A.disabled&&A.name){var B=A.getValue();if(B!!=undefined){var C={};C[A.name]=B;return Object.toQueryString(C)}}return""},getValue:function(A){A=$(A);var B=A.tagName.toLowerCase();return Form.Element.Serializers[B](A)},setValue:function(A,B){A=$(A);var C=A.tagName.toLowerCase();Form.Element.Serializers[C](A,B);return A},clear:function(A){$(A).value="";return A},present:function(A){return $(A).value!!=""},activate:function(A){A=$(A);try{A.focus();if(A.select&&(A.tagName.toLowerCase()!!="input"||!!["button","reset","submit"].include(A.type))){A.select()}}catch(B){}return A},disable:function(A){A=$(A);A.disabled=true;return A},enable:function(A){A=$(A);A.disabled=false;return A}};var Field=Form.Element;var $F=Form.Element.Methods.getValue;Form.Element.Serializers={input:function(A,B){switch(A.type.toLowerCase()){case"checkbox":case"radio":return Form.Element.Serializers.inputSelector(A,B);default:return Form.Element.Serializers.textarea(A,B)}},inputSelector:function(A,B){if(Object.isUndefined(B)){return A.checked?A.value:null}else{A.checked=!!!!B}},textarea:function(A,B){if(Object.isUndefined(B)){return A.value}else{A.value=B}},select:function(C,F){if(Object.isUndefined(F)){return this[C.type=="select-one"?"selectOne":"selectMany"](C)}else{var B,D,G=!!Object.isArray(F);for(var A=0,E=C.length;A<E;A++){B=C.options[A];D=this.optionValue(B);if(G){if(D==F){B.selected=true;return }}else{B.selected=F.include(D)}}}},selectOne:function(B){var A=B.selectedIndex;return A>=0?this.optionValue(B.options[A]):null},selectMany:function(D){var A,E=D.length;if(!!E){return null}for(var C=0,A=[];C<E;C++){var B=D.options[C];if(B.selected){A.push(this.optionValue(B))}}return A},optionValue:function(A){return Element.extend(A).hasAttribute("value")?A.value:A.text}};Abstract.TimedObserver=Class.create(PeriodicalExecuter,{initialize:function($super,A,B,C){$super(C,B);this.element=$(A);this.lastValue=this.getValue()},execute:function(){var A=this.getValue();if(Object.isString(this.lastValue)&&Object.isString(A)?this.lastValue!!=A:String(this.lastValue)!!=String(A)){this.callback(this.element,A);this.lastValue=A}}});Form.Element.Observer=Class.create(Abstract.TimedObserver,{getValue:function(){return Form.Element.getValue(this.element)}});Form.Observer=Class.create(Abstract.TimedObserver,{getValue:function(){return Form.serialize(this.element)}});Abstract.EventObserver=Class.create({initialize:function(A,B){this.element=$(A);this.callback=B;this.lastValue=this.getValue();if(this.element.tagName.toLowerCase()=="form"){this.registerFormCallbacks()}else{this.registerCallback(this.element)}},onElementEvent:function(){var A=this.getValue();if(this.lastValue!!=A){this.callback(this.element,A);this.lastValue=A}},registerFormCallbacks:function(){Form.getElements(this.element).each(this.registerCallback,this)},registerCallback:function(A){if(A.type){switch(A.type.toLowerCase()){case"checkbox":case"radio":Event.observe(A,"click",this.onElementEvent.bind(this));break;default:Event.observe(A,"change",this.onElementEvent.bind(this));break}}}});Form.Element.EventObserver=Class.create(Abstract.EventObserver,{getValue:function(){return Form.Element.getValue(this.element)}});Form.EventObserver=Class.create(Abstract.EventObserver,{getValue:function(){return Form.serialize(this.element)}});if(!!window.Event){var Event={}}Object.extend(Event,{KEY_BACKSPACE:8,KEY_TAB:9,KEY_RETURN:13,KEY_ESC:27,KEY_LEFT:37,KEY_UP:38,KEY_RIGHT:39,KEY_DOWN:40,KEY_DELETE:46,KEY_HOME:36,KEY_END:35,KEY_PAGEUP:33,KEY_PAGEDOWN:34,KEY_INSERT:45,cache:{},relatedTarget:function(B){var A;switch(B.type){case"mouseover":A=B.fromElement;break;case"mouseout":A=B.toElement;break;default:return null}return Element.extend(A)}});Event.Methods=(function(){var A;if(Prototype.Browser.IE){var B={0:1,1:4,2:2};A=function(D,C){return D.button==B[C]}}else{if(Prototype.Browser.WebKit){A=function(D,C){switch(C){case 0:return D.which==1&&!!D.metaKey;case 1:return D.which==1&&D.metaKey;default:return false}}}else{A=function(D,C){return D.which?(D.which===C+1):(D.button===C)}}}return{isLeftClick:function(C){return A(C,0)},isMiddleClick:function(C){return A(C,1)},isRightClick:function(C){return A(C,2)},element:function(E){E=Event.extend(E);var D=E.target,C=E.type,F=E.currentTarget;if(F&&F.tagName){if(C==="load"||C==="error"||(C==="click"&&F.tagName.toLowerCase()==="input"&&F.type==="radio")){D=F}}if(D.nodeType==Node.TEXT_NODE){D=D.parentNode}return Element.extend(D)},findElement:function(D,F){var C=Event.element(D);if(!!F){return C}var E=[C].concat(C.ancestors());return Selector.findElement(E,F,0)},pointer:function(E){var D=document.documentElement,C=document.body||{scrollLeft:0,scrollTop:0};return{x:E.pageX||(E.clientX+(D.scrollLeft||C.scrollLeft)-(D.clientLeft||0)),y:E.pageY||(E.clientY+(D.scrollTop||C.scrollTop)-(D.clientTop||0))}},pointerX:function(C){return Event.pointer(C).x},pointerY:function(C){return Event.pointer(C).y},stop:function(C){Event.extend(C);C.preventDefault();C.stopPropagation();C.stopped=true}}})();Event.extend=(function(){var A=Object.keys(Event.Methods).inject({},function(B,C){B[C]=Event.Methods[C].methodize();return B});if(Prototype.Browser.IE){Object.extend(A,{stopPropagation:function(){this.cancelBubble=true},preventDefault:function(){this.returnValue=false},inspect:function(){return"[object Event]"}});return function(B){if(!!B){return false}if(B._extendedByPrototype){return B}B._extendedByPrototype=Prototype.emptyFunction;var C=Event.pointer(B);Object.extend(B,{target:B.srcElement,relatedTarget:Event.relatedTarget(B),pageX:C.x,pageY:C.y});return Object.extend(B,A)}}else{Event.prototype=Event.prototype||document.createEvent("HTMLEvents")["__proto__"];Object.extend(Event.prototype,A);return Prototype.K}})();Object.extend(Event,(function(){var B=Event.cache;function C(J){if(J._prototypeEventID){return J._prototypeEventID[0]}arguments.callee.id=arguments.callee.id||1;return J._prototypeEventID=[++arguments.callee.id]}function G(J){if(J&&J.include(":")){return"dataavailable"}return J}function A(J){return B[J]=B[J]||{}}function F(L,J){var K=A(L);return K[J]=K[J]||[]}function H(K,J,L){var O=C(K);var N=F(O,J);if(N.pluck("handler").include(L)){return false}var M=function(P){if(!!Event||!!Event.extend||(P.eventName&&P.eventName!!=J)){return false}Event.extend(P);L.call(K,P)};M.handler=L;N.push(M);return M}function I(M,J,K){var L=F(M,J);return L.find(function(N){return N.handler==K})}function D(M,J,K){var L=A(M);if(!!L[J]){return false}L[J]=L[J].without(I(M,J,K))}function E(){for(var K in B){for(var J in B[K]){B[K][J]=null}}}if(window.attachEvent){window.attachEvent("onunload",E)}if(Prototype.Browser.WebKit){window.addEventListener("unload",Prototype.emptyFunction,false)}return{observe:function(L,J,M){L=$(L);var K=G(J);var N=H(L,J,M);if(!!N){return L}if(L.addEventListener){L.addEventListener(K,N,false)}else{L.attachEvent("on"+K,N)}return L},stopObserving:function(L,J,M){L=$(L);var O=C(L),K=G(J);if(!!M&&J){F(O,J).each(function(P){L.stopObserving(J,P.handler)});return L}else{if(!!J){Object.keys(A(O)).each(function(P){L.stopObserving(P)});return L}}var N=I(O,J,M);if(!!N){return L}if(L.removeEventListener){L.removeEventListener(K,N,false)}else{L.detachEvent("on"+K,N)}D(O,J,M);return L},fire:function(L,K,J){L=$(L);if(L==document&&document.createEvent&&!!L.dispatchEvent){L=document.documentElement}var M;if(document.createEvent){M=document.createEvent("HTMLEvents");M.initEvent("dataavailable",true,true)}else{M=document.createEventObject();M.eventType="ondataavailable"}M.eventName=K;M.memo=J||{};if(document.createEvent){L.dispatchEvent(M)}else{L.fireEvent(M.eventType,M)}return Event.extend(M)}}})());Object.extend(Event,Event.Methods);Element.addMethods({fire:Event.fire,observe:Event.observe,stopObserving:Event.stopObserving});Object.extend(document,{fire:Element.Methods.fire.methodize(),observe:Element.Methods.observe.methodize(),stopObserving:Element.Methods.stopObserving.methodize(),loaded:false});(function(){var B;function A(){if(document.loaded){return }if(B){window.clearInterval(B)}document.fire("dom:loaded");document.loaded=true}if(document.addEventListener){if(Prototype.Browser.WebKit){B=window.setInterval(function(){if(/loaded|complete/.test(document.readyState)){A()}},0);Event.observe(window,"load",A)}else{document.addEventListener("DOMContentLoaded",A,false)}}else{document.write("<script id=__onDOMContentLoaded defer src=//:><\/script>");$("__onDOMContentLoaded").onreadystatechange=function(){if(this.readyState=="complete"){this.onreadystatechange=null;A()}}}})();Hash.toQueryString=Object.toQueryString;var Toggle={display:Element.toggle};Element.Methods.childOf=Element.Methods.descendantOf;var Insertion={Before:function(A,B){return Element.insert(A,{before:B})},Top:function(A,B){return Element.insert(A,{top:B})},Bottom:function(A,B){return Element.insert(A,{bottom:B})},After:function(A,B){return Element.insert(A,{after:B})}};var $continue=new Error(''"throw $continue" is deprecated, use "return" instead'');var Position={includeScrollOffsets:false,prepare:function(){this.deltaX=window.pageXOffset||document.documentElement.scrollLeft||document.body.scrollLeft||0;this.deltaY=window.pageYOffset||document.documentElement.scrollTop||document.body.scrollTop||0},within:function(B,A,C){if(this.includeScrollOffsets){return this.withinIncludingScrolloffsets(B,A,C)}this.xcomp=A;this.ycomp=C;this.offset=Element.cumulativeOffset(B);return(C>=this.offset[1]&&C<this.offset[1]+B.offsetHeight&&A>=this.offset[0]&&A<this.offset[0]+B.offsetWidth)},withinIncludingScrolloffsets:function(B,A,D){var C=Element.cumulativeScrollOffset(B);this.xcomp=A+C[0]-this.deltaX;this.ycomp=D+C[1]-this.deltaY;this.offset=Element.cumulativeOffset(B);return(this.ycomp>=this.offset[1]&&this.ycomp<this.offset[1]+B.offsetHeight&&this.xcomp>=this.offset[0]&&this.xcomp<this.offset[0]+B.offsetWidth)},overlap:function(B,A){if(!!B){return 0}if(B=="vertical"){return((this.offset[1]+A.offsetHeight)-this.ycomp)/A.offsetHeight}if(B=="horizontal"){return((this.offset[0]+A.offsetWidth)-this.xcomp)/A.offsetWidth}},cumulativeOffset:Element.Methods.cumulativeOffset,positionedOffset:Element.Methods.positionedOffset,absolutize:function(A){Position.prepare();return Element.absolutize(A)},relativize:function(A){Position.prepare();return Element.relativize(A)},realOffset:Element.Methods.cumulativeScrollOffset,offsetParent:Element.Methods.getOffsetParent,page:Element.Methods.viewportOffset,clone:function(B,C,A){A=A||{};return Element.clonePosition(C,B,A)}};if(!!document.getElementsByClassName){document.getElementsByClassName=function(B){function A(C){return C.blank()?null:"[contains(concat('' '', @class, '' ''), '' "+C+" '')]"}B.getElementsByClassName=Prototype.BrowserFeatures.XPath?function(C,E){E=E.toString().strip();var D=/\s/.test(E)?$w(E).map(A).join(""):A(E);return D?document._getElementsByXPath(".//*"+D,C):[]}:function(E,F){F=F.toString().strip();var G=[],H=(/\s/.test(F)?$w(F):null);if(!!H&&!!F){return G}var C=$(E).getElementsByTagName("*");F=" "+F+" ";for(var D=0,J,I;J=C[D];D++){if(J.className&&(I=" "+J.className+" ")&&(I.include(F)||(H&&H.all(function(K){return !!K.toString().blank()&&I.include(" "+K+" ")})))){G.push(Element.extend(J))}}return G};return function(D,C){return $(C||document.body).getElementsByClassName(D)}}(Element.Methods)}Element.ClassNames=Class.create();Element.ClassNames.prototype={initialize:function(A){this.element=$(A)},_each:function(A){this.element.className.split(/\s+/).select(function(B){return B.length>0})._each(A)},set:function(A){this.element.className=A},add:function(A){if(this.include(A)){return }this.set($A(this).concat(A).join(" "))},remove:function(A){if(!!this.include(A)){return }this.set($A(this).without(A).join(" "))},toString:function(){return $A(this).join(" ")}};Object.extend(Element.ClassNames.prototype,Enumerable);Element.addMethods();'! !

!PTDeploymentLibrary methodsFor: 'accessing' stamp: 'lr 6/29/2009 15:34'!
selectorsToInclude
	^ #(prototypeJs)! !

WAFileLibrary subclass: #PTDevelopmentLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Libraries'!

!PTDevelopmentLibrary methodsFor: 'uploaded' stamp: 'lr 6/29/2009 15:21'!
prototypeJs
	^ '/*  Prototype JavaScript framework, version 1.6.0.3
 *  (c) 2005-2008 Sam Stephenson
 *
 *  Prototype is freely distributable under the terms of an MIT-style license.
 *  For details, see the Prototype web site: http://www.prototypejs.org/
 *
 *--------------------------------------------------------------------------*/

var Prototype = {
  Version: ''1.6.0.3'',

  Browser: {
    IE:     !!!!(window.attachEvent &&
      navigator.userAgent.indexOf(''Opera'') === -1),
    Opera:  navigator.userAgent.indexOf(''Opera'') > -1,
    WebKit: navigator.userAgent.indexOf(''AppleWebKit/'') > -1,
    Gecko:  navigator.userAgent.indexOf(''Gecko'') > -1 &&
      navigator.userAgent.indexOf(''KHTML'') === -1,
    MobileSafari: !!!!navigator.userAgent.match(/Apple.*Mobile.*Safari/)
  },

  BrowserFeatures: {
    XPath: !!!!document.evaluate,
    SelectorsAPI: !!!!document.querySelector,
    ElementExtensions: !!!!window.HTMLElement,
    SpecificElementExtensions:
      document.createElement(''div'')[''__proto__''] &&
      document.createElement(''div'')[''__proto__''] !!==
        document.createElement(''form'')[''__proto__'']
  },

  ScriptFragment: ''<script[^>]*>([\\S\\s]*?)<\/script>'',
  JSONFilter: /^\/\*-secure-([\s\S]*)\*\/\s*$/,

  emptyFunction: function() { },
  K: function(x) { return x }
};

if (Prototype.Browser.MobileSafari)
  Prototype.BrowserFeatures.SpecificElementExtensions = false;


/* Based on Alex Arnell''s inheritance implementation. */
var Class = {
  create: function() {
    var parent = null, properties = $A(arguments);
    if (Object.isFunction(properties[0]))
      parent = properties.shift();

    function klass() {
      this.initialize.apply(this, arguments);
    }

    Object.extend(klass, Class.Methods);
    klass.superclass = parent;
    klass.subclasses = [];

    if (parent) {
      var subclass = function() { };
      subclass.prototype = parent.prototype;
      klass.prototype = new subclass;
      parent.subclasses.push(klass);
    }

    for (var i = 0; i < properties.length; i++)
      klass.addMethods(properties[i]);

    if (!!klass.prototype.initialize)
      klass.prototype.initialize = Prototype.emptyFunction;

    klass.prototype.constructor = klass;

    return klass;
  }
};

Class.Methods = {
  addMethods: function(source) {
    var ancestor   = this.superclass && this.superclass.prototype;
    var properties = Object.keys(source);

    if (!!Object.keys({ toString: true }).length)
      properties.push("toString", "valueOf");

    for (var i = 0, length = properties.length; i < length; i++) {
      var property = properties[i], value = source[property];
      if (ancestor && Object.isFunction(value) &&
          value.argumentNames().first() == "$super") {
        var method = value;
        value = (function(m) {
          return function() { return ancestor[m].apply(this, arguments) };
        })(property).wrap(method);

        value.valueOf = method.valueOf.bind(method);
        value.toString = method.toString.bind(method);
      }
      this.prototype[property] = value;
    }

    return this;
  }
};

var Abstract = { };

Object.extend = function(destination, source) {
  for (var property in source)
    destination[property] = source[property];
  return destination;
};

Object.extend(Object, {
  inspect: function(object) {
    try {
      if (Object.isUndefined(object)) return ''undefined'';
      if (object === null) return ''null'';
      return object.inspect ? object.inspect() : String(object);
    } catch (e) {
      if (e instanceof RangeError) return ''...'';
      throw e;
    }
  },

  toJSON: function(object) {
    var type = typeof object;
    switch (type) {
      case ''undefined'':
      case ''function'':
      case ''unknown'': return;
      case ''boolean'': return object.toString();
    }

    if (object === null) return ''null'';
    if (object.toJSON) return object.toJSON();
    if (Object.isElement(object)) return;

    var results = [];
    for (var property in object) {
      var value = Object.toJSON(object[property]);
      if (!!Object.isUndefined(value))
        results.push(property.toJSON() + '': '' + value);
    }

    return ''{'' + results.join('', '') + ''}'';
  },

  toQueryString: function(object) {
    return $H(object).toQueryString();
  },

  toHTML: function(object) {
    return object && object.toHTML ? object.toHTML() : String.interpret(object);
  },

  keys: function(object) {
    var keys = [];
    for (var property in object)
      keys.push(property);
    return keys;
  },

  values: function(object) {
    var values = [];
    for (var property in object)
      values.push(object[property]);
    return values;
  },

  clone: function(object) {
    return Object.extend({ }, object);
  },

  isElement: function(object) {
    return !!!!(object && object.nodeType == 1);
  },

  isArray: function(object) {
    return object !!= null && typeof object == "object" &&
      ''splice'' in object && ''join'' in object;
  },

  isHash: function(object) {
    return object instanceof Hash;
  },

  isFunction: function(object) {
    return typeof object == "function";
  },

  isString: function(object) {
    return typeof object == "string";
  },

  isNumber: function(object) {
    return typeof object == "number";
  },

  isUndefined: function(object) {
    return typeof object == "undefined";
  }
});

Object.extend(Function.prototype, {
  argumentNames: function() {
    var names = this.toString().match(/^[\s\(]*function[^(]*\(([^\)]*)\)/)[1]
      .replace(/\s+/g, '''').split('','');
    return names.length == 1 && !!names[0] ? [] : names;
  },

  bind: function() {
    if (arguments.length < 2 && Object.isUndefined(arguments[0])) return this;
    var __method = this, args = $A(arguments), object = args.shift();
    return function() {
      return __method.apply(object, args.concat($A(arguments)));
    }
  },

  bindAsEventListener: function() {
    var __method = this, args = $A(arguments), object = args.shift();
    return function(event) {
      return __method.apply(object, [event || window.event].concat(args));
    }
  },

  curry: function() {
    if (!!arguments.length) return this;
    var __method = this, args = $A(arguments);
    return function() {
      return __method.apply(this, args.concat($A(arguments)));
    }
  },

  delay: function() {
    var __method = this, args = $A(arguments), timeout = args.shift() * 1000;
    return window.setTimeout(function() {
      return __method.apply(__method, args);
    }, timeout);
  },

  defer: function() {
    var args = [0.01].concat($A(arguments));
    return this.delay.apply(this, args);
  },

  wrap: function(wrapper) {
    var __method = this;
    return function() {
      return wrapper.apply(this, [__method.bind(this)].concat($A(arguments)));
    }
  },

  methodize: function() {
    if (this._methodized) return this._methodized;
    var __method = this;
    return this._methodized = function() {
      return __method.apply(null, [this].concat($A(arguments)));
    };
  }
});

Date.prototype.toJSON = function() {
  return ''"'' + this.getUTCFullYear() + ''-'' +
    (this.getUTCMonth() + 1).toPaddedString(2) + ''-'' +
    this.getUTCDate().toPaddedString(2) + ''T'' +
    this.getUTCHours().toPaddedString(2) + '':'' +
    this.getUTCMinutes().toPaddedString(2) + '':'' +
    this.getUTCSeconds().toPaddedString(2) + ''Z"'';
};

var Try = {
  these: function() {
    var returnValue;

    for (var i = 0, length = arguments.length; i < length; i++) {
      var lambda = arguments[i];
      try {
        returnValue = lambda();
        break;
      } catch (e) { }
    }

    return returnValue;
  }
};

RegExp.prototype.match = RegExp.prototype.test;

RegExp.escape = function(str) {
  return String(str).replace(/([.*+?^=!!:${}()|[\]\/\\])/g, ''\\$1'');
};

/*--------------------------------------------------------------------------*/

var PeriodicalExecuter = Class.create({
  initialize: function(callback, frequency) {
    this.callback = callback;
    this.frequency = frequency;
    this.currentlyExecuting = false;

    this.registerCallback();
  },

  registerCallback: function() {
    this.timer = setInterval(this.onTimerEvent.bind(this), this.frequency * 1000);
  },

  execute: function() {
    this.callback(this);
  },

  stop: function() {
    if (!!this.timer) return;
    clearInterval(this.timer);
    this.timer = null;
  },

  onTimerEvent: function() {
    if (!!this.currentlyExecuting) {
      try {
        this.currentlyExecuting = true;
        this.execute();
      } finally {
        this.currentlyExecuting = false;
      }
    }
  }
});
Object.extend(String, {
  interpret: function(value) {
    return value == null ? '''' : String(value);
  },
  specialChar: {
    ''\b'': ''\\b'',
    ''\t'': ''\\t'',
    ''\n'': ''\\n'',
    ''\f'': ''\\f'',
    ''\r'': ''\\r'',
    ''\\'': ''\\\\''
  }
});

Object.extend(String.prototype, {
  gsub: function(pattern, replacement) {
    var result = '''', source = this, match;
    replacement = arguments.callee.prepareReplacement(replacement);

    while (source.length > 0) {
      if (match = source.match(pattern)) {
        result += source.slice(0, match.index);
        result += String.interpret(replacement(match));
        source  = source.slice(match.index + match[0].length);
      } else {
        result += source, source = '''';
      }
    }
    return result;
  },

  sub: function(pattern, replacement, count) {
    replacement = this.gsub.prepareReplacement(replacement);
    count = Object.isUndefined(count) ? 1 : count;

    return this.gsub(pattern, function(match) {
      if (--count < 0) return match[0];
      return replacement(match);
    });
  },

  scan: function(pattern, iterator) {
    this.gsub(pattern, iterator);
    return String(this);
  },

  truncate: function(length, truncation) {
    length = length || 30;
    truncation = Object.isUndefined(truncation) ? ''...'' : truncation;
    return this.length > length ?
      this.slice(0, length - truncation.length) + truncation : String(this);
  },

  strip: function() {
    return this.replace(/^\s+/, '''').replace(/\s+$/, '''');
  },

  stripTags: function() {
    return this.replace(/<\/?[^>]+>/gi, '''');
  },

  stripScripts: function() {
    return this.replace(new RegExp(Prototype.ScriptFragment, ''img''), '''');
  },

  extractScripts: function() {
    var matchAll = new RegExp(Prototype.ScriptFragment, ''img'');
    var matchOne = new RegExp(Prototype.ScriptFragment, ''im'');
    return (this.match(matchAll) || []).map(function(scriptTag) {
      return (scriptTag.match(matchOne) || ['''', ''''])[1];
    });
  },

  evalScripts: function() {
    return this.extractScripts().map(function(script) { return eval(script) });
  },

  escapeHTML: function() {
    var self = arguments.callee;
    self.text.data = this;
    return self.div.innerHTML;
  },

  unescapeHTML: function() {
    var div = new Element(''div'');
    div.innerHTML = this.stripTags();
    return div.childNodes[0] ? (div.childNodes.length > 1 ?
      $A(div.childNodes).inject('''', function(memo, node) { return memo+node.nodeValue }) :
      div.childNodes[0].nodeValue) : '''';
  },

  toQueryParams: function(separator) {
    var match = this.strip().match(/([^?#]*)(#.*)?$/);
    if (!!match) return { };

    return match[1].split(separator || ''&'').inject({ }, function(hash, pair) {
      if ((pair = pair.split(''=''))[0]) {
        var key = decodeURIComponent(pair.shift());
        var value = pair.length > 1 ? pair.join(''='') : pair[0];
        if (value !!= undefined) value = decodeURIComponent(value);

        if (key in hash) {
          if (!!Object.isArray(hash[key])) hash[key] = [hash[key]];
          hash[key].push(value);
        }
        else hash[key] = value;
      }
      return hash;
    });
  },

  toArray: function() {
    return this.split('''');
  },

  succ: function() {
    return this.slice(0, this.length - 1) +
      String.fromCharCode(this.charCodeAt(this.length - 1) + 1);
  },

  times: function(count) {
    return count < 1 ? '''' : new Array(count + 1).join(this);
  },

  camelize: function() {
    var parts = this.split(''-''), len = parts.length;
    if (len == 1) return parts[0];

    var camelized = this.charAt(0) == ''-''
      ? parts[0].charAt(0).toUpperCase() + parts[0].substring(1)
      : parts[0];

    for (var i = 1; i < len; i++)
      camelized += parts[i].charAt(0).toUpperCase() + parts[i].substring(1);

    return camelized;
  },

  capitalize: function() {
    return this.charAt(0).toUpperCase() + this.substring(1).toLowerCase();
  },

  underscore: function() {
    return this.gsub(/::/, ''/'').gsub(/([A-Z]+)([A-Z][a-z])/,''#{1}_#{2}'').gsub(/([a-z\d])([A-Z])/,''#{1}_#{2}'').gsub(/-/,''_'').toLowerCase();
  },

  dasherize: function() {
    return this.gsub(/_/,''-'');
  },

  inspect: function(useDoubleQuotes) {
    var escapedString = this.gsub(/[\x00-\x1f\\]/, function(match) {
      var character = String.specialChar[match[0]];
      return character ? character : ''\\u00'' + match[0].charCodeAt().toPaddedString(2, 16);
    });
    if (useDoubleQuotes) return ''"'' + escapedString.replace(/"/g, ''\\"'') + ''"'';
    return "''" + escapedString.replace(/''/g, ''\\\'''') + "''";
  },

  toJSON: function() {
    return this.inspect(true);
  },

  unfilterJSON: function(filter) {
    return this.sub(filter || Prototype.JSONFilter, ''#{1}'');
  },

  isJSON: function() {
    var str = this;
    if (str.blank()) return false;
    str = this.replace(/\\./g, ''@'').replace(/"[^"\\\n\r]*"/g, '''');
    return (/^[,:{}\[\]0-9.\-+Eaeflnr-u \n\r\t]*$/).test(str);
  },

  evalJSON: function(sanitize) {
    var json = this.unfilterJSON();
    try {
      if (!!sanitize || json.isJSON()) return eval(''('' + json + '')'');
    } catch (e) { }
    throw new SyntaxError(''Badly formed JSON string: '' + this.inspect());
  },

  include: function(pattern) {
    return this.indexOf(pattern) > -1;
  },

  startsWith: function(pattern) {
    return this.indexOf(pattern) === 0;
  },

  endsWith: function(pattern) {
    var d = this.length - pattern.length;
    return d >= 0 && this.lastIndexOf(pattern) === d;
  },

  empty: function() {
    return this == '''';
  },

  blank: function() {
    return /^\s*$/.test(this);
  },

  interpolate: function(object, pattern) {
    return new Template(this, pattern).evaluate(object);
  }
});

if (Prototype.Browser.WebKit || Prototype.Browser.IE) Object.extend(String.prototype, {
  escapeHTML: function() {
    return this.replace(/&/g,''&amp;'').replace(/</g,''&lt;'').replace(/>/g,''&gt;'');
  },
  unescapeHTML: function() {
    return this.stripTags().replace(/&amp;/g,''&'').replace(/&lt;/g,''<'').replace(/&gt;/g,''>'');
  }
});

String.prototype.gsub.prepareReplacement = function(replacement) {
  if (Object.isFunction(replacement)) return replacement;
  var template = new Template(replacement);
  return function(match) { return template.evaluate(match) };
};

String.prototype.parseQuery = String.prototype.toQueryParams;

Object.extend(String.prototype.escapeHTML, {
  div:  document.createElement(''div''),
  text: document.createTextNode('''')
});

String.prototype.escapeHTML.div.appendChild(String.prototype.escapeHTML.text);

var Template = Class.create({
  initialize: function(template, pattern) {
    this.template = template.toString();
    this.pattern = pattern || Template.Pattern;
  },

  evaluate: function(object) {
    if (Object.isFunction(object.toTemplateReplacements))
      object = object.toTemplateReplacements();

    return this.template.gsub(this.pattern, function(match) {
      if (object == null) return '''';

      var before = match[1] || '''';
      if (before == ''\\'') return match[2];

      var ctx = object, expr = match[3];
      var pattern = /^([^.[]+|\[((?:.*?[^\\])?)\])(\.|\[|$)/;
      match = pattern.exec(expr);
      if (match == null) return before;

      while (match !!= null) {
        var comp = match[1].startsWith(''['') ? match[2].gsub(''\\\\]'', '']'') : match[1];
        ctx = ctx[comp];
        if (null == ctx || '''' == match[3]) break;
        expr = expr.substring(''['' == match[3] ? match[1].length : match[0].length);
        match = pattern.exec(expr);
      }

      return before + String.interpret(ctx);
    });
  }
});
Template.Pattern = /(^|.|\r|\n)(#\{(.*?)\})/;

var $break = { };

var Enumerable = {
  each: function(iterator, context) {
    var index = 0;
    try {
      this._each(function(value) {
        iterator.call(context, value, index++);
      });
    } catch (e) {
      if (e !!= $break) throw e;
    }
    return this;
  },

  eachSlice: function(number, iterator, context) {
    var index = -number, slices = [], array = this.toArray();
    if (number < 1) return array;
    while ((index += number) < array.length)
      slices.push(array.slice(index, index+number));
    return slices.collect(iterator, context);
  },

  all: function(iterator, context) {
    iterator = iterator || Prototype.K;
    var result = true;
    this.each(function(value, index) {
      result = result && !!!!iterator.call(context, value, index);
      if (!!result) throw $break;
    });
    return result;
  },

  any: function(iterator, context) {
    iterator = iterator || Prototype.K;
    var result = false;
    this.each(function(value, index) {
      if (result = !!!!iterator.call(context, value, index))
        throw $break;
    });
    return result;
  },

  collect: function(iterator, context) {
    iterator = iterator || Prototype.K;
    var results = [];
    this.each(function(value, index) {
      results.push(iterator.call(context, value, index));
    });
    return results;
  },

  detect: function(iterator, context) {
    var result;
    this.each(function(value, index) {
      if (iterator.call(context, value, index)) {
        result = value;
        throw $break;
      }
    });
    return result;
  },

  findAll: function(iterator, context) {
    var results = [];
    this.each(function(value, index) {
      if (iterator.call(context, value, index))
        results.push(value);
    });
    return results;
  },

  grep: function(filter, iterator, context) {
    iterator = iterator || Prototype.K;
    var results = [];

    if (Object.isString(filter))
      filter = new RegExp(filter);

    this.each(function(value, index) {
      if (filter.match(value))
        results.push(iterator.call(context, value, index));
    });
    return results;
  },

  include: function(object) {
    if (Object.isFunction(this.indexOf))
      if (this.indexOf(object) !!= -1) return true;

    var found = false;
    this.each(function(value) {
      if (value == object) {
        found = true;
        throw $break;
      }
    });
    return found;
  },

  inGroupsOf: function(number, fillWith) {
    fillWith = Object.isUndefined(fillWith) ? null : fillWith;
    return this.eachSlice(number, function(slice) {
      while(slice.length < number) slice.push(fillWith);
      return slice;
    });
  },

  inject: function(memo, iterator, context) {
    this.each(function(value, index) {
      memo = iterator.call(context, memo, value, index);
    });
    return memo;
  },

  invoke: function(method) {
    var args = $A(arguments).slice(1);
    return this.map(function(value) {
      return value[method].apply(value, args);
    });
  },

  max: function(iterator, context) {
    iterator = iterator || Prototype.K;
    var result;
    this.each(function(value, index) {
      value = iterator.call(context, value, index);
      if (result == null || value >= result)
        result = value;
    });
    return result;
  },

  min: function(iterator, context) {
    iterator = iterator || Prototype.K;
    var result;
    this.each(function(value, index) {
      value = iterator.call(context, value, index);
      if (result == null || value < result)
        result = value;
    });
    return result;
  },

  partition: function(iterator, context) {
    iterator = iterator || Prototype.K;
    var trues = [], falses = [];
    this.each(function(value, index) {
      (iterator.call(context, value, index) ?
        trues : falses).push(value);
    });
    return [trues, falses];
  },

  pluck: function(property) {
    var results = [];
    this.each(function(value) {
      results.push(value[property]);
    });
    return results;
  },

  reject: function(iterator, context) {
    var results = [];
    this.each(function(value, index) {
      if (!!iterator.call(context, value, index))
        results.push(value);
    });
    return results;
  },

  sortBy: function(iterator, context) {
    return this.map(function(value, index) {
      return {
        value: value,
        criteria: iterator.call(context, value, index)
      };
    }).sort(function(left, right) {
      var a = left.criteria, b = right.criteria;
      return a < b ? -1 : a > b ? 1 : 0;
    }).pluck(''value'');
  },

  toArray: function() {
    return this.map();
  },

  zip: function() {
    var iterator = Prototype.K, args = $A(arguments);
    if (Object.isFunction(args.last()))
      iterator = args.pop();

    var collections = [this].concat(args).map($A);
    return this.map(function(value, index) {
      return iterator(collections.pluck(index));
    });
  },

  size: function() {
    return this.toArray().length;
  },

  inspect: function() {
    return ''#<Enumerable:'' + this.toArray().inspect() + ''>'';
  }
};

Object.extend(Enumerable, {
  map:     Enumerable.collect,
  find:    Enumerable.detect,
  select:  Enumerable.findAll,
  filter:  Enumerable.findAll,
  member:  Enumerable.include,
  entries: Enumerable.toArray,
  every:   Enumerable.all,
  some:    Enumerable.any
});
function $A(iterable) {
  if (!!iterable) return [];
  if (iterable.toArray) return iterable.toArray();
  var length = iterable.length || 0, results = new Array(length);
  while (length--) results[length] = iterable[length];
  return results;
}

if (Prototype.Browser.WebKit) {
  $A = function(iterable) {
    if (!!iterable) return [];
    // In Safari, only use the `toArray` method if it''s not a NodeList.
    // A NodeList is a function, has an function `item` property, and a numeric
    // `length` property. Adapted from Google Doctype.
    if (!!(typeof iterable === ''function'' && typeof iterable.length ===
        ''number'' && typeof iterable.item === ''function'') && iterable.toArray)
      return iterable.toArray();
    var length = iterable.length || 0, results = new Array(length);
    while (length--) results[length] = iterable[length];
    return results;
  };
}

Array.from = $A;

Object.extend(Array.prototype, Enumerable);

if (!!Array.prototype._reverse) Array.prototype._reverse = Array.prototype.reverse;

Object.extend(Array.prototype, {
  _each: function(iterator) {
    for (var i = 0, length = this.length; i < length; i++)
      iterator(this[i]);
  },

  clear: function() {
    this.length = 0;
    return this;
  },

  first: function() {
    return this[0];
  },

  last: function() {
    return this[this.length - 1];
  },

  compact: function() {
    return this.select(function(value) {
      return value !!= null;
    });
  },

  flatten: function() {
    return this.inject([], function(array, value) {
      return array.concat(Object.isArray(value) ?
        value.flatten() : [value]);
    });
  },

  without: function() {
    var values = $A(arguments);
    return this.select(function(value) {
      return !!values.include(value);
    });
  },

  reverse: function(inline) {
    return (inline !!== false ? this : this.toArray())._reverse();
  },

  reduce: function() {
    return this.length > 1 ? this : this[0];
  },

  uniq: function(sorted) {
    return this.inject([], function(array, value, index) {
      if (0 == index || (sorted ? array.last() !!= value : !!array.include(value)))
        array.push(value);
      return array;
    });
  },

  intersect: function(array) {
    return this.uniq().findAll(function(item) {
      return array.detect(function(value) { return item === value });
    });
  },

  clone: function() {
    return [].concat(this);
  },

  size: function() {
    return this.length;
  },

  inspect: function() {
    return ''['' + this.map(Object.inspect).join('', '') + '']'';
  },

  toJSON: function() {
    var results = [];
    this.each(function(object) {
      var value = Object.toJSON(object);
      if (!!Object.isUndefined(value)) results.push(value);
    });
    return ''['' + results.join('', '') + '']'';
  }
});

// use native browser JS 1.6 implementation if available
if (Object.isFunction(Array.prototype.forEach))
  Array.prototype._each = Array.prototype.forEach;

if (!!Array.prototype.indexOf) Array.prototype.indexOf = function(item, i) {
  i || (i = 0);
  var length = this.length;
  if (i < 0) i = length + i;
  for (; i < length; i++)
    if (this[i] === item) return i;
  return -1;
};

if (!!Array.prototype.lastIndexOf) Array.prototype.lastIndexOf = function(item, i) {
  i = isNaN(i) ? this.length : (i < 0 ? this.length + i : i) + 1;
  var n = this.slice(0, i).reverse().indexOf(item);
  return (n < 0) ? n : i - n - 1;
};

Array.prototype.toArray = Array.prototype.clone;

function $w(string) {
  if (!!Object.isString(string)) return [];
  string = string.strip();
  return string ? string.split(/\s+/) : [];
}

if (Prototype.Browser.Opera){
  Array.prototype.concat = function() {
    var array = [];
    for (var i = 0, length = this.length; i < length; i++) array.push(this[i]);
    for (var i = 0, length = arguments.length; i < length; i++) {
      if (Object.isArray(arguments[i])) {
        for (var j = 0, arrayLength = arguments[i].length; j < arrayLength; j++)
          array.push(arguments[i][j]);
      } else {
        array.push(arguments[i]);
      }
    }
    return array;
  };
}
Object.extend(Number.prototype, {
  toColorPart: function() {
    return this.toPaddedString(2, 16);
  },

  succ: function() {
    return this + 1;
  },

  times: function(iterator, context) {
    $R(0, this, true).each(iterator, context);
    return this;
  },

  toPaddedString: function(length, radix) {
    var string = this.toString(radix || 10);
    return ''0''.times(length - string.length) + string;
  },

  toJSON: function() {
    return isFinite(this) ? this.toString() : ''null'';
  }
});

$w(''abs round ceil floor'').each(function(method){
  Number.prototype[method] = Math[method].methodize();
});
function $H(object) {
  return new Hash(object);
};

var Hash = Class.create(Enumerable, (function() {

  function toQueryPair(key, value) {
    if (Object.isUndefined(value)) return key;
    return key + ''='' + encodeURIComponent(String.interpret(value));
  }

  return {
    initialize: function(object) {
      this._object = Object.isHash(object) ? object.toObject() : Object.clone(object);
    },

    _each: function(iterator) {
      for (var key in this._object) {
        var value = this._object[key], pair = [key, value];
        pair.key = key;
        pair.value = value;
        iterator(pair);
      }
    },

    set: function(key, value) {
      return this._object[key] = value;
    },

    get: function(key) {
      // simulating poorly supported hasOwnProperty
      if (this._object[key] !!== Object.prototype[key])
        return this._object[key];
    },

    unset: function(key) {
      var value = this._object[key];
      delete this._object[key];
      return value;
    },

    toObject: function() {
      return Object.clone(this._object);
    },

    keys: function() {
      return this.pluck(''key'');
    },

    values: function() {
      return this.pluck(''value'');
    },

    index: function(value) {
      var match = this.detect(function(pair) {
        return pair.value === value;
      });
      return match && match.key;
    },

    merge: function(object) {
      return this.clone().update(object);
    },

    update: function(object) {
      return new Hash(object).inject(this, function(result, pair) {
        result.set(pair.key, pair.value);
        return result;
      });
    },

    toQueryString: function() {
      return this.inject([], function(results, pair) {
        var key = encodeURIComponent(pair.key), values = pair.value;

        if (values && typeof values == ''object'') {
          if (Object.isArray(values))
            return results.concat(values.map(toQueryPair.curry(key)));
        } else results.push(toQueryPair(key, values));
        return results;
      }).join(''&'');
    },

    inspect: function() {
      return ''#<Hash:{'' + this.map(function(pair) {
        return pair.map(Object.inspect).join('': '');
      }).join('', '') + ''}>'';
    },

    toJSON: function() {
      return Object.toJSON(this.toObject());
    },

    clone: function() {
      return new Hash(this);
    }
  }
})());

Hash.prototype.toTemplateReplacements = Hash.prototype.toObject;
Hash.from = $H;
var ObjectRange = Class.create(Enumerable, {
  initialize: function(start, end, exclusive) {
    this.start = start;
    this.end = end;
    this.exclusive = exclusive;
  },

  _each: function(iterator) {
    var value = this.start;
    while (this.include(value)) {
      iterator(value);
      value = value.succ();
    }
  },

  include: function(value) {
    if (value < this.start)
      return false;
    if (this.exclusive)
      return value < this.end;
    return value <= this.end;
  }
});

var $R = function(start, end, exclusive) {
  return new ObjectRange(start, end, exclusive);
};

var Ajax = {
  getTransport: function() {
    return Try.these(
      function() {return new XMLHttpRequest()},
      function() {return new ActiveXObject(''Msxml2.XMLHTTP'')},
      function() {return new ActiveXObject(''Microsoft.XMLHTTP'')}
    ) || false;
  },

  activeRequestCount: 0
};

Ajax.Responders = {
  responders: [],

  _each: function(iterator) {
    this.responders._each(iterator);
  },

  register: function(responder) {
    if (!!this.include(responder))
      this.responders.push(responder);
  },

  unregister: function(responder) {
    this.responders = this.responders.without(responder);
  },

  dispatch: function(callback, request, transport, json) {
    this.each(function(responder) {
      if (Object.isFunction(responder[callback])) {
        try {
          responder[callback].apply(responder, [request, transport, json]);
        } catch (e) { }
      }
    });
  }
};

Object.extend(Ajax.Responders, Enumerable);

Ajax.Responders.register({
  onCreate:   function() { Ajax.activeRequestCount++ },
  onComplete: function() { Ajax.activeRequestCount-- }
});

Ajax.Base = Class.create({
  initialize: function(options) {
    this.options = {
      method:       ''post'',
      asynchronous: true,
      contentType:  ''application/x-www-form-urlencoded'',
      encoding:     ''UTF-8'',
      parameters:   '''',
      evalJSON:     true,
      evalJS:       true
    };
    Object.extend(this.options, options || { });

    this.options.method = this.options.method.toLowerCase();

    if (Object.isString(this.options.parameters))
      this.options.parameters = this.options.parameters.toQueryParams();
    else if (Object.isHash(this.options.parameters))
      this.options.parameters = this.options.parameters.toObject();
  }
});

Ajax.Request = Class.create(Ajax.Base, {
  _complete: false,

  initialize: function($super, url, options) {
    $super(options);
    this.transport = Ajax.getTransport();
    this.request(url);
  },

  request: function(url) {
    this.url = url;
    this.method = this.options.method;
    var params = Object.clone(this.options.parameters);

    if (!![''get'', ''post''].include(this.method)) {
      // simulate other verbs over post
      params[''_method''] = this.method;
      this.method = ''post'';
    }

    this.parameters = params;

    if (params = Object.toQueryString(params)) {
      // when GET, append parameters to URL
      if (this.method == ''get'')
        this.url += (this.url.include(''?'') ? ''&'' : ''?'') + params;
      else if (/Konqueror|Safari|KHTML/.test(navigator.userAgent))
        params += ''&_='';
    }

    try {
      var response = new Ajax.Response(this);
      if (this.options.onCreate) this.options.onCreate(response);
      Ajax.Responders.dispatch(''onCreate'', this, response);

      this.transport.open(this.method.toUpperCase(), this.url,
        this.options.asynchronous);

      if (this.options.asynchronous) this.respondToReadyState.bind(this).defer(1);

      this.transport.onreadystatechange = this.onStateChange.bind(this);
      this.setRequestHeaders();

      this.body = this.method == ''post'' ? (this.options.postBody || params) : null;
      this.transport.send(this.body);

      /* Force Firefox to handle ready state 4 for synchronous requests */
      if (!!this.options.asynchronous && this.transport.overrideMimeType)
        this.onStateChange();

    }
    catch (e) {
      this.dispatchException(e);
    }
  },

  onStateChange: function() {
    var readyState = this.transport.readyState;
    if (readyState > 1 && !!((readyState == 4) && this._complete))
      this.respondToReadyState(this.transport.readyState);
  },

  setRequestHeaders: function() {
    var headers = {
      ''X-Requested-With'': ''XMLHttpRequest'',
      ''X-Prototype-Version'': Prototype.Version,
      ''Accept'': ''text/javascript, text/html, application/xml, text/xml, */*''
    };

    if (this.method == ''post'') {
      headers[''Content-type''] = this.options.contentType +
        (this.options.encoding ? ''; charset='' + this.options.encoding : '''');

      /* Force "Connection: close" for older Mozilla browsers to work
       * around a bug where XMLHttpRequest sends an incorrect
       * Content-length header. See Mozilla Bugzilla #246651.
       */
      if (this.transport.overrideMimeType &&
          (navigator.userAgent.match(/Gecko\/(\d{4})/) || [0,2005])[1] < 2005)
            headers[''Connection''] = ''close'';
    }

    // user-defined headers
    if (typeof this.options.requestHeaders == ''object'') {
      var extras = this.options.requestHeaders;

      if (Object.isFunction(extras.push))
        for (var i = 0, length = extras.length; i < length; i += 2)
          headers[extras[i]] = extras[i+1];
      else
        $H(extras).each(function(pair) { headers[pair.key] = pair.value });
    }

    for (var name in headers)
      this.transport.setRequestHeader(name, headers[name]);
  },

  success: function() {
    var status = this.getStatus();
    return !!status || (status >= 200 && status < 300);
  },

  getStatus: function() {
    try {
      return this.transport.status || 0;
    } catch (e) { return 0 }
  },

  respondToReadyState: function(readyState) {
    var state = Ajax.Request.Events[readyState], response = new Ajax.Response(this);

    if (state == ''Complete'') {
      try {
        this._complete = true;
        (this.options[''on'' + response.status]
         || this.options[''on'' + (this.success() ? ''Success'' : ''Failure'')]
         || Prototype.emptyFunction)(response, response.headerJSON);
      } catch (e) {
        this.dispatchException(e);
      }

      var contentType = response.getHeader(''Content-type'');
      if (this.options.evalJS == ''force''
          || (this.options.evalJS && this.isSameOrigin() && contentType
          && contentType.match(/^\s*(text|application)\/(x-)?(java|ecma)script(;.*)?\s*$/i)))
        this.evalResponse();
    }

    try {
      (this.options[''on'' + state] || Prototype.emptyFunction)(response, response.headerJSON);
      Ajax.Responders.dispatch(''on'' + state, this, response, response.headerJSON);
    } catch (e) {
      this.dispatchException(e);
    }

    if (state == ''Complete'') {
      // avoid memory leak in MSIE: clean up
      this.transport.onreadystatechange = Prototype.emptyFunction;
    }
  },

  isSameOrigin: function() {
    var m = this.url.match(/^\s*https?:\/\/[^\/]*/);
    return !!m || (m[0] == ''#{protocol}//#{domain}#{port}''.interpolate({
      protocol: location.protocol,
      domain: document.domain,
      port: location.port ? '':'' + location.port : ''''
    }));
  },

  getHeader: function(name) {
    try {
      return this.transport.getResponseHeader(name) || null;
    } catch (e) { return null }
  },

  evalResponse: function() {
    try {
      return eval((this.transport.responseText || '''').unfilterJSON());
    } catch (e) {
      this.dispatchException(e);
    }
  },

  dispatchException: function(exception) {
    (this.options.onException || Prototype.emptyFunction)(this, exception);
    Ajax.Responders.dispatch(''onException'', this, exception);
  }
});

Ajax.Request.Events =
  [''Uninitialized'', ''Loading'', ''Loaded'', ''Interactive'', ''Complete''];

Ajax.Response = Class.create({
  initialize: function(request){
    this.request = request;
    var transport  = this.transport  = request.transport,
        readyState = this.readyState = transport.readyState;

    if((readyState > 2 && !!Prototype.Browser.IE) || readyState == 4) {
      this.status       = this.getStatus();
      this.statusText   = this.getStatusText();
      this.responseText = String.interpret(transport.responseText);
      this.headerJSON   = this._getHeaderJSON();
    }

    if(readyState == 4) {
      var xml = transport.responseXML;
      this.responseXML  = Object.isUndefined(xml) ? null : xml;
      this.responseJSON = this._getResponseJSON();
    }
  },

  status:      0,
  statusText: '''',

  getStatus: Ajax.Request.prototype.getStatus,

  getStatusText: function() {
    try {
      return this.transport.statusText || '''';
    } catch (e) { return '''' }
  },

  getHeader: Ajax.Request.prototype.getHeader,

  getAllHeaders: function() {
    try {
      return this.getAllResponseHeaders();
    } catch (e) { return null }
  },

  getResponseHeader: function(name) {
    return this.transport.getResponseHeader(name);
  },

  getAllResponseHeaders: function() {
    return this.transport.getAllResponseHeaders();
  },

  _getHeaderJSON: function() {
    var json = this.getHeader(''X-JSON'');
    if (!!json) return null;
    json = decodeURIComponent(escape(json));
    try {
      return json.evalJSON(this.request.options.sanitizeJSON ||
        !!this.request.isSameOrigin());
    } catch (e) {
      this.request.dispatchException(e);
    }
  },

  _getResponseJSON: function() {
    var options = this.request.options;
    if (!!options.evalJSON || (options.evalJSON !!= ''force'' &&
      !!(this.getHeader(''Content-type'') || '''').include(''application/json'')) ||
        this.responseText.blank())
          return null;
    try {
      return this.responseText.evalJSON(options.sanitizeJSON ||
        !!this.request.isSameOrigin());
    } catch (e) {
      this.request.dispatchException(e);
    }
  }
});

Ajax.Updater = Class.create(Ajax.Request, {
  initialize: function($super, container, url, options) {
    this.container = {
      success: (container.success || container),
      failure: (container.failure || (container.success ? null : container))
    };

    options = Object.clone(options);
    var onComplete = options.onComplete;
    options.onComplete = (function(response, json) {
      this.updateContent(response.responseText);
      if (Object.isFunction(onComplete)) onComplete(response, json);
    }).bind(this);

    $super(url, options);
  },

  updateContent: function(responseText) {
    var receiver = this.container[this.success() ? ''success'' : ''failure''],
        options = this.options;

    if (!!options.evalScripts) responseText = responseText.stripScripts();

    if (receiver = $(receiver)) {
      if (options.insertion) {
        if (Object.isString(options.insertion)) {
          var insertion = { }; insertion[options.insertion] = responseText;
          receiver.insert(insertion);
        }
        else options.insertion(receiver, responseText);
      }
      else receiver.update(responseText);
    }
  }
});

Ajax.PeriodicalUpdater = Class.create(Ajax.Base, {
  initialize: function($super, container, url, options) {
    $super(options);
    this.onComplete = this.options.onComplete;

    this.frequency = (this.options.frequency || 2);
    this.decay = (this.options.decay || 1);

    this.updater = { };
    this.container = container;
    this.url = url;

    this.start();
  },

  start: function() {
    this.options.onComplete = this.updateComplete.bind(this);
    this.onTimerEvent();
  },

  stop: function() {
    this.updater.options.onComplete = undefined;
    clearTimeout(this.timer);
    (this.onComplete || Prototype.emptyFunction).apply(this, arguments);
  },

  updateComplete: function(response) {
    if (this.options.decay) {
      this.decay = (response.responseText == this.lastText ?
        this.decay * this.options.decay : 1);

      this.lastText = response.responseText;
    }
    this.timer = this.onTimerEvent.bind(this).delay(this.decay * this.frequency);
  },

  onTimerEvent: function() {
    this.updater = new Ajax.Updater(this.container, this.url, this.options);
  }
});
function $(element) {
  if (arguments.length > 1) {
    for (var i = 0, elements = [], length = arguments.length; i < length; i++)
      elements.push($(arguments[i]));
    return elements;
  }
  if (Object.isString(element))
    element = document.getElementById(element);
  return Element.extend(element);
}

if (Prototype.BrowserFeatures.XPath) {
  document._getElementsByXPath = function(expression, parentElement) {
    var results = [];
    var query = document.evaluate(expression, $(parentElement) || document,
      null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
    for (var i = 0, length = query.snapshotLength; i < length; i++)
      results.push(Element.extend(query.snapshotItem(i)));
    return results;
  };
}

/*--------------------------------------------------------------------------*/

if (!!window.Node) var Node = { };

if (!!Node.ELEMENT_NODE) {
  // DOM level 2 ECMAScript Language Binding
  Object.extend(Node, {
    ELEMENT_NODE: 1,
    ATTRIBUTE_NODE: 2,
    TEXT_NODE: 3,
    CDATA_SECTION_NODE: 4,
    ENTITY_REFERENCE_NODE: 5,
    ENTITY_NODE: 6,
    PROCESSING_INSTRUCTION_NODE: 7,
    COMMENT_NODE: 8,
    DOCUMENT_NODE: 9,
    DOCUMENT_TYPE_NODE: 10,
    DOCUMENT_FRAGMENT_NODE: 11,
    NOTATION_NODE: 12
  });
}

(function() {
  var element = this.Element;
  this.Element = function(tagName, attributes) {
    attributes = attributes || { };
    tagName = tagName.toLowerCase();
    var cache = Element.cache;
    if (Prototype.Browser.IE && attributes.name) {
      tagName = ''<'' + tagName + '' name="'' + attributes.name + ''">'';
      delete attributes.name;
      return Element.writeAttribute(document.createElement(tagName), attributes);
    }
    if (!!cache[tagName]) cache[tagName] = Element.extend(document.createElement(tagName));
    return Element.writeAttribute(cache[tagName].cloneNode(false), attributes);
  };
  Object.extend(this.Element, element || { });
  if (element) this.Element.prototype = element.prototype;
}).call(window);

Element.cache = { };

Element.Methods = {
  visible: function(element) {
    return $(element).style.display !!= ''none'';
  },

  toggle: function(element) {
    element = $(element);
    Element[Element.visible(element) ? ''hide'' : ''show''](element);
    return element;
  },

  hide: function(element) {
    element = $(element);
    element.style.display = ''none'';
    return element;
  },

  show: function(element) {
    element = $(element);
    element.style.display = '''';
    return element;
  },

  remove: function(element) {
    element = $(element);
    element.parentNode.removeChild(element);
    return element;
  },

  update: function(element, content) {
    element = $(element);
    if (content && content.toElement) content = content.toElement();
    if (Object.isElement(content)) return element.update().insert(content);
    content = Object.toHTML(content);
    element.innerHTML = content.stripScripts();
    content.evalScripts.bind(content).defer();
    return element;
  },

  replace: function(element, content) {
    element = $(element);
    if (content && content.toElement) content = content.toElement();
    else if (!!Object.isElement(content)) {
      content = Object.toHTML(content);
      var range = element.ownerDocument.createRange();
      range.selectNode(element);
      content.evalScripts.bind(content).defer();
      content = range.createContextualFragment(content.stripScripts());
    }
    element.parentNode.replaceChild(content, element);
    return element;
  },

  insert: function(element, insertions) {
    element = $(element);

    if (Object.isString(insertions) || Object.isNumber(insertions) ||
        Object.isElement(insertions) || (insertions && (insertions.toElement || insertions.toHTML)))
          insertions = {bottom:insertions};

    var content, insert, tagName, childNodes;

    for (var position in insertions) {
      content  = insertions[position];
      position = position.toLowerCase();
      insert = Element._insertionTranslations[position];

      if (content && content.toElement) content = content.toElement();
      if (Object.isElement(content)) {
        insert(element, content);
        continue;
      }

      content = Object.toHTML(content);

      tagName = ((position == ''before'' || position == ''after'')
        ? element.parentNode : element).tagName.toUpperCase();

      childNodes = Element._getContentFromAnonymousElement(tagName, content.stripScripts());

      if (position == ''top'' || position == ''after'') childNodes.reverse();
      childNodes.each(insert.curry(element));

      content.evalScripts.bind(content).defer();
    }

    return element;
  },

  wrap: function(element, wrapper, attributes) {
    element = $(element);
    if (Object.isElement(wrapper))
      $(wrapper).writeAttribute(attributes || { });
    else if (Object.isString(wrapper)) wrapper = new Element(wrapper, attributes);
    else wrapper = new Element(''div'', wrapper);
    if (element.parentNode)
      element.parentNode.replaceChild(wrapper, element);
    wrapper.appendChild(element);
    return wrapper;
  },

  inspect: function(element) {
    element = $(element);
    var result = ''<'' + element.tagName.toLowerCase();
    $H({''id'': ''id'', ''className'': ''class''}).each(function(pair) {
      var property = pair.first(), attribute = pair.last();
      var value = (element[property] || '''').toString();
      if (value) result += '' '' + attribute + ''='' + value.inspect(true);
    });
    return result + ''>'';
  },

  recursivelyCollect: function(element, property) {
    element = $(element);
    var elements = [];
    while (element = element[property])
      if (element.nodeType == 1)
        elements.push(Element.extend(element));
    return elements;
  },

  ancestors: function(element) {
    return $(element).recursivelyCollect(''parentNode'');
  },

  descendants: function(element) {
    return $(element).select("*");
  },

  firstDescendant: function(element) {
    element = $(element).firstChild;
    while (element && element.nodeType !!= 1) element = element.nextSibling;
    return $(element);
  },

  immediateDescendants: function(element) {
    if (!!(element = $(element).firstChild)) return [];
    while (element && element.nodeType !!= 1) element = element.nextSibling;
    if (element) return [element].concat($(element).nextSiblings());
    return [];
  },

  previousSiblings: function(element) {
    return $(element).recursivelyCollect(''previousSibling'');
  },

  nextSiblings: function(element) {
    return $(element).recursivelyCollect(''nextSibling'');
  },

  siblings: function(element) {
    element = $(element);
    return element.previousSiblings().reverse().concat(element.nextSiblings());
  },

  match: function(element, selector) {
    if (Object.isString(selector))
      selector = new Selector(selector);
    return selector.match($(element));
  },

  up: function(element, expression, index) {
    element = $(element);
    if (arguments.length == 1) return $(element.parentNode);
    var ancestors = element.ancestors();
    return Object.isNumber(expression) ? ancestors[expression] :
      Selector.findElement(ancestors, expression, index);
  },

  down: function(element, expression, index) {
    element = $(element);
    if (arguments.length == 1) return element.firstDescendant();
    return Object.isNumber(expression) ? element.descendants()[expression] :
      Element.select(element, expression)[index || 0];
  },

  previous: function(element, expression, index) {
    element = $(element);
    if (arguments.length == 1) return $(Selector.handlers.previousElementSibling(element));
    var previousSiblings = element.previousSiblings();
    return Object.isNumber(expression) ? previousSiblings[expression] :
      Selector.findElement(previousSiblings, expression, index);
  },

  next: function(element, expression, index) {
    element = $(element);
    if (arguments.length == 1) return $(Selector.handlers.nextElementSibling(element));
    var nextSiblings = element.nextSiblings();
    return Object.isNumber(expression) ? nextSiblings[expression] :
      Selector.findElement(nextSiblings, expression, index);
  },

  select: function() {
    var args = $A(arguments), element = $(args.shift());
    return Selector.findChildElements(element, args);
  },

  adjacent: function() {
    var args = $A(arguments), element = $(args.shift());
    return Selector.findChildElements(element.parentNode, args).without(element);
  },

  identify: function(element) {
    element = $(element);
    var id = element.readAttribute(''id''), self = arguments.callee;
    if (id) return id;
    do { id = ''anonymous_element_'' + self.counter++ } while ($(id));
    element.writeAttribute(''id'', id);
    return id;
  },

  readAttribute: function(element, name) {
    element = $(element);
    if (Prototype.Browser.IE) {
      var t = Element._attributeTranslations.read;
      if (t.values[name]) return t.values[name](element, name);
      if (t.names[name]) name = t.names[name];
      if (name.include('':'')) {
        return (!!element.attributes || !!element.attributes[name]) ? null :
         element.attributes[name].value;
      }
    }
    return element.getAttribute(name);
  },

  writeAttribute: function(element, name, value) {
    element = $(element);
    var attributes = { }, t = Element._attributeTranslations.write;

    if (typeof name == ''object'') attributes = name;
    else attributes[name] = Object.isUndefined(value) ? true : value;

    for (var attr in attributes) {
      name = t.names[attr] || attr;
      value = attributes[attr];
      if (t.values[attr]) name = t.values[attr](element, value);
      if (value === false || value === null)
        element.removeAttribute(name);
      else if (value === true)
        element.setAttribute(name, name);
      else element.setAttribute(name, value);
    }
    return element;
  },

  getHeight: function(element) {
    return $(element).getDimensions().height;
  },

  getWidth: function(element) {
    return $(element).getDimensions().width;
  },

  classNames: function(element) {
    return new Element.ClassNames(element);
  },

  hasClassName: function(element, className) {
    if (!!(element = $(element))) return;
    var elementClassName = element.className;
    return (elementClassName.length > 0 && (elementClassName == className ||
      new RegExp("(^|\\s)" + className + "(\\s|$)").test(elementClassName)));
  },

  addClassName: function(element, className) {
    if (!!(element = $(element))) return;
    if (!!element.hasClassName(className))
      element.className += (element.className ? '' '' : '''') + className;
    return element;
  },

  removeClassName: function(element, className) {
    if (!!(element = $(element))) return;
    element.className = element.className.replace(
      new RegExp("(^|\\s+)" + className + "(\\s+|$)"), '' '').strip();
    return element;
  },

  toggleClassName: function(element, className) {
    if (!!(element = $(element))) return;
    return element[element.hasClassName(className) ?
      ''removeClassName'' : ''addClassName''](className);
  },

  // removes whitespace-only text node children
  cleanWhitespace: function(element) {
    element = $(element);
    var node = element.firstChild;
    while (node) {
      var nextNode = node.nextSibling;
      if (node.nodeType == 3 && !!/\S/.test(node.nodeValue))
        element.removeChild(node);
      node = nextNode;
    }
    return element;
  },

  empty: function(element) {
    return $(element).innerHTML.blank();
  },

  descendantOf: function(element, ancestor) {
    element = $(element), ancestor = $(ancestor);

    if (element.compareDocumentPosition)
      return (element.compareDocumentPosition(ancestor) & 8) === 8;

    if (ancestor.contains)
      return ancestor.contains(element) && ancestor !!== element;

    while (element = element.parentNode)
      if (element == ancestor) return true;

    return false;
  },

  scrollTo: function(element) {
    element = $(element);
    var pos = element.cumulativeOffset();
    window.scrollTo(pos[0], pos[1]);
    return element;
  },

  getStyle: function(element, style) {
    element = $(element);
    style = style == ''float'' ? ''cssFloat'' : style.camelize();
    var value = element.style[style];
    if (!!value || value == ''auto'') {
      var css = document.defaultView.getComputedStyle(element, null);
      value = css ? css[style] : null;
    }
    if (style == ''opacity'') return value ? parseFloat(value) : 1.0;
    return value == ''auto'' ? null : value;
  },

  getOpacity: function(element) {
    return $(element).getStyle(''opacity'');
  },

  setStyle: function(element, styles) {
    element = $(element);
    var elementStyle = element.style, match;
    if (Object.isString(styles)) {
      element.style.cssText += '';'' + styles;
      return styles.include(''opacity'') ?
        element.setOpacity(styles.match(/opacity:\s*(\d?\.?\d*)/)[1]) : element;
    }
    for (var property in styles)
      if (property == ''opacity'') element.setOpacity(styles[property]);
      else
        elementStyle[(property == ''float'' || property == ''cssFloat'') ?
          (Object.isUndefined(elementStyle.styleFloat) ? ''cssFloat'' : ''styleFloat'') :
            property] = styles[property];

    return element;
  },

  setOpacity: function(element, value) {
    element = $(element);
    element.style.opacity = (value == 1 || value === '''') ? '''' :
      (value < 0.00001) ? 0 : value;
    return element;
  },

  getDimensions: function(element) {
    element = $(element);
    var display = element.getStyle(''display'');
    if (display !!= ''none'' && display !!= null) // Safari bug
      return {width: element.offsetWidth, height: element.offsetHeight};

    // All *Width and *Height properties give 0 on elements with display none,
    // so enable the element temporarily
    var els = element.style;
    var originalVisibility = els.visibility;
    var originalPosition = els.position;
    var originalDisplay = els.display;
    els.visibility = ''hidden'';
    els.position = ''absolute'';
    els.display = ''block'';
    var originalWidth = element.clientWidth;
    var originalHeight = element.clientHeight;
    els.display = originalDisplay;
    els.position = originalPosition;
    els.visibility = originalVisibility;
    return {width: originalWidth, height: originalHeight};
  },

  makePositioned: function(element) {
    element = $(element);
    var pos = Element.getStyle(element, ''position'');
    if (pos == ''static'' || !!pos) {
      element._madePositioned = true;
      element.style.position = ''relative'';
      // Opera returns the offset relative to the positioning context, when an
      // element is position relative but top and left have not been defined
      if (Prototype.Browser.Opera) {
        element.style.top = 0;
        element.style.left = 0;
      }
    }
    return element;
  },

  undoPositioned: function(element) {
    element = $(element);
    if (element._madePositioned) {
      element._madePositioned = undefined;
      element.style.position =
        element.style.top =
        element.style.left =
        element.style.bottom =
        element.style.right = '''';
    }
    return element;
  },

  makeClipping: function(element) {
    element = $(element);
    if (element._overflow) return element;
    element._overflow = Element.getStyle(element, ''overflow'') || ''auto'';
    if (element._overflow !!== ''hidden'')
      element.style.overflow = ''hidden'';
    return element;
  },

  undoClipping: function(element) {
    element = $(element);
    if (!!element._overflow) return element;
    element.style.overflow = element._overflow == ''auto'' ? '''' : element._overflow;
    element._overflow = null;
    return element;
  },

  cumulativeOffset: function(element) {
    var valueT = 0, valueL = 0;
    do {
      valueT += element.offsetTop  || 0;
      valueL += element.offsetLeft || 0;
      element = element.offsetParent;
    } while (element);
    return Element._returnOffset(valueL, valueT);
  },

  positionedOffset: function(element) {
    var valueT = 0, valueL = 0;
    do {
      valueT += element.offsetTop  || 0;
      valueL += element.offsetLeft || 0;
      element = element.offsetParent;
      if (element) {
        if (element.tagName.toUpperCase() == ''BODY'') break;
        var p = Element.getStyle(element, ''position'');
        if (p !!== ''static'') break;
      }
    } while (element);
    return Element._returnOffset(valueL, valueT);
  },

  absolutize: function(element) {
    element = $(element);
    if (element.getStyle(''position'') == ''absolute'') return element;
    // Position.prepare(); // To be done manually by Scripty when it needs it.

    var offsets = element.positionedOffset();
    var top     = offsets[1];
    var left    = offsets[0];
    var width   = element.clientWidth;
    var height  = element.clientHeight;

    element._originalLeft   = left - parseFloat(element.style.left  || 0);
    element._originalTop    = top  - parseFloat(element.style.top || 0);
    element._originalWidth  = element.style.width;
    element._originalHeight = element.style.height;

    element.style.position = ''absolute'';
    element.style.top    = top + ''px'';
    element.style.left   = left + ''px'';
    element.style.width  = width + ''px'';
    element.style.height = height + ''px'';
    return element;
  },

  relativize: function(element) {
    element = $(element);
    if (element.getStyle(''position'') == ''relative'') return element;
    // Position.prepare(); // To be done manually by Scripty when it needs it.

    element.style.position = ''relative'';
    var top  = parseFloat(element.style.top  || 0) - (element._originalTop || 0);
    var left = parseFloat(element.style.left || 0) - (element._originalLeft || 0);

    element.style.top    = top + ''px'';
    element.style.left   = left + ''px'';
    element.style.height = element._originalHeight;
    element.style.width  = element._originalWidth;
    return element;
  },

  cumulativeScrollOffset: function(element) {
    var valueT = 0, valueL = 0;
    do {
      valueT += element.scrollTop  || 0;
      valueL += element.scrollLeft || 0;
      element = element.parentNode;
    } while (element);
    return Element._returnOffset(valueL, valueT);
  },

  getOffsetParent: function(element) {
    if (element.offsetParent) return $(element.offsetParent);
    if (element == document.body) return $(element);

    while ((element = element.parentNode) && element !!= document.body)
      if (Element.getStyle(element, ''position'') !!= ''static'')
        return $(element);

    return $(document.body);
  },

  viewportOffset: function(forElement) {
    var valueT = 0, valueL = 0;

    var element = forElement;
    do {
      valueT += element.offsetTop  || 0;
      valueL += element.offsetLeft || 0;

      // Safari fix
      if (element.offsetParent == document.body &&
        Element.getStyle(element, ''position'') == ''absolute'') break;

    } while (element = element.offsetParent);

    element = forElement;
    do {
      if (!!Prototype.Browser.Opera || (element.tagName && (element.tagName.toUpperCase() == ''BODY''))) {
        valueT -= element.scrollTop  || 0;
        valueL -= element.scrollLeft || 0;
      }
    } while (element = element.parentNode);

    return Element._returnOffset(valueL, valueT);
  },

  clonePosition: function(element, source) {
    var options = Object.extend({
      setLeft:    true,
      setTop:     true,
      setWidth:   true,
      setHeight:  true,
      offsetTop:  0,
      offsetLeft: 0
    }, arguments[2] || { });

    // find page position of source
    source = $(source);
    var p = source.viewportOffset();

    // find coordinate system to use
    element = $(element);
    var delta = [0, 0];
    var parent = null;
    // delta [0,0] will do fine with position: fixed elements,
    // position:absolute needs offsetParent deltas
    if (Element.getStyle(element, ''position'') == ''absolute'') {
      parent = element.getOffsetParent();
      delta = parent.viewportOffset();
    }

    // correct by body offsets (fixes Safari)
    if (parent == document.body) {
      delta[0] -= document.body.offsetLeft;
      delta[1] -= document.body.offsetTop;
    }

    // set position
    if (options.setLeft)   element.style.left  = (p[0] - delta[0] + options.offsetLeft) + ''px'';
    if (options.setTop)    element.style.top   = (p[1] - delta[1] + options.offsetTop) + ''px'';
    if (options.setWidth)  element.style.width = source.offsetWidth + ''px'';
    if (options.setHeight) element.style.height = source.offsetHeight + ''px'';
    return element;
  }
};

Element.Methods.identify.counter = 1;

Object.extend(Element.Methods, {
  getElementsBySelector: Element.Methods.select,
  childElements: Element.Methods.immediateDescendants
});

Element._attributeTranslations = {
  write: {
    names: {
      className: ''class'',
      htmlFor:   ''for''
    },
    values: { }
  }
};

if (Prototype.Browser.Opera) {
  Element.Methods.getStyle = Element.Methods.getStyle.wrap(
    function(proceed, element, style) {
      switch (style) {
        case ''left'': case ''top'': case ''right'': case ''bottom'':
          if (proceed(element, ''position'') === ''static'') return null;
        case ''height'': case ''width'':
          // returns ''0px'' for hidden elements; we want it to return null
          if (!!Element.visible(element)) return null;

          // returns the border-box dimensions rather than the content-box
          // dimensions, so we subtract padding and borders from the value
          var dim = parseInt(proceed(element, style), 10);

          if (dim !!== element[''offset'' + style.capitalize()])
            return dim + ''px'';

          var properties;
          if (style === ''height'') {
            properties = [''border-top-width'', ''padding-top'',
             ''padding-bottom'', ''border-bottom-width''];
          }
          else {
            properties = [''border-left-width'', ''padding-left'',
             ''padding-right'', ''border-right-width''];
          }
          return properties.inject(dim, function(memo, property) {
            var val = proceed(element, property);
            return val === null ? memo : memo - parseInt(val, 10);
          }) + ''px'';
        default: return proceed(element, style);
      }
    }
  );

  Element.Methods.readAttribute = Element.Methods.readAttribute.wrap(
    function(proceed, element, attribute) {
      if (attribute === ''title'') return element.title;
      return proceed(element, attribute);
    }
  );
}

else if (Prototype.Browser.IE) {
  // IE doesn''t report offsets correctly for static elements, so we change them
  // to "relative" to get the values, then change them back.
  Element.Methods.getOffsetParent = Element.Methods.getOffsetParent.wrap(
    function(proceed, element) {
      element = $(element);
      // IE throws an error if element is not in document
      try { element.offsetParent }
      catch(e) { return $(document.body) }
      var position = element.getStyle(''position'');
      if (position !!== ''static'') return proceed(element);
      element.setStyle({ position: ''relative'' });
      var value = proceed(element);
      element.setStyle({ position: position });
      return value;
    }
  );

  $w(''positionedOffset viewportOffset'').each(function(method) {
    Element.Methods[method] = Element.Methods[method].wrap(
      function(proceed, element) {
        element = $(element);
        try { element.offsetParent }
        catch(e) { return Element._returnOffset(0,0) }
        var position = element.getStyle(''position'');
        if (position !!== ''static'') return proceed(element);
        // Trigger hasLayout on the offset parent so that IE6 reports
        // accurate offsetTop and offsetLeft values for position: fixed.
        var offsetParent = element.getOffsetParent();
        if (offsetParent && offsetParent.getStyle(''position'') === ''fixed'')
          offsetParent.setStyle({ zoom: 1 });
        element.setStyle({ position: ''relative'' });
        var value = proceed(element);
        element.setStyle({ position: position });
        return value;
      }
    );
  });

  Element.Methods.cumulativeOffset = Element.Methods.cumulativeOffset.wrap(
    function(proceed, element) {
      try { element.offsetParent }
      catch(e) { return Element._returnOffset(0,0) }
      return proceed(element);
    }
  );

  Element.Methods.getStyle = function(element, style) {
    element = $(element);
    style = (style == ''float'' || style == ''cssFloat'') ? ''styleFloat'' : style.camelize();
    var value = element.style[style];
    if (!!value && element.currentStyle) value = element.currentStyle[style];

    if (style == ''opacity'') {
      if (value = (element.getStyle(''filter'') || '''').match(/alpha\(opacity=(.*)\)/))
        if (value[1]) return parseFloat(value[1]) / 100;
      return 1.0;
    }

    if (value == ''auto'') {
      if ((style == ''width'' || style == ''height'') && (element.getStyle(''display'') !!= ''none''))
        return element[''offset'' + style.capitalize()] + ''px'';
      return null;
    }
    return value;
  };

  Element.Methods.setOpacity = function(element, value) {
    function stripAlpha(filter){
      return filter.replace(/alpha\([^\)]*\)/gi,'''');
    }
    element = $(element);
    var currentStyle = element.currentStyle;
    if ((currentStyle && !!currentStyle.hasLayout) ||
      (!!currentStyle && element.style.zoom == ''normal''))
        element.style.zoom = 1;

    var filter = element.getStyle(''filter''), style = element.style;
    if (value == 1 || value === '''') {
      (filter = stripAlpha(filter)) ?
        style.filter = filter : style.removeAttribute(''filter'');
      return element;
    } else if (value < 0.00001) value = 0;
    style.filter = stripAlpha(filter) +
      ''alpha(opacity='' + (value * 100) + '')'';
    return element;
  };

  Element._attributeTranslations = {
    read: {
      names: {
        ''class'': ''className'',
        ''for'':   ''htmlFor''
      },
      values: {
        _getAttr: function(element, attribute) {
          return element.getAttribute(attribute, 2);
        },
        _getAttrNode: function(element, attribute) {
          var node = element.getAttributeNode(attribute);
          return node ? node.value : "";
        },
        _getEv: function(element, attribute) {
          attribute = element.getAttribute(attribute);
          return attribute ? attribute.toString().slice(23, -2) : null;
        },
        _flag: function(element, attribute) {
          return $(element).hasAttribute(attribute) ? attribute : null;
        },
        style: function(element) {
          return element.style.cssText.toLowerCase();
        },
        title: function(element) {
          return element.title;
        }
      }
    }
  };

  Element._attributeTranslations.write = {
    names: Object.extend({
      cellpadding: ''cellPadding'',
      cellspacing: ''cellSpacing''
    }, Element._attributeTranslations.read.names),
    values: {
      checked: function(element, value) {
        element.checked = !!!!value;
      },

      style: function(element, value) {
        element.style.cssText = value ? value : '''';
      }
    }
  };

  Element._attributeTranslations.has = {};

  $w(''colSpan rowSpan vAlign dateTime accessKey tabIndex '' +
      ''encType maxLength readOnly longDesc frameBorder'').each(function(attr) {
    Element._attributeTranslations.write.names[attr.toLowerCase()] = attr;
    Element._attributeTranslations.has[attr.toLowerCase()] = attr;
  });

  (function(v) {
    Object.extend(v, {
      href:        v._getAttr,
      src:         v._getAttr,
      type:        v._getAttr,
      action:      v._getAttrNode,
      disabled:    v._flag,
      checked:     v._flag,
      readonly:    v._flag,
      multiple:    v._flag,
      onload:      v._getEv,
      onunload:    v._getEv,
      onclick:     v._getEv,
      ondblclick:  v._getEv,
      onmousedown: v._getEv,
      onmouseup:   v._getEv,
      onmouseover: v._getEv,
      onmousemove: v._getEv,
      onmouseout:  v._getEv,
      onfocus:     v._getEv,
      onblur:      v._getEv,
      onkeypress:  v._getEv,
      onkeydown:   v._getEv,
      onkeyup:     v._getEv,
      onsubmit:    v._getEv,
      onreset:     v._getEv,
      onselect:    v._getEv,
      onchange:    v._getEv
    });
  })(Element._attributeTranslations.read.values);
}

else if (Prototype.Browser.Gecko && /rv:1\.8\.0/.test(navigator.userAgent)) {
  Element.Methods.setOpacity = function(element, value) {
    element = $(element);
    element.style.opacity = (value == 1) ? 0.999999 :
      (value === '''') ? '''' : (value < 0.00001) ? 0 : value;
    return element;
  };
}

else if (Prototype.Browser.WebKit) {
  Element.Methods.setOpacity = function(element, value) {
    element = $(element);
    element.style.opacity = (value == 1 || value === '''') ? '''' :
      (value < 0.00001) ? 0 : value;

    if (value == 1)
      if(element.tagName.toUpperCase() == ''IMG'' && element.width) {
        element.width++; element.width--;
      } else try {
        var n = document.createTextNode('' '');
        element.appendChild(n);
        element.removeChild(n);
      } catch (e) { }

    return element;
  };

  // Safari returns margins on body which is incorrect if the child is absolutely
  // positioned.  For performance reasons, redefine Element#cumulativeOffset for
  // KHTML/WebKit only.
  Element.Methods.cumulativeOffset = function(element) {
    var valueT = 0, valueL = 0;
    do {
      valueT += element.offsetTop  || 0;
      valueL += element.offsetLeft || 0;
      if (element.offsetParent == document.body)
        if (Element.getStyle(element, ''position'') == ''absolute'') break;

      element = element.offsetParent;
    } while (element);

    return Element._returnOffset(valueL, valueT);
  };
}

if (Prototype.Browser.IE || Prototype.Browser.Opera) {
  // IE and Opera are missing .innerHTML support for TABLE-related and SELECT elements
  Element.Methods.update = function(element, content) {
    element = $(element);

    if (content && content.toElement) content = content.toElement();
    if (Object.isElement(content)) return element.update().insert(content);

    content = Object.toHTML(content);
    var tagName = element.tagName.toUpperCase();

    if (tagName in Element._insertionTranslations.tags) {
      $A(element.childNodes).each(function(node) { element.removeChild(node) });
      Element._getContentFromAnonymousElement(tagName, content.stripScripts())
        .each(function(node) { element.appendChild(node) });
    }
    else element.innerHTML = content.stripScripts();

    content.evalScripts.bind(content).defer();
    return element;
  };
}

if (''outerHTML'' in document.createElement(''div'')) {
  Element.Methods.replace = function(element, content) {
    element = $(element);

    if (content && content.toElement) content = content.toElement();
    if (Object.isElement(content)) {
      element.parentNode.replaceChild(content, element);
      return element;
    }

    content = Object.toHTML(content);
    var parent = element.parentNode, tagName = parent.tagName.toUpperCase();

    if (Element._insertionTranslations.tags[tagName]) {
      var nextSibling = element.next();
      var fragments = Element._getContentFromAnonymousElement(tagName, content.stripScripts());
      parent.removeChild(element);
      if (nextSibling)
        fragments.each(function(node) { parent.insertBefore(node, nextSibling) });
      else
        fragments.each(function(node) { parent.appendChild(node) });
    }
    else element.outerHTML = content.stripScripts();

    content.evalScripts.bind(content).defer();
    return element;
  };
}

Element._returnOffset = function(l, t) {
  var result = [l, t];
  result.left = l;
  result.top = t;
  return result;
};

Element._getContentFromAnonymousElement = function(tagName, html) {
  var div = new Element(''div''), t = Element._insertionTranslations.tags[tagName];
  if (t) {
    div.innerHTML = t[0] + html + t[1];
    t[2].times(function() { div = div.firstChild });
  } else div.innerHTML = html;
  return $A(div.childNodes);
};

Element._insertionTranslations = {
  before: function(element, node) {
    element.parentNode.insertBefore(node, element);
  },
  top: function(element, node) {
    element.insertBefore(node, element.firstChild);
  },
  bottom: function(element, node) {
    element.appendChild(node);
  },
  after: function(element, node) {
    element.parentNode.insertBefore(node, element.nextSibling);
  },
  tags: {
    TABLE:  [''<table>'',                ''</table>'',                   1],
    TBODY:  [''<table><tbody>'',         ''</tbody></table>'',           2],
    TR:     [''<table><tbody><tr>'',     ''</tr></tbody></table>'',      3],
    TD:     [''<table><tbody><tr><td>'', ''</td></tr></tbody></table>'', 4],
    SELECT: [''<select>'',               ''</select>'',                  1]
  }
};

(function() {
  Object.extend(this.tags, {
    THEAD: this.tags.TBODY,
    TFOOT: this.tags.TBODY,
    TH:    this.tags.TD
  });
}).call(Element._insertionTranslations);

Element.Methods.Simulated = {
  hasAttribute: function(element, attribute) {
    attribute = Element._attributeTranslations.has[attribute] || attribute;
    var node = $(element).getAttributeNode(attribute);
    return !!!!(node && node.specified);
  }
};

Element.Methods.ByTag = { };

Object.extend(Element, Element.Methods);

if (!!Prototype.BrowserFeatures.ElementExtensions &&
    document.createElement(''div'')[''__proto__'']) {
  window.HTMLElement = { };
  window.HTMLElement.prototype = document.createElement(''div'')[''__proto__''];
  Prototype.BrowserFeatures.ElementExtensions = true;
}

Element.extend = (function() {
  if (Prototype.BrowserFeatures.SpecificElementExtensions)
    return Prototype.K;

  var Methods = { }, ByTag = Element.Methods.ByTag;

  var extend = Object.extend(function(element) {
    if (!!element || element._extendedByPrototype ||
        element.nodeType !!= 1 || element == window) return element;

    var methods = Object.clone(Methods),
      tagName = element.tagName.toUpperCase(), property, value;

    // extend methods for specific tags
    if (ByTag[tagName]) Object.extend(methods, ByTag[tagName]);

    for (property in methods) {
      value = methods[property];
      if (Object.isFunction(value) && !!(property in element))
        element[property] = value.methodize();
    }

    element._extendedByPrototype = Prototype.emptyFunction;
    return element;

  }, {
    refresh: function() {
      // extend methods for all tags (Safari doesn''t need this)
      if (!!Prototype.BrowserFeatures.ElementExtensions) {
        Object.extend(Methods, Element.Methods);
        Object.extend(Methods, Element.Methods.Simulated);
      }
    }
  });

  extend.refresh();
  return extend;
})();

Element.hasAttribute = function(element, attribute) {
  if (element.hasAttribute) return element.hasAttribute(attribute);
  return Element.Methods.Simulated.hasAttribute(element, attribute);
};

Element.addMethods = function(methods) {
  var F = Prototype.BrowserFeatures, T = Element.Methods.ByTag;

  if (!!methods) {
    Object.extend(Form, Form.Methods);
    Object.extend(Form.Element, Form.Element.Methods);
    Object.extend(Element.Methods.ByTag, {
      "FORM":     Object.clone(Form.Methods),
      "INPUT":    Object.clone(Form.Element.Methods),
      "SELECT":   Object.clone(Form.Element.Methods),
      "TEXTAREA": Object.clone(Form.Element.Methods)
    });
  }

  if (arguments.length == 2) {
    var tagName = methods;
    methods = arguments[1];
  }

  if (!!tagName) Object.extend(Element.Methods, methods || { });
  else {
    if (Object.isArray(tagName)) tagName.each(extend);
    else extend(tagName);
  }

  function extend(tagName) {
    tagName = tagName.toUpperCase();
    if (!!Element.Methods.ByTag[tagName])
      Element.Methods.ByTag[tagName] = { };
    Object.extend(Element.Methods.ByTag[tagName], methods);
  }

  function copy(methods, destination, onlyIfAbsent) {
    onlyIfAbsent = onlyIfAbsent || false;
    for (var property in methods) {
      var value = methods[property];
      if (!!Object.isFunction(value)) continue;
      if (!!onlyIfAbsent || !!(property in destination))
        destination[property] = value.methodize();
    }
  }

  function findDOMClass(tagName) {
    var klass;
    var trans = {
      "OPTGROUP": "OptGroup", "TEXTAREA": "TextArea", "P": "Paragraph",
      "FIELDSET": "FieldSet", "UL": "UList", "OL": "OList", "DL": "DList",
      "DIR": "Directory", "H1": "Heading", "H2": "Heading", "H3": "Heading",
      "H4": "Heading", "H5": "Heading", "H6": "Heading", "Q": "Quote",
      "INS": "Mod", "DEL": "Mod", "A": "Anchor", "IMG": "Image", "CAPTION":
      "TableCaption", "COL": "TableCol", "COLGROUP": "TableCol", "THEAD":
      "TableSection", "TFOOT": "TableSection", "TBODY": "TableSection", "TR":
      "TableRow", "TH": "TableCell", "TD": "TableCell", "FRAMESET":
      "FrameSet", "IFRAME": "IFrame"
    };
    if (trans[tagName]) klass = ''HTML'' + trans[tagName] + ''Element'';
    if (window[klass]) return window[klass];
    klass = ''HTML'' + tagName + ''Element'';
    if (window[klass]) return window[klass];
    klass = ''HTML'' + tagName.capitalize() + ''Element'';
    if (window[klass]) return window[klass];

    window[klass] = { };
    window[klass].prototype = document.createElement(tagName)[''__proto__''];
    return window[klass];
  }

  if (F.ElementExtensions) {
    copy(Element.Methods, HTMLElement.prototype);
    copy(Element.Methods.Simulated, HTMLElement.prototype, true);
  }

  if (F.SpecificElementExtensions) {
    for (var tag in Element.Methods.ByTag) {
      var klass = findDOMClass(tag);
      if (Object.isUndefined(klass)) continue;
      copy(T[tag], klass.prototype);
    }
  }

  Object.extend(Element, Element.Methods);
  delete Element.ByTag;

  if (Element.extend.refresh) Element.extend.refresh();
  Element.cache = { };
};

document.viewport = {
  getDimensions: function() {
    var dimensions = { }, B = Prototype.Browser;
    $w(''width height'').each(function(d) {
      var D = d.capitalize();
      if (B.WebKit && !!document.evaluate) {
        // Safari <3.0 needs self.innerWidth/Height
        dimensions[d] = self[''inner'' + D];
      } else if (B.Opera && parseFloat(window.opera.version()) < 9.5) {
        // Opera <9.5 needs document.body.clientWidth/Height
        dimensions[d] = document.body[''client'' + D]
      } else {
        dimensions[d] = document.documentElement[''client'' + D];
      }
    });
    return dimensions;
  },

  getWidth: function() {
    return this.getDimensions().width;
  },

  getHeight: function() {
    return this.getDimensions().height;
  },

  getScrollOffsets: function() {
    return Element._returnOffset(
      window.pageXOffset || document.documentElement.scrollLeft || document.body.scrollLeft,
      window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop);
  }
};
/* Portions of the Selector class are derived from Jack Slocum''s DomQuery,
 * part of YUI-Ext version 0.40, distributed under the terms of an MIT-style
 * license.  Please see http://www.yui-ext.com/ for more information. */

var Selector = Class.create({
  initialize: function(expression) {
    this.expression = expression.strip();

    if (this.shouldUseSelectorsAPI()) {
      this.mode = ''selectorsAPI'';
    } else if (this.shouldUseXPath()) {
      this.mode = ''xpath'';
      this.compileXPathMatcher();
    } else {
      this.mode = "normal";
      this.compileMatcher();
    }

  },

  shouldUseXPath: function() {
    if (!!Prototype.BrowserFeatures.XPath) return false;

    var e = this.expression;

    // Safari 3 chokes on :*-of-type and :empty
    if (Prototype.Browser.WebKit &&
     (e.include("-of-type") || e.include(":empty")))
      return false;

    // XPath can''t do namespaced attributes, nor can it read
    // the "checked" property from DOM nodes
    if ((/(\[[\w-]*?:|:checked)/).test(e))
      return false;

    return true;
  },

  shouldUseSelectorsAPI: function() {
    if (!!Prototype.BrowserFeatures.SelectorsAPI) return false;

    if (!!Selector._div) Selector._div = new Element(''div'');

    // Make sure the browser treats the selector as valid. Test on an
    // isolated element to minimize cost of this check.
    try {
      Selector._div.querySelector(this.expression);
    } catch(e) {
      return false;
    }

    return true;
  },

  compileMatcher: function() {
    var e = this.expression, ps = Selector.patterns, h = Selector.handlers,
        c = Selector.criteria, le, p, m;

    if (Selector._cache[e]) {
      this.matcher = Selector._cache[e];
      return;
    }

    this.matcher = ["this.matcher = function(root) {",
                    "var r = root, h = Selector.handlers, c = false, n;"];

    while (e && le !!= e && (/\S/).test(e)) {
      le = e;
      for (var i in ps) {
        p = ps[i];
        if (m = e.match(p)) {
          this.matcher.push(Object.isFunction(c[i]) ? c[i](m) :
            new Template(c[i]).evaluate(m));
          e = e.replace(m[0], '''');
          break;
        }
      }
    }

    this.matcher.push("return h.unique(n);\n}");
    eval(this.matcher.join(''\n''));
    Selector._cache[this.expression] = this.matcher;
  },

  compileXPathMatcher: function() {
    var e = this.expression, ps = Selector.patterns,
        x = Selector.xpath, le, m;

    if (Selector._cache[e]) {
      this.xpath = Selector._cache[e]; return;
    }

    this.matcher = [''.//*''];
    while (e && le !!= e && (/\S/).test(e)) {
      le = e;
      for (var i in ps) {
        if (m = e.match(ps[i])) {
          this.matcher.push(Object.isFunction(x[i]) ? x[i](m) :
            new Template(x[i]).evaluate(m));
          e = e.replace(m[0], '''');
          break;
        }
      }
    }

    this.xpath = this.matcher.join('''');
    Selector._cache[this.expression] = this.xpath;
  },

  findElements: function(root) {
    root = root || document;
    var e = this.expression, results;

    switch (this.mode) {
      case ''selectorsAPI'':
        // querySelectorAll queries document-wide, then filters to descendants
        // of the context element. That''s not what we want.
        // Add an explicit context to the selector if necessary.
        if (root !!== document) {
          var oldId = root.id, id = $(root).identify();
          e = "#" + id + " " + e;
        }

        results = $A(root.querySelectorAll(e)).map(Element.extend);
        root.id = oldId;

        return results;
      case ''xpath'':
        return document._getElementsByXPath(this.xpath, root);
      default:
       return this.matcher(root);
    }
  },

  match: function(element) {
    this.tokens = [];

    var e = this.expression, ps = Selector.patterns, as = Selector.assertions;
    var le, p, m;

    while (e && le !!== e && (/\S/).test(e)) {
      le = e;
      for (var i in ps) {
        p = ps[i];
        if (m = e.match(p)) {
          // use the Selector.assertions methods unless the selector
          // is too complex.
          if (as[i]) {
            this.tokens.push([i, Object.clone(m)]);
            e = e.replace(m[0], '''');
          } else {
            // reluctantly do a document-wide search
            // and look for a match in the array
            return this.findElements(document).include(element);
          }
        }
      }
    }

    var match = true, name, matches;
    for (var i = 0, token; token = this.tokens[i]; i++) {
      name = token[0], matches = token[1];
      if (!!Selector.assertions[name](element, matches)) {
        match = false; break;
      }
    }

    return match;
  },

  toString: function() {
    return this.expression;
  },

  inspect: function() {
    return "#<Selector:" + this.expression.inspect() + ">";
  }
});

Object.extend(Selector, {
  _cache: { },

  xpath: {
    descendant:   "//*",
    child:        "/*",
    adjacent:     "/following-sibling::*[1]",
    laterSibling: ''/following-sibling::*'',
    tagName:      function(m) {
      if (m[1] == ''*'') return '''';
      return "[local-name()=''" + m[1].toLowerCase() +
             "'' or local-name()=''" + m[1].toUpperCase() + "'']";
    },
    className:    "[contains(concat('' '', @class, '' ''), '' #{1} '')]",
    id:           "[@id=''#{1}'']",
    attrPresence: function(m) {
      m[1] = m[1].toLowerCase();
      return new Template("[@#{1}]").evaluate(m);
    },
    attr: function(m) {
      m[1] = m[1].toLowerCase();
      m[3] = m[5] || m[6];
      return new Template(Selector.xpath.operators[m[2]]).evaluate(m);
    },
    pseudo: function(m) {
      var h = Selector.xpath.pseudos[m[1]];
      if (!!h) return '''';
      if (Object.isFunction(h)) return h(m);
      return new Template(Selector.xpath.pseudos[m[1]]).evaluate(m);
    },
    operators: {
      ''='':  "[@#{1}=''#{3}'']",
      ''!!='': "[@#{1}!!=''#{3}'']",
      ''^='': "[starts-with(@#{1}, ''#{3}'')]",
      ''$='': "[substring(@#{1}, (string-length(@#{1}) - string-length(''#{3}'') + 1))=''#{3}'']",
      ''*='': "[contains(@#{1}, ''#{3}'')]",
      ''~='': "[contains(concat('' '', @#{1}, '' ''), '' #{3} '')]",
      ''|='': "[contains(concat(''-'', @#{1}, ''-''), ''-#{3}-'')]"
    },
    pseudos: {
      ''first-child'': ''[not(preceding-sibling::*)]'',
      ''last-child'':  ''[not(following-sibling::*)]'',
      ''only-child'':  ''[not(preceding-sibling::* or following-sibling::*)]'',
      ''empty'':       "[count(*) = 0 and (count(text()) = 0)]",
      ''checked'':     "[@checked]",
      ''disabled'':    "[(@disabled) and (@type!!=''hidden'')]",
      ''enabled'':     "[not(@disabled) and (@type!!=''hidden'')]",
      ''not'': function(m) {
        var e = m[6], p = Selector.patterns,
            x = Selector.xpath, le, v;

        var exclusion = [];
        while (e && le !!= e && (/\S/).test(e)) {
          le = e;
          for (var i in p) {
            if (m = e.match(p[i])) {
              v = Object.isFunction(x[i]) ? x[i](m) : new Template(x[i]).evaluate(m);
              exclusion.push("(" + v.substring(1, v.length - 1) + ")");
              e = e.replace(m[0], '''');
              break;
            }
          }
        }
        return "[not(" + exclusion.join(" and ") + ")]";
      },
      ''nth-child'':      function(m) {
        return Selector.xpath.pseudos.nth("(count(./preceding-sibling::*) + 1) ", m);
      },
      ''nth-last-child'': function(m) {
        return Selector.xpath.pseudos.nth("(count(./following-sibling::*) + 1) ", m);
      },
      ''nth-of-type'':    function(m) {
        return Selector.xpath.pseudos.nth("position() ", m);
      },
      ''nth-last-of-type'': function(m) {
        return Selector.xpath.pseudos.nth("(last() + 1 - position()) ", m);
      },
      ''first-of-type'':  function(m) {
        m[6] = "1"; return Selector.xpath.pseudos[''nth-of-type''](m);
      },
      ''last-of-type'':   function(m) {
        m[6] = "1"; return Selector.xpath.pseudos[''nth-last-of-type''](m);
      },
      ''only-of-type'':   function(m) {
        var p = Selector.xpath.pseudos; return p[''first-of-type''](m) + p[''last-of-type''](m);
      },
      nth: function(fragment, m) {
        var mm, formula = m[6], predicate;
        if (formula == ''even'') formula = ''2n+0'';
        if (formula == ''odd'')  formula = ''2n+1'';
        if (mm = formula.match(/^(\d+)$/)) // digit only
          return ''['' + fragment + "= " + mm[1] + '']'';
        if (mm = formula.match(/^(-?\d*)?n(([+-])(\d+))?/)) { // an+b
          if (mm[1] == "-") mm[1] = -1;
          var a = mm[1] ? Number(mm[1]) : 1;
          var b = mm[2] ? Number(mm[2]) : 0;
          predicate = "[((#{fragment} - #{b}) mod #{a} = 0) and " +
          "((#{fragment} - #{b}) div #{a} >= 0)]";
          return new Template(predicate).evaluate({
            fragment: fragment, a: a, b: b });
        }
      }
    }
  },

  criteria: {
    tagName:      ''n = h.tagName(n, r, "#{1}", c);      c = false;'',
    className:    ''n = h.className(n, r, "#{1}", c);    c = false;'',
    id:           ''n = h.id(n, r, "#{1}", c);           c = false;'',
    attrPresence: ''n = h.attrPresence(n, r, "#{1}", c); c = false;'',
    attr: function(m) {
      m[3] = (m[5] || m[6]);
      return new Template(''n = h.attr(n, r, "#{1}", "#{3}", "#{2}", c); c = false;'').evaluate(m);
    },
    pseudo: function(m) {
      if (m[6]) m[6] = m[6].replace(/"/g, ''\\"'');
      return new Template(''n = h.pseudo(n, "#{1}", "#{6}", r, c); c = false;'').evaluate(m);
    },
    descendant:   ''c = "descendant";'',
    child:        ''c = "child";'',
    adjacent:     ''c = "adjacent";'',
    laterSibling: ''c = "laterSibling";''
  },

  patterns: {
    // combinators must be listed first
    // (and descendant needs to be last combinator)
    laterSibling: /^\s*~\s*/,
    child:        /^\s*>\s*/,
    adjacent:     /^\s*\+\s*/,
    descendant:   /^\s/,

    // selectors follow
    tagName:      /^\s*(\*|[\w\-]+)(\b|$)?/,
    id:           /^#([\w\-\*]+)(\b|$)/,
    className:    /^\.([\w\-\*]+)(\b|$)/,
    pseudo:
/^:((first|last|nth|nth-last|only)(-child|-of-type)|empty|checked|(en|dis)abled|not)(\((.*?)\))?(\b|$|(?=\s|[:+~>]))/,
    attrPresence: /^\[((?:[\w]+:)?[\w]+)\]/,
    attr:         /\[((?:[\w-]*:)?[\w-]+)\s*(?:([!!^$*~|]?=)\s*(([''"])([^\4]*?)\4|([^''"][^\]]*?)))?\]/
  },

  // for Selector.match and Element#match
  assertions: {
    tagName: function(element, matches) {
      return matches[1].toUpperCase() == element.tagName.toUpperCase();
    },

    className: function(element, matches) {
      return Element.hasClassName(element, matches[1]);
    },

    id: function(element, matches) {
      return element.id === matches[1];
    },

    attrPresence: function(element, matches) {
      return Element.hasAttribute(element, matches[1]);
    },

    attr: function(element, matches) {
      var nodeValue = Element.readAttribute(element, matches[1]);
      return nodeValue && Selector.operators[matches[2]](nodeValue, matches[5] || matches[6]);
    }
  },

  handlers: {
    // UTILITY FUNCTIONS
    // joins two collections
    concat: function(a, b) {
      for (var i = 0, node; node = b[i]; i++)
        a.push(node);
      return a;
    },

    // marks an array of nodes for counting
    mark: function(nodes) {
      var _true = Prototype.emptyFunction;
      for (var i = 0, node; node = nodes[i]; i++)
        node._countedByPrototype = _true;
      return nodes;
    },

    unmark: function(nodes) {
      for (var i = 0, node; node = nodes[i]; i++)
        node._countedByPrototype = undefined;
      return nodes;
    },

    // mark each child node with its position (for nth calls)
    // "ofType" flag indicates whether we''re indexing for nth-of-type
    // rather than nth-child
    index: function(parentNode, reverse, ofType) {
      parentNode._countedByPrototype = Prototype.emptyFunction;
      if (reverse) {
        for (var nodes = parentNode.childNodes, i = nodes.length - 1, j = 1; i >= 0; i--) {
          var node = nodes[i];
          if (node.nodeType == 1 && (!!ofType || node._countedByPrototype)) node.nodeIndex = j++;
        }
      } else {
        for (var i = 0, j = 1, nodes = parentNode.childNodes; node = nodes[i]; i++)
          if (node.nodeType == 1 && (!!ofType || node._countedByPrototype)) node.nodeIndex = j++;
      }
    },

    // filters out duplicates and extends all nodes
    unique: function(nodes) {
      if (nodes.length == 0) return nodes;
      var results = [], n;
      for (var i = 0, l = nodes.length; i < l; i++)
        if (!!(n = nodes[i])._countedByPrototype) {
          n._countedByPrototype = Prototype.emptyFunction;
          results.push(Element.extend(n));
        }
      return Selector.handlers.unmark(results);
    },

    // COMBINATOR FUNCTIONS
    descendant: function(nodes) {
      var h = Selector.handlers;
      for (var i = 0, results = [], node; node = nodes[i]; i++)
        h.concat(results, node.getElementsByTagName(''*''));
      return results;
    },

    child: function(nodes) {
      var h = Selector.handlers;
      for (var i = 0, results = [], node; node = nodes[i]; i++) {
        for (var j = 0, child; child = node.childNodes[j]; j++)
          if (child.nodeType == 1 && child.tagName !!= ''!!'') results.push(child);
      }
      return results;
    },

    adjacent: function(nodes) {
      for (var i = 0, results = [], node; node = nodes[i]; i++) {
        var next = this.nextElementSibling(node);
        if (next) results.push(next);
      }
      return results;
    },

    laterSibling: function(nodes) {
      var h = Selector.handlers;
      for (var i = 0, results = [], node; node = nodes[i]; i++)
        h.concat(results, Element.nextSiblings(node));
      return results;
    },

    nextElementSibling: function(node) {
      while (node = node.nextSibling)
        if (node.nodeType == 1) return node;
      return null;
    },

    previousElementSibling: function(node) {
      while (node = node.previousSibling)
        if (node.nodeType == 1) return node;
      return null;
    },

    // TOKEN FUNCTIONS
    tagName: function(nodes, root, tagName, combinator) {
      var uTagName = tagName.toUpperCase();
      var results = [], h = Selector.handlers;
      if (nodes) {
        if (combinator) {
          // fastlane for ordinary descendant combinators
          if (combinator == "descendant") {
            for (var i = 0, node; node = nodes[i]; i++)
              h.concat(results, node.getElementsByTagName(tagName));
            return results;
          } else nodes = this[combinator](nodes);
          if (tagName == "*") return nodes;
        }
        for (var i = 0, node; node = nodes[i]; i++)
          if (node.tagName.toUpperCase() === uTagName) results.push(node);
        return results;
      } else return root.getElementsByTagName(tagName);
    },

    id: function(nodes, root, id, combinator) {
      var targetNode = $(id), h = Selector.handlers;
      if (!!targetNode) return [];
      if (!!nodes && root == document) return [targetNode];
      if (nodes) {
        if (combinator) {
          if (combinator == ''child'') {
            for (var i = 0, node; node = nodes[i]; i++)
              if (targetNode.parentNode == node) return [targetNode];
          } else if (combinator == ''descendant'') {
            for (var i = 0, node; node = nodes[i]; i++)
              if (Element.descendantOf(targetNode, node)) return [targetNode];
          } else if (combinator == ''adjacent'') {
            for (var i = 0, node; node = nodes[i]; i++)
              if (Selector.handlers.previousElementSibling(targetNode) == node)
                return [targetNode];
          } else nodes = h[combinator](nodes);
        }
        for (var i = 0, node; node = nodes[i]; i++)
          if (node == targetNode) return [targetNode];
        return [];
      }
      return (targetNode && Element.descendantOf(targetNode, root)) ? [targetNode] : [];
    },

    className: function(nodes, root, className, combinator) {
      if (nodes && combinator) nodes = this[combinator](nodes);
      return Selector.handlers.byClassName(nodes, root, className);
    },

    byClassName: function(nodes, root, className) {
      if (!!nodes) nodes = Selector.handlers.descendant([root]);
      var needle = '' '' + className + '' '';
      for (var i = 0, results = [], node, nodeClassName; node = nodes[i]; i++) {
        nodeClassName = node.className;
        if (nodeClassName.length == 0) continue;
        if (nodeClassName == className || ('' '' + nodeClassName + '' '').include(needle))
          results.push(node);
      }
      return results;
    },

    attrPresence: function(nodes, root, attr, combinator) {
      if (!!nodes) nodes = root.getElementsByTagName("*");
      if (nodes && combinator) nodes = this[combinator](nodes);
      var results = [];
      for (var i = 0, node; node = nodes[i]; i++)
        if (Element.hasAttribute(node, attr)) results.push(node);
      return results;
    },

    attr: function(nodes, root, attr, value, operator, combinator) {
      if (!!nodes) nodes = root.getElementsByTagName("*");
      if (nodes && combinator) nodes = this[combinator](nodes);
      var handler = Selector.operators[operator], results = [];
      for (var i = 0, node; node = nodes[i]; i++) {
        var nodeValue = Element.readAttribute(node, attr);
        if (nodeValue === null) continue;
        if (handler(nodeValue, value)) results.push(node);
      }
      return results;
    },

    pseudo: function(nodes, name, value, root, combinator) {
      if (nodes && combinator) nodes = this[combinator](nodes);
      if (!!nodes) nodes = root.getElementsByTagName("*");
      return Selector.pseudos[name](nodes, value, root);
    }
  },

  pseudos: {
    ''first-child'': function(nodes, value, root) {
      for (var i = 0, results = [], node; node = nodes[i]; i++) {
        if (Selector.handlers.previousElementSibling(node)) continue;
          results.push(node);
      }
      return results;
    },
    ''last-child'': function(nodes, value, root) {
      for (var i = 0, results = [], node; node = nodes[i]; i++) {
        if (Selector.handlers.nextElementSibling(node)) continue;
          results.push(node);
      }
      return results;
    },
    ''only-child'': function(nodes, value, root) {
      var h = Selector.handlers;
      for (var i = 0, results = [], node; node = nodes[i]; i++)
        if (!!h.previousElementSibling(node) && !!h.nextElementSibling(node))
          results.push(node);
      return results;
    },
    ''nth-child'':        function(nodes, formula, root) {
      return Selector.pseudos.nth(nodes, formula, root);
    },
    ''nth-last-child'':   function(nodes, formula, root) {
      return Selector.pseudos.nth(nodes, formula, root, true);
    },
    ''nth-of-type'':      function(nodes, formula, root) {
      return Selector.pseudos.nth(nodes, formula, root, false, true);
    },
    ''nth-last-of-type'': function(nodes, formula, root) {
      return Selector.pseudos.nth(nodes, formula, root, true, true);
    },
    ''first-of-type'':    function(nodes, formula, root) {
      return Selector.pseudos.nth(nodes, "1", root, false, true);
    },
    ''last-of-type'':     function(nodes, formula, root) {
      return Selector.pseudos.nth(nodes, "1", root, true, true);
    },
    ''only-of-type'':     function(nodes, formula, root) {
      var p = Selector.pseudos;
      return p[''last-of-type''](p[''first-of-type''](nodes, formula, root), formula, root);
    },

    // handles the an+b logic
    getIndices: function(a, b, total) {
      if (a == 0) return b > 0 ? [b] : [];
      return $R(1, total).inject([], function(memo, i) {
        if (0 == (i - b) % a && (i - b) / a >= 0) memo.push(i);
        return memo;
      });
    },

    // handles nth(-last)-child, nth(-last)-of-type, and (first|last)-of-type
    nth: function(nodes, formula, root, reverse, ofType) {
      if (nodes.length == 0) return [];
      if (formula == ''even'') formula = ''2n+0'';
      if (formula == ''odd'')  formula = ''2n+1'';
      var h = Selector.handlers, results = [], indexed = [], m;
      h.mark(nodes);
      for (var i = 0, node; node = nodes[i]; i++) {
        if (!!node.parentNode._countedByPrototype) {
          h.index(node.parentNode, reverse, ofType);
          indexed.push(node.parentNode);
        }
      }
      if (formula.match(/^\d+$/)) { // just a number
        formula = Number(formula);
        for (var i = 0, node; node = nodes[i]; i++)
          if (node.nodeIndex == formula) results.push(node);
      } else if (m = formula.match(/^(-?\d*)?n(([+-])(\d+))?/)) { // an+b
        if (m[1] == "-") m[1] = -1;
        var a = m[1] ? Number(m[1]) : 1;
        var b = m[2] ? Number(m[2]) : 0;
        var indices = Selector.pseudos.getIndices(a, b, nodes.length);
        for (var i = 0, node, l = indices.length; node = nodes[i]; i++) {
          for (var j = 0; j < l; j++)
            if (node.nodeIndex == indices[j]) results.push(node);
        }
      }
      h.unmark(nodes);
      h.unmark(indexed);
      return results;
    },

    ''empty'': function(nodes, value, root) {
      for (var i = 0, results = [], node; node = nodes[i]; i++) {
        // IE treats comments as element nodes
        if (node.tagName == ''!!'' || node.firstChild) continue;
        results.push(node);
      }
      return results;
    },

    ''not'': function(nodes, selector, root) {
      var h = Selector.handlers, selectorType, m;
      var exclusions = new Selector(selector).findElements(root);
      h.mark(exclusions);
      for (var i = 0, results = [], node; node = nodes[i]; i++)
        if (!!node._countedByPrototype) results.push(node);
      h.unmark(exclusions);
      return results;
    },

    ''enabled'': function(nodes, value, root) {
      for (var i = 0, results = [], node; node = nodes[i]; i++)
        if (!!node.disabled && (!!node.type || node.type !!== ''hidden''))
          results.push(node);
      return results;
    },

    ''disabled'': function(nodes, value, root) {
      for (var i = 0, results = [], node; node = nodes[i]; i++)
        if (node.disabled) results.push(node);
      return results;
    },

    ''checked'': function(nodes, value, root) {
      for (var i = 0, results = [], node; node = nodes[i]; i++)
        if (node.checked) results.push(node);
      return results;
    }
  },

  operators: {
    ''='':  function(nv, v) { return nv == v; },
    ''!!='': function(nv, v) { return nv !!= v; },
    ''^='': function(nv, v) { return nv == v || nv && nv.startsWith(v); },
    ''$='': function(nv, v) { return nv == v || nv && nv.endsWith(v); },
    ''*='': function(nv, v) { return nv == v || nv && nv.include(v); },
    ''$='': function(nv, v) { return nv.endsWith(v); },
    ''*='': function(nv, v) { return nv.include(v); },
    ''~='': function(nv, v) { return ('' '' + nv + '' '').include('' '' + v + '' ''); },
    ''|='': function(nv, v) { return (''-'' + (nv || "").toUpperCase() +
     ''-'').include(''-'' + (v || "").toUpperCase() + ''-''); }
  },

  split: function(expression) {
    var expressions = [];
    expression.scan(/(([\w#:.~>+()\s-]+|\*|\[.*?\])+)\s*(,|$)/, function(m) {
      expressions.push(m[1].strip());
    });
    return expressions;
  },

  matchElements: function(elements, expression) {
    var matches = $$(expression), h = Selector.handlers;
    h.mark(matches);
    for (var i = 0, results = [], element; element = elements[i]; i++)
      if (element._countedByPrototype) results.push(element);
    h.unmark(matches);
    return results;
  },

  findElement: function(elements, expression, index) {
    if (Object.isNumber(expression)) {
      index = expression; expression = false;
    }
    return Selector.matchElements(elements, expression || ''*'')[index || 0];
  },

  findChildElements: function(element, expressions) {
    expressions = Selector.split(expressions.join('',''));
    var results = [], h = Selector.handlers;
    for (var i = 0, l = expressions.length, selector; i < l; i++) {
      selector = new Selector(expressions[i].strip());
      h.concat(results, selector.findElements(element));
    }
    return (l > 1) ? h.unique(results) : results;
  }
});

if (Prototype.Browser.IE) {
  Object.extend(Selector.handlers, {
    // IE returns comment nodes on getElementsByTagName("*").
    // Filter them out.
    concat: function(a, b) {
      for (var i = 0, node; node = b[i]; i++)
        if (node.tagName !!== "!!") a.push(node);
      return a;
    },

    // IE improperly serializes _countedByPrototype in (inner|outer)HTML.
    unmark: function(nodes) {
      for (var i = 0, node; node = nodes[i]; i++)
        node.removeAttribute(''_countedByPrototype'');
      return nodes;
    }
  });
}

function $$() {
  return Selector.findChildElements(document, $A(arguments));
}
var Form = {
  reset: function(form) {
    $(form).reset();
    return form;
  },

  serializeElements: function(elements, options) {
    if (typeof options !!= ''object'') options = { hash: !!!!options };
    else if (Object.isUndefined(options.hash)) options.hash = true;
    var key, value, submitted = false, submit = options.submit;

    var data = elements.inject({ }, function(result, element) {
      if (!!element.disabled && element.name) {
        key = element.name; value = $(element).getValue();
        if (value !!= null && element.type !!= ''file'' && (element.type !!= ''submit'' || (!!submitted &&
            submit !!== false && (!!submit || key == submit) && (submitted = true)))) {
          if (key in result) {
            // a key is already present; construct an array of values
            if (!!Object.isArray(result[key])) result[key] = [result[key]];
            result[key].push(value);
          }
          else result[key] = value;
        }
      }
      return result;
    });

    return options.hash ? data : Object.toQueryString(data);
  }
};

Form.Methods = {
  serialize: function(form, options) {
    return Form.serializeElements(Form.getElements(form), options);
  },

  getElements: function(form) {
    return $A($(form).getElementsByTagName(''*'')).inject([],
      function(elements, child) {
        if (Form.Element.Serializers[child.tagName.toLowerCase()])
          elements.push(Element.extend(child));
        return elements;
      }
    );
  },

  getInputs: function(form, typeName, name) {
    form = $(form);
    var inputs = form.getElementsByTagName(''input'');

    if (!!typeName && !!name) return $A(inputs).map(Element.extend);

    for (var i = 0, matchingInputs = [], length = inputs.length; i < length; i++) {
      var input = inputs[i];
      if ((typeName && input.type !!= typeName) || (name && input.name !!= name))
        continue;
      matchingInputs.push(Element.extend(input));
    }

    return matchingInputs;
  },

  disable: function(form) {
    form = $(form);
    Form.getElements(form).invoke(''disable'');
    return form;
  },

  enable: function(form) {
    form = $(form);
    Form.getElements(form).invoke(''enable'');
    return form;
  },

  findFirstElement: function(form) {
    var elements = $(form).getElements().findAll(function(element) {
      return ''hidden'' !!= element.type && !!element.disabled;
    });
    var firstByIndex = elements.findAll(function(element) {
      return element.hasAttribute(''tabIndex'') && element.tabIndex >= 0;
    }).sortBy(function(element) { return element.tabIndex }).first();

    return firstByIndex ? firstByIndex : elements.find(function(element) {
      return [''input'', ''select'', ''textarea''].include(element.tagName.toLowerCase());
    });
  },

  focusFirstElement: function(form) {
    form = $(form);
    form.findFirstElement().activate();
    return form;
  },

  request: function(form, options) {
    form = $(form), options = Object.clone(options || { });

    var params = options.parameters, action = form.readAttribute(''action'') || '''';
    if (action.blank()) action = window.location.href;
    options.parameters = form.serialize(true);

    if (params) {
      if (Object.isString(params)) params = params.toQueryParams();
      Object.extend(options.parameters, params);
    }

    if (form.hasAttribute(''method'') && !!options.method)
      options.method = form.method;

    return new Ajax.Request(action, options);
  }
};

/*--------------------------------------------------------------------------*/

Form.Element = {
  focus: function(element) {
    $(element).focus();
    return element;
  },

  select: function(element) {
    $(element).select();
    return element;
  }
};

Form.Element.Methods = {
  serialize: function(element) {
    element = $(element);
    if (!!element.disabled && element.name) {
      var value = element.getValue();
      if (value !!= undefined) {
        var pair = { };
        pair[element.name] = value;
        return Object.toQueryString(pair);
      }
    }
    return '''';
  },

  getValue: function(element) {
    element = $(element);
    var method = element.tagName.toLowerCase();
    return Form.Element.Serializers[method](element);
  },

  setValue: function(element, value) {
    element = $(element);
    var method = element.tagName.toLowerCase();
    Form.Element.Serializers[method](element, value);
    return element;
  },

  clear: function(element) {
    $(element).value = '''';
    return element;
  },

  present: function(element) {
    return $(element).value !!= '''';
  },

  activate: function(element) {
    element = $(element);
    try {
      element.focus();
      if (element.select && (element.tagName.toLowerCase() !!= ''input'' ||
          !![''button'', ''reset'', ''submit''].include(element.type)))
        element.select();
    } catch (e) { }
    return element;
  },

  disable: function(element) {
    element = $(element);
    element.disabled = true;
    return element;
  },

  enable: function(element) {
    element = $(element);
    element.disabled = false;
    return element;
  }
};

/*--------------------------------------------------------------------------*/

var Field = Form.Element;
var $F = Form.Element.Methods.getValue;

/*--------------------------------------------------------------------------*/

Form.Element.Serializers = {
  input: function(element, value) {
    switch (element.type.toLowerCase()) {
      case ''checkbox'':
      case ''radio'':
        return Form.Element.Serializers.inputSelector(element, value);
      default:
        return Form.Element.Serializers.textarea(element, value);
    }
  },

  inputSelector: function(element, value) {
    if (Object.isUndefined(value)) return element.checked ? element.value : null;
    else element.checked = !!!!value;
  },

  textarea: function(element, value) {
    if (Object.isUndefined(value)) return element.value;
    else element.value = value;
  },

  select: function(element, value) {
    if (Object.isUndefined(value))
      return this[element.type == ''select-one'' ?
        ''selectOne'' : ''selectMany''](element);
    else {
      var opt, currentValue, single = !!Object.isArray(value);
      for (var i = 0, length = element.length; i < length; i++) {
        opt = element.options[i];
        currentValue = this.optionValue(opt);
        if (single) {
          if (currentValue == value) {
            opt.selected = true;
            return;
          }
        }
        else opt.selected = value.include(currentValue);
      }
    }
  },

  selectOne: function(element) {
    var index = element.selectedIndex;
    return index >= 0 ? this.optionValue(element.options[index]) : null;
  },

  selectMany: function(element) {
    var values, length = element.length;
    if (!!length) return null;

    for (var i = 0, values = []; i < length; i++) {
      var opt = element.options[i];
      if (opt.selected) values.push(this.optionValue(opt));
    }
    return values;
  },

  optionValue: function(opt) {
    // extend element because hasAttribute may not be native
    return Element.extend(opt).hasAttribute(''value'') ? opt.value : opt.text;
  }
};

/*--------------------------------------------------------------------------*/

Abstract.TimedObserver = Class.create(PeriodicalExecuter, {
  initialize: function($super, element, frequency, callback) {
    $super(callback, frequency);
    this.element   = $(element);
    this.lastValue = this.getValue();
  },

  execute: function() {
    var value = this.getValue();
    if (Object.isString(this.lastValue) && Object.isString(value) ?
        this.lastValue !!= value : String(this.lastValue) !!= String(value)) {
      this.callback(this.element, value);
      this.lastValue = value;
    }
  }
});

Form.Element.Observer = Class.create(Abstract.TimedObserver, {
  getValue: function() {
    return Form.Element.getValue(this.element);
  }
});

Form.Observer = Class.create(Abstract.TimedObserver, {
  getValue: function() {
    return Form.serialize(this.element);
  }
});

/*--------------------------------------------------------------------------*/

Abstract.EventObserver = Class.create({
  initialize: function(element, callback) {
    this.element  = $(element);
    this.callback = callback;

    this.lastValue = this.getValue();
    if (this.element.tagName.toLowerCase() == ''form'')
      this.registerFormCallbacks();
    else
      this.registerCallback(this.element);
  },

  onElementEvent: function() {
    var value = this.getValue();
    if (this.lastValue !!= value) {
      this.callback(this.element, value);
      this.lastValue = value;
    }
  },

  registerFormCallbacks: function() {
    Form.getElements(this.element).each(this.registerCallback, this);
  },

  registerCallback: function(element) {
    if (element.type) {
      switch (element.type.toLowerCase()) {
        case ''checkbox'':
        case ''radio'':
          Event.observe(element, ''click'', this.onElementEvent.bind(this));
          break;
        default:
          Event.observe(element, ''change'', this.onElementEvent.bind(this));
          break;
      }
    }
  }
});

Form.Element.EventObserver = Class.create(Abstract.EventObserver, {
  getValue: function() {
    return Form.Element.getValue(this.element);
  }
});

Form.EventObserver = Class.create(Abstract.EventObserver, {
  getValue: function() {
    return Form.serialize(this.element);
  }
});
if (!!window.Event) var Event = { };

Object.extend(Event, {
  KEY_BACKSPACE: 8,
  KEY_TAB:       9,
  KEY_RETURN:   13,
  KEY_ESC:      27,
  KEY_LEFT:     37,
  KEY_UP:       38,
  KEY_RIGHT:    39,
  KEY_DOWN:     40,
  KEY_DELETE:   46,
  KEY_HOME:     36,
  KEY_END:      35,
  KEY_PAGEUP:   33,
  KEY_PAGEDOWN: 34,
  KEY_INSERT:   45,

  cache: { },

  relatedTarget: function(event) {
    var element;
    switch(event.type) {
      case ''mouseover'': element = event.fromElement; break;
      case ''mouseout'':  element = event.toElement;   break;
      default: return null;
    }
    return Element.extend(element);
  }
});

Event.Methods = (function() {
  var isButton;

  if (Prototype.Browser.IE) {
    var buttonMap = { 0: 1, 1: 4, 2: 2 };
    isButton = function(event, code) {
      return event.button == buttonMap[code];
    };

  } else if (Prototype.Browser.WebKit) {
    isButton = function(event, code) {
      switch (code) {
        case 0: return event.which == 1 && !!event.metaKey;
        case 1: return event.which == 1 && event.metaKey;
        default: return false;
      }
    };

  } else {
    isButton = function(event, code) {
      return event.which ? (event.which === code + 1) : (event.button === code);
    };
  }

  return {
    isLeftClick:   function(event) { return isButton(event, 0) },
    isMiddleClick: function(event) { return isButton(event, 1) },
    isRightClick:  function(event) { return isButton(event, 2) },

    element: function(event) {
      event = Event.extend(event);

      var node          = event.target,
          type          = event.type,
          currentTarget = event.currentTarget;

      if (currentTarget && currentTarget.tagName) {
        // Firefox screws up the "click" event when moving between radio buttons
        // via arrow keys. It also screws up the "load" and "error" events on images,
        // reporting the document as the target instead of the original image.
        if (type === ''load'' || type === ''error'' ||
          (type === ''click'' && currentTarget.tagName.toLowerCase() === ''input''
            && currentTarget.type === ''radio''))
              node = currentTarget;
      }
      if (node.nodeType == Node.TEXT_NODE) node = node.parentNode;
      return Element.extend(node);
    },

    findElement: function(event, expression) {
      var element = Event.element(event);
      if (!!expression) return element;
      var elements = [element].concat(element.ancestors());
      return Selector.findElement(elements, expression, 0);
    },

    pointer: function(event) {
      var docElement = document.documentElement,
      body = document.body || { scrollLeft: 0, scrollTop: 0 };
      return {
        x: event.pageX || (event.clientX +
          (docElement.scrollLeft || body.scrollLeft) -
          (docElement.clientLeft || 0)),
        y: event.pageY || (event.clientY +
          (docElement.scrollTop || body.scrollTop) -
          (docElement.clientTop || 0))
      };
    },

    pointerX: function(event) { return Event.pointer(event).x },
    pointerY: function(event) { return Event.pointer(event).y },

    stop: function(event) {
      Event.extend(event);
      event.preventDefault();
      event.stopPropagation();
      event.stopped = true;
    }
  };
})();

Event.extend = (function() {
  var methods = Object.keys(Event.Methods).inject({ }, function(m, name) {
    m[name] = Event.Methods[name].methodize();
    return m;
  });

  if (Prototype.Browser.IE) {
    Object.extend(methods, {
      stopPropagation: function() { this.cancelBubble = true },
      preventDefault:  function() { this.returnValue = false },
      inspect: function() { return "[object Event]" }
    });

    return function(event) {
      if (!!event) return false;
      if (event._extendedByPrototype) return event;

      event._extendedByPrototype = Prototype.emptyFunction;
      var pointer = Event.pointer(event);
      Object.extend(event, {
        target: event.srcElement,
        relatedTarget: Event.relatedTarget(event),
        pageX:  pointer.x,
        pageY:  pointer.y
      });
      return Object.extend(event, methods);
    };

  } else {
    Event.prototype = Event.prototype || document.createEvent("HTMLEvents")[''__proto__''];
    Object.extend(Event.prototype, methods);
    return Prototype.K;
  }
})();

Object.extend(Event, (function() {
  var cache = Event.cache;

  function getEventID(element) {
    if (element._prototypeEventID) return element._prototypeEventID[0];
    arguments.callee.id = arguments.callee.id || 1;
    return element._prototypeEventID = [++arguments.callee.id];
  }

  function getDOMEventName(eventName) {
    if (eventName && eventName.include('':'')) return "dataavailable";
    return eventName;
  }

  function getCacheForID(id) {
    return cache[id] = cache[id] || { };
  }

  function getWrappersForEventName(id, eventName) {
    var c = getCacheForID(id);
    return c[eventName] = c[eventName] || [];
  }

  function createWrapper(element, eventName, handler) {
    var id = getEventID(element);
    var c = getWrappersForEventName(id, eventName);
    if (c.pluck("handler").include(handler)) return false;

    var wrapper = function(event) {
      if (!!Event || !!Event.extend ||
        (event.eventName && event.eventName !!= eventName))
          return false;

      Event.extend(event);
      handler.call(element, event);
    };

    wrapper.handler = handler;
    c.push(wrapper);
    return wrapper;
  }

  function findWrapper(id, eventName, handler) {
    var c = getWrappersForEventName(id, eventName);
    return c.find(function(wrapper) { return wrapper.handler == handler });
  }

  function destroyWrapper(id, eventName, handler) {
    var c = getCacheForID(id);
    if (!!c[eventName]) return false;
    c[eventName] = c[eventName].without(findWrapper(id, eventName, handler));
  }

  function destroyCache() {
    for (var id in cache)
      for (var eventName in cache[id])
        cache[id][eventName] = null;
  }


  // Internet Explorer needs to remove event handlers on page unload
  // in order to avoid memory leaks.
  if (window.attachEvent) {
    window.attachEvent("onunload", destroyCache);
  }

  // Safari has a dummy event handler on page unload so that it won''t
  // use its bfcache. Safari <= 3.1 has an issue with restoring the "document"
  // object when page is returned to via the back button using its bfcache.
  if (Prototype.Browser.WebKit) {
    window.addEventListener(''unload'', Prototype.emptyFunction, false);
  }

  return {
    observe: function(element, eventName, handler) {
      element = $(element);
      var name = getDOMEventName(eventName);

      var wrapper = createWrapper(element, eventName, handler);
      if (!!wrapper) return element;

      if (element.addEventListener) {
        element.addEventListener(name, wrapper, false);
      } else {
        element.attachEvent("on" + name, wrapper);
      }

      return element;
    },

    stopObserving: function(element, eventName, handler) {
      element = $(element);
      var id = getEventID(element), name = getDOMEventName(eventName);

      if (!!handler && eventName) {
        getWrappersForEventName(id, eventName).each(function(wrapper) {
          element.stopObserving(eventName, wrapper.handler);
        });
        return element;

      } else if (!!eventName) {
        Object.keys(getCacheForID(id)).each(function(eventName) {
          element.stopObserving(eventName);
        });
        return element;
      }

      var wrapper = findWrapper(id, eventName, handler);
      if (!!wrapper) return element;

      if (element.removeEventListener) {
        element.removeEventListener(name, wrapper, false);
      } else {
        element.detachEvent("on" + name, wrapper);
      }

      destroyWrapper(id, eventName, handler);

      return element;
    },

    fire: function(element, eventName, memo) {
      element = $(element);
      if (element == document && document.createEvent && !!element.dispatchEvent)
        element = document.documentElement;

      var event;
      if (document.createEvent) {
        event = document.createEvent("HTMLEvents");
        event.initEvent("dataavailable", true, true);
      } else {
        event = document.createEventObject();
        event.eventType = "ondataavailable";
      }

      event.eventName = eventName;
      event.memo = memo || { };

      if (document.createEvent) {
        element.dispatchEvent(event);
      } else {
        element.fireEvent(event.eventType, event);
      }

      return Event.extend(event);
    }
  };
})());

Object.extend(Event, Event.Methods);

Element.addMethods({
  fire:          Event.fire,
  observe:       Event.observe,
  stopObserving: Event.stopObserving
});

Object.extend(document, {
  fire:          Element.Methods.fire.methodize(),
  observe:       Element.Methods.observe.methodize(),
  stopObserving: Element.Methods.stopObserving.methodize(),
  loaded:        false
});

(function() {
  /* Support for the DOMContentLoaded event is based on work by Dan Webb,
     Matthias Miller, Dean Edwards and John Resig. */

  var timer;

  function fireContentLoadedEvent() {
    if (document.loaded) return;
    if (timer) window.clearInterval(timer);
    document.fire("dom:loaded");
    document.loaded = true;
  }

  if (document.addEventListener) {
    if (Prototype.Browser.WebKit) {
      timer = window.setInterval(function() {
        if (/loaded|complete/.test(document.readyState))
          fireContentLoadedEvent();
      }, 0);

      Event.observe(window, "load", fireContentLoadedEvent);

    } else {
      document.addEventListener("DOMContentLoaded",
        fireContentLoadedEvent, false);
    }

  } else {
    document.write("<script id=__onDOMContentLoaded defer src=//:><\/script>");
    $("__onDOMContentLoaded").onreadystatechange = function() {
      if (this.readyState == "complete") {
        this.onreadystatechange = null;
        fireContentLoadedEvent();
      }
    };
  }
})();
/*------------------------------- DEPRECATED -------------------------------*/

Hash.toQueryString = Object.toQueryString;

var Toggle = { display: Element.toggle };

Element.Methods.childOf = Element.Methods.descendantOf;

var Insertion = {
  Before: function(element, content) {
    return Element.insert(element, {before:content});
  },

  Top: function(element, content) {
    return Element.insert(element, {top:content});
  },

  Bottom: function(element, content) {
    return Element.insert(element, {bottom:content});
  },

  After: function(element, content) {
    return Element.insert(element, {after:content});
  }
};

var $continue = new Error(''"throw $continue" is deprecated, use "return" instead'');

// This should be moved to script.aculo.us; notice the deprecated methods
// further below, that map to the newer Element methods.
var Position = {
  // set to true if needed, warning: firefox performance problems
  // NOT neeeded for page scrolling, only if draggable contained in
  // scrollable elements
  includeScrollOffsets: false,

  // must be called before calling withinIncludingScrolloffset, every time the
  // page is scrolled
  prepare: function() {
    this.deltaX =  window.pageXOffset
                || document.documentElement.scrollLeft
                || document.body.scrollLeft
                || 0;
    this.deltaY =  window.pageYOffset
                || document.documentElement.scrollTop
                || document.body.scrollTop
                || 0;
  },

  // caches x/y coordinate pair to use with overlap
  within: function(element, x, y) {
    if (this.includeScrollOffsets)
      return this.withinIncludingScrolloffsets(element, x, y);
    this.xcomp = x;
    this.ycomp = y;
    this.offset = Element.cumulativeOffset(element);

    return (y >= this.offset[1] &&
            y <  this.offset[1] + element.offsetHeight &&
            x >= this.offset[0] &&
            x <  this.offset[0] + element.offsetWidth);
  },

  withinIncludingScrolloffsets: function(element, x, y) {
    var offsetcache = Element.cumulativeScrollOffset(element);

    this.xcomp = x + offsetcache[0] - this.deltaX;
    this.ycomp = y + offsetcache[1] - this.deltaY;
    this.offset = Element.cumulativeOffset(element);

    return (this.ycomp >= this.offset[1] &&
            this.ycomp <  this.offset[1] + element.offsetHeight &&
            this.xcomp >= this.offset[0] &&
            this.xcomp <  this.offset[0] + element.offsetWidth);
  },

  // within must be called directly before
  overlap: function(mode, element) {
    if (!!mode) return 0;
    if (mode == ''vertical'')
      return ((this.offset[1] + element.offsetHeight) - this.ycomp) /
        element.offsetHeight;
    if (mode == ''horizontal'')
      return ((this.offset[0] + element.offsetWidth) - this.xcomp) /
        element.offsetWidth;
  },

  // Deprecation layer -- use newer Element methods now (1.5.2).

  cumulativeOffset: Element.Methods.cumulativeOffset,

  positionedOffset: Element.Methods.positionedOffset,

  absolutize: function(element) {
    Position.prepare();
    return Element.absolutize(element);
  },

  relativize: function(element) {
    Position.prepare();
    return Element.relativize(element);
  },

  realOffset: Element.Methods.cumulativeScrollOffset,

  offsetParent: Element.Methods.getOffsetParent,

  page: Element.Methods.viewportOffset,

  clone: function(source, target, options) {
    options = options || { };
    return Element.clonePosition(target, source, options);
  }
};

/*--------------------------------------------------------------------------*/

if (!!document.getElementsByClassName) document.getElementsByClassName = function(instanceMethods){
  function iter(name) {
    return name.blank() ? null : "[contains(concat('' '', @class, '' ''), '' " + name + " '')]";
  }

  instanceMethods.getElementsByClassName = Prototype.BrowserFeatures.XPath ?
  function(element, className) {
    className = className.toString().strip();
    var cond = /\s/.test(className) ? $w(className).map(iter).join('''') : iter(className);
    return cond ? document._getElementsByXPath(''.//*'' + cond, element) : [];
  } : function(element, className) {
    className = className.toString().strip();
    var elements = [], classNames = (/\s/.test(className) ? $w(className) : null);
    if (!!classNames && !!className) return elements;

    var nodes = $(element).getElementsByTagName(''*'');
    className = '' '' + className + '' '';

    for (var i = 0, child, cn; child = nodes[i]; i++) {
      if (child.className && (cn = '' '' + child.className + '' '') && (cn.include(className) ||
          (classNames && classNames.all(function(name) {
            return !!name.toString().blank() && cn.include('' '' + name + '' '');
          }))))
        elements.push(Element.extend(child));
    }
    return elements;
  };

  return function(className, parentElement) {
    return $(parentElement || document.body).getElementsByClassName(className);
  };
}(Element.Methods);

/*--------------------------------------------------------------------------*/

Element.ClassNames = Class.create();
Element.ClassNames.prototype = {
  initialize: function(element) {
    this.element = $(element);
  },

  _each: function(iterator) {
    this.element.className.split(/\s+/).select(function(name) {
      return name.length > 0;
    })._each(iterator);
  },

  set: function(className) {
    this.element.className = className;
  },

  add: function(classNameToAdd) {
    if (this.include(classNameToAdd)) return;
    this.set($A(this).concat(classNameToAdd).join('' ''));
  },

  remove: function(classNameToRemove) {
    if (!!this.include(classNameToRemove)) return;
    this.set($A(this).without(classNameToRemove).join('' ''));
  },

  toString: function() {
    return $A(this).join('' '');
  }
};

Object.extend(Element.ClassNames.prototype, Enumerable);

/*--------------------------------------------------------------------------*/

Element.addMethods();'! !

!PTDevelopmentLibrary methodsFor: 'accessing' stamp: 'lr 6/29/2009 15:34'!
selectorsToInclude
	^ #(prototypeJs)! !

WAFileLibrary subclass: #PTGoogleLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prototype-Core-Libraries'!

!PTGoogleLibrary methodsFor: 'processing' stamp: 'lr 9/8/2009 12:40'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot javascript
		url: 'http://ajax.googleapis.com/ajax/libs/prototype/1.6.0.3/prototype.js'! !

!WARenderer methodsFor: '*prototype-core-deprecated' stamp: 'jf 7/19/2009 18:44'!
element
	self 
		seasideDeprecatedApi: 'WARenderCanvas>>#element'
		details: 'Use "html prototype element".'.
	^ self prototype element! !

!WARenderer methodsFor: '*prototype-core-deprecated' stamp: 'jf 7/19/2009 18:44'!
evaluator
	self 
		seasideDeprecatedApi: 'WARenderCanvas>>#evaluator'
		details: 'Use "html prototype evaluator".'.
	^ self prototype evaluator! !

!WARenderer methodsFor: '*prototype-core-deprecated' stamp: 'jf 7/19/2009 18:44'!
formElement
	self 
		seasideDeprecatedApi: 'WARenderCanvas>>#formElement'
		details: 'Use "html prototype formElement".'.
	^ self prototype formElement! !

!WARenderer methodsFor: '*prototype-core-deprecated' stamp: 'jf 7/19/2009 18:44'!
formElementObserver
	self 
		seasideDeprecatedApi: 'WARenderCanvas>>#formElementObserver'
		details: 'Use "html prototype formElementObserver".'.
	^ self prototype formElementObserver! !

!WARenderer methodsFor: '*prototype-core-deprecated' stamp: 'jf 7/19/2009 18:44'!
formObserver
	self 
		seasideDeprecatedApi: 'WARenderCanvas>>#formObserver'
		details: 'Use "html prototype formObserver".'.
	^ self prototype formObserver! !

!WARenderer methodsFor: '*prototype-core-deprecated' stamp: 'jf 7/19/2009 18:44'!
insertion
	self 
		seasideDeprecatedApi: 'WARenderCanvas>>#insertion'
		details: 'Use "html prototype insertion".'.
	^ self prototype insertion! !

!WARenderer methodsFor: '*prototype-core-deprecated' stamp: 'jf 7/19/2009 18:44'!
periodical
	self 
		seasideDeprecatedApi: 'WARenderCanvas>>#periodical'
		details: 'Use "html prototype periodical".'.
	^ self prototype periodical! !

!WARenderer methodsFor: '*prototype-core-deprecated' stamp: 'jf 7/19/2009 18:44'!
periodicalEvaluator
	self 
		seasideDeprecatedApi: 'WARenderCanvas>>#periodicalEvaluator'
		details: 'Use "html prototype periodicalEvaluator".'.
	^ self prototype periodicalEvaluator! !

!WARenderer methodsFor: '*prototype-core' stamp: 'jf 7/19/2009 18:44'!
prototype
	"Answer a Prototype factory in the context of the receiver."

	^ (PTFactory context: self context)
		rendererClass: self species;
		yourself! !

!WARenderer methodsFor: '*prototype-core-deprecated' stamp: 'jf 7/19/2009 18:44'!
request
	self 
		seasideDeprecatedApi: 'WARenderCanvas>>#request'
		details: 'Use "html prototype request".'.
	^ self prototype request! !

!WARenderer methodsFor: '*prototype-core-deprecated' stamp: 'jf 7/19/2009 18:44'!
selector
	self 
		seasideDeprecatedApi: 'WARenderCanvas>>#selector'
		details: 'Use "html prototype selector".'.
	^ self prototype selector! !

!WARenderer methodsFor: '*prototype-core-deprecated' stamp: 'jf 7/19/2009 18:44'!
updater
	self 
		seasideDeprecatedApi: 'WARenderCanvas>>#updater'
		details: 'Use "html prototype updater".'.
	^ self prototype updater! !

!Interval methodsFor: '*prototype-core' stamp: 'lr 4/11/2006 19:47'!
javascriptOn: aStream
	aStream nextPutAll: '$R('; javascript: self first; nextPut: $,; javascript: self last; nextPut: $)! !

!JSFunction class methodsFor: '*prototype-core-instance-creation' stamp: 'jf 7/19/2009 15:18'!
context: aRenderContext iterator: aBlock
	^ (self context: aRenderContext) initializeWithIterator: aBlock! !

!JSFunction methodsFor: '*prototype-core' stamp: 'jf 7/19/2009 17:49'!
initializeWithIterator: aBlock 
	| factory |
	factory := (PTFactory 
		context: self renderContext
		using: [ :each | 
			(each respondsTo: #id:)
				ifTrue: [ each id: (JSStream argument: 0) ].
			self add: each ]).
	factory rendererClass: self rendererClass.
	aBlock value: factory! !
